package dst.net.droid;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.TextView;

public class AskKilogramSelectAct  extends Activity {
	
	private AndroidOperations _andOP;
	private int _selectedKG;
	private boolean _pressed;

	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        setContentView(R.layout.askkilogram);
        
        _pressed = false;
        _selectedKG = 0;
        final TextView txtNewPrice = (TextView) findViewById(R.id.askKGTxtAmount);
        final Button btnAccept = (Button)findViewById(R.id.askKGBtnAccept);
        final Button btnCancel = (Button) findViewById(R.id.askKGBtnCancel);
        
        btnAccept.setOnClickListener(new OnClickListener() {

   			public void onClick(View v) {

   				if (_pressed)
   					return;
   				
   				_pressed= true;
   				
   				AndroidOperations.hideInputMethod(AskKilogramSelectAct.this, btnAccept);
   				AcceptKG();
   			}
   		});
           
           btnCancel.setOnClickListener(new OnClickListener() {
   			
   			public void onClick(View v) {

   				if (_pressed)
   					return;
   				
   				_pressed= true;
   				
   				AndroidOperations.hideInputMethod(AskKilogramSelectAct.this, btnAccept);
   				setResult(RESULT_CANCELED);
   				finish();
   			}
   		});
           
           _andOP = new AndroidOperations(this);
           _andOP.performClickOnDone(txtNewPrice, btnAccept);
   	}
	
    @Override 
    protected void onResume(){ 
        super.onResume(); 
        
        final TextView txtNewPrice = (TextView) findViewById(R.id.askKGTxtAmount);
        
        txtNewPrice.postDelayed(new Runnable() { 
            public void run() { 
                InputMethodManager keyboard = (InputMethodManager) 
                getSystemService(Context.INPUT_METHOD_SERVICE); 
                keyboard.showSoftInput(txtNewPrice, 0);  
            } 
        },Parameters.KeyboardWait);
    }
    
    private void AcceptKG()
    {
    	final TextView txtNewKG = (TextView) findViewById(R.id.askKGTxtAmount);
    	
    	try 
        {
    		_selectedKG= Integer.valueOf(txtNewKG.getText().toString());
    		
    		MakeChangeKG();
        }
        catch (Exception ex)
        {
        	txtNewKG.setText("");
        	txtNewKG.requestFocus();

            _andOP.ShowMessage(getString(R.string.AskPrice),getString(R.string.AskPriceInvalid));
        }
    
    	_pressed= false;
    }
    
    private void MakeChangeKG()
    {
        Bundle bundle = new Bundle();
        bundle.putInt("newKG", _selectedKG);

        Intent i = new android.content.Intent();
        i.putExtras(bundle);

        setResult(RESULT_OK, i);

        finish();
    }
}
