package dst.net.droid;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.TextView;

public class AskQuantityAct extends Activity {
	
     private TextView _txtNewQty;
     private double _newQty;
     private AndroidOperations _andOP;
     private boolean _pressed;
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
	
        setContentView(R.layout.askquantity);
        
        Bundle extras = getIntent().getExtras();
        _newQty= extras.getDouble("quantity",1);

        _txtNewQty = (TextView) findViewById(R.id.askTxtQty);
        final Button btnAccept = (Button)findViewById(R.id.askbtnAcceptQty);
        final Button btnCancel = (Button) findViewById(R.id.askbtnCancelQty);
        _pressed= false;
        
        _andOP = new AndroidOperations(this);
        _andOP.performClickOnDone(_txtNewQty, btnAccept);
        
        btnAccept.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {
				// TODO Auto-generated method stub
				if (_pressed)
					return;
				
				_pressed = true;
				
				AndroidOperations.hideInputMethod(AskQuantityAct.this, btnAccept);
				
				AcceptQty();
			}
		});
        
        btnCancel.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {

				if (_pressed)
					return;
				
				_pressed = true;
				
				AndroidOperations.hideInputMethod(AskQuantityAct.this, btnAccept);
			
				setResult(RESULT_CANCELED);
				finish();
			}
		});
	}
	
    @Override 
    protected void onResume(){ 
        super.onResume(); 
        
        final TextView txtNewQty = (TextView) findViewById(R.id.askTxtQty);
        _pressed = false;
        
        txtNewQty.postDelayed(new Runnable() { 
            public void run() { 
                InputMethodManager keyboard = (InputMethodManager) 
                getSystemService(Context.INPUT_METHOD_SERVICE); 
                keyboard.showSoftInput(txtNewQty, 0);  
            } 
        },Parameters.KeyboardWait);
    } 
private void AcceptQty()
{
    try 
    {
    	_newQty = new Double(_txtNewQty.getText().toString());
    	
        if (_newQty == 0)
            _newQty = 1;

        MakeChangeQty();
    	
    }
    catch (Exception ex)
    {
        _txtNewQty.setText("");
        _txtNewQty.requestFocus();

        _andOP.ShowMessage(getString(R.string.AskQuantity) ,getString(R.string.AskQuantityInvalid));
    }
    
    _pressed = false;
}
private void MakeChangeQty()
{
    Bundle bundle = new Bundle();
    bundle.putDouble("newQty", _newQty);

    Intent i = new android.content.Intent();
    i.putExtras(bundle);

    setResult(RESULT_OK, i);

    finish();
}
}
