package dst.net.droid;

import java.util.HashMap;
import java.util.Map;
import com.google.gson.Gson;
import dst.net.jsonObj.TableTransfer;
import dst.net.rest.RestClient;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.TextView;

public class AskTableChangeAct  extends Activity {

	private AndroidOperations _andOP;
	private int _tableNumberDest, _tableSubOrderNumberDest, _tableSubOrderDestTariff;
	private boolean _pressed;
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
	
        setContentView(R.layout.asktablechange);
        
        final Button btnAccept = (Button) findViewById(R.id.chgbtnAcceptTable);
        final Button btnCancel = (Button) findViewById(R.id.chgbtnCancelTable);
        final TextView txtTableDest = (TextView) findViewById(R.id.chgTxtTableDes);
        
        _tableSubOrderNumberDest = 0;
        _pressed= false;
        
        AndroidOperations _andOP = new AndroidOperations(AskTableChangeAct.this);
        _andOP.performClickOnDone(txtTableDest, btnAccept);
        
        btnAccept.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				if (_pressed)
					return;
				
				_pressed = true;
				
				MakeTransfer_Step1();  
			}
		});
        
        btnCancel.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {

				if (_pressed)
					return;
				
				_pressed = true;
				
				setResult(RESULT_CANCELED);
	            finish();
			}
		});
        
	}
	
    @Override 
    protected void onResume(){ 
        super.onResume(); 
        
        final TextView txtkeyboard = (TextView) findViewById(R.id.chgTxtTableDes);
        
        txtkeyboard.postDelayed(new Runnable() { 
            public void run() { 
                InputMethodManager keyboard = (InputMethodManager) 
                getSystemService(Context.INPUT_METHOD_SERVICE); 
                keyboard.showSoftInput(txtkeyboard, 0);  
            } 
        },200);
    } 
	private void MakeTransfer_Step1()
	{
		final TextView txtTableDest = (TextView) findViewById(R.id.chgTxtTableDes);
		
         _tableNumberDest = -1;

       try
       {
    	   _tableNumberDest = Integer.valueOf( txtTableDest.getText().toString());
    	   
    	   _andOP = new AndroidOperations(AskTableChangeAct.this);
    	   
           if (_tableNumberDest < 0) // invalid table number
           {
        	   txtTableDest.setText("");
        	   
               _andOP.ShowMessage(getString(R.string.AskTableChange), getString(R.string.AskTableChangeDestInvalid));
           }
           else if (_tableNumberDest == AndroidOperations.CurrentTable) //tabledest= sourceTable
           {
        	   txtTableDest.setText("");
               _andOP.ShowMessage(getString(R.string.AskTableChange), getString(R.string.AskTableChangeDestEqual));
           }
           else
           {
        		RestClient clientRest = new RestClient(Parameters.WcfUrl);
    			Map<String, String> params = new HashMap<String, String>();
    			
    			params.put("deviceid", AndroidOperations.DeviceID);
    			params.put("destTable",String.valueOf(_tableNumberDest));
    	
    			try     
    			{   
    				String response = clientRest.webGet("MakeTransfer/", params);
    				
    				if(response==null || response == "")
    				{
    					AndroidOperations.AppendLog("Restarting from MakeTransfer Step1");
        				
        				setResult(RESULT_FIRST_USER);
        				finish();
    				}
    				
    				TableTransfer resp = new Gson().fromJson(response, TableTransfer.class);
    				
    				if (resp.Result== -1)
    				{
    					_andOP = new AndroidOperations(AskTableChangeAct.this);
    					_andOP.ShowMessage( getString(R.string.AskTableChange), resp.Description);
    				}
    				else
    					CheckTransferResult(resp);
    			}
    			catch (Exception e) {
    				
    				AndroidOperations.AppendLog("MakeTransfer Step1:" + e.getMessage());
    				
    				setResult(RESULT_FIRST_USER);
    				finish();
    			}
           }

       }
       catch(Exception ex) // invalid table number
       {
    	   _pressed= false;
    	   _tableNumberDest = -1;
    	   _andOP.ShowMessage(getString(R.string.AskTableChangeDest), getString(R.string.AskTableChangeDestInvalid));
       }
       
       _pressed= false;
       txtTableDest.setText("");
	}
	
	public int  CheckPermission(TableTransfer result, int action)
	{

		if (result.Result==1 || result.Result==-1)
			return result.Result;
		
		//Show Table Form
        Intent i = new Intent(AskTableChangeAct.this,  RequestAccessPasswordAct.class);
        
        i.putExtra("password", result.Description);
        i.putExtra("action", action);
        
        startActivityForResult(i,2);
        
        return 0;
	}
	
	private void  CheckDestHasLinesAndContinueStep2()
	{
		DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() { 
    		
    		public void onClick(DialogInterface dialog, int which) { 
		        switch (which){ 
		        case DialogInterface.BUTTON_POSITIVE: 
		        	MakeTransfer_Step2(); 
		            break; 
		 
		        case DialogInterface.BUTTON_NEGATIVE: 
		            //No button clicked 
		            break; 
		        } 
		    } 
		}; 
		 
		AlertDialog.Builder builder = new AlertDialog.Builder(AskTableChangeAct.this); 
		builder.setIcon(R.drawable.ic_dialog_icon);
		builder.setCancelable(false);
		builder.setMessage(getString(R.string.AskTableChangeDestLines)).setPositiveButton(getString(R.string.Yes), dialogClickListener) 
		    .setNegativeButton(getString(R.string.No), dialogClickListener).show();
	}
	
	private void CheckTransferResult(TableTransfer resp)
	{
		if (resp.DestHasLines)
		{
			DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() { 
	    		
	    		public void onClick(DialogInterface dialog, int which) { 
			        switch (which){ 
			        case DialogInterface.BUTTON_POSITIVE: 
			        	MakeTransfer_Step2(); 
			            break; 
			 
			        case DialogInterface.BUTTON_NEGATIVE: 
			            //No button clicked 
			            break; 
			        } 
			    } 
			}; 
			 
			AlertDialog.Builder builder = new AlertDialog.Builder(AskTableChangeAct.this); 
			builder.setMessage(R.string.AskTableChangeDestLines).setPositiveButton(R.string.Yes, dialogClickListener) 
			    .setNegativeButton(R.string.No, dialogClickListener).setCancelable(false).show();
		
		}
		else if (resp.CheckPermission)
		{
			switch (CheckPermission(resp, 1))
			{
				case 1: if(resp.DestHasLines)
						CheckDestHasLinesAndContinueStep2();
						else
						MakeTransfer_Step2(); break;
				case -1:
				{
					_andOP = new AndroidOperations(getApplicationContext());
					_andOP.ShowMessage(getString(R.string.AskTableChange),getString(R.string.AccessDenied)); break;
				}
			}
		}
		
		else if (resp.HasSubOrder)
		{
			 //Show Sub Order Forms
            Intent i = new Intent(AskTableChangeAct.this,RequestSubOrderAct.class);
            
            i.putExtra("transfermode", true);
            
            startActivityForResult(i, 1);
		}
		else if (resp.DiffTariff)
		{
			DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() { 
	    		
	    		public void onClick(DialogInterface dialog, int which) { 
			        switch (which){ 
			        case DialogInterface.BUTTON_POSITIVE: 
			        	MakeTransfer_Step4(); 
			            break; 
			 
			        case DialogInterface.BUTTON_NEGATIVE: 
			            //No button clicked 
			            break; 
			        } 
			    } 
			}; 
			 
			AlertDialog.Builder builder = new AlertDialog.Builder(AskTableChangeAct.this); 
			builder.setMessage(R.string.AskTableChangeTariff ).setPositiveButton(R.string.Yes, dialogClickListener) 
			    .setNegativeButton(R.string.No, dialogClickListener).setCancelable(false).show();
		}
		else if (resp.Result ==1)
		{
			setResult(RESULT_OK);
			finish();
		}
	}
	
	private void MakeTransfer_Step2()
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("destTable",String.valueOf(_tableNumberDest));

		try     
		{   
			String response = clientRest.webGet("MakeTransferStep2/", params);
			
			if (response == null || response == "")
			{
				AndroidOperations.AppendLog("Restarting from MakeTransfer Step2");
				
				setResult(RESULT_FIRST_USER);
				finish();
			}
			
			TableTransfer resp = new Gson().fromJson(response, TableTransfer.class);
			
			if (resp.Result== -1)
			{
				_andOP = new AndroidOperations(AskTableChangeAct.this);
				_andOP.ShowMessage(getString(R.string.AskTableChange), resp.Description);
			}
		
			CheckTransferResult(resp);
		}
		catch(Exception ex)
		{
			AndroidOperations.AppendLog("MakeTransfer Step2:" + ex.getMessage());
			
			setResult(RESULT_FIRST_USER);
			finish();
		}
	}
	
	private void MakeTransfer_Step3()
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("destTable",String.valueOf(_tableNumberDest));
		params.put("suborder",String.valueOf(_tableSubOrderNumberDest));
		params.put("tariff",String.valueOf(_tableSubOrderDestTariff));

		try     
		{   
			String response = clientRest.webGet("MakeTransferStep3/", params);
			
			TableTransfer resp = new Gson().fromJson(response, TableTransfer.class);
			
			if (resp.Result== -1)
			{
				_andOP = new AndroidOperations(AskTableChangeAct.this);
				_andOP.ShowMessage(getString(R.string.AskTableChange), resp.Description);
			}
		
			CheckTransferResult(resp);
		}
		catch(Exception ex)
		{
			setResult(RESULT_FIRST_USER);
			finish();

		}
	}
	
	private void MakeTransfer_Step4()
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("destTable",String.valueOf(_tableNumberDest));
		params.put("suborder",String.valueOf(_tableSubOrderNumberDest));

		try     
		{   
			String response = clientRest.webGet("MakeTransferStep4/", params);
			
			TableTransfer resp = new Gson().fromJson(response, TableTransfer.class);
			
			if (resp.Result== -1)
			{
				_andOP = new AndroidOperations(AskTableChangeAct.this);
				_andOP.ShowMessage(getString(R.string.AskTableChange), resp.Description);
			}
		
			CheckTransferResult(resp);
		}
		catch(Exception ex)
		{
			setResult(RESULT_FIRST_USER);
			finish();

		}
	}
	
	public void onActivityResult(int requestCode, int resultCode, Intent intent) { 
        
		if (resultCode== RESULT_FIRST_USER)
    	{
			AndroidOperations.AppendLog("BackToMain FROM:" + this.toString());
			
    		setResult(RESULT_FIRST_USER);
    		finish();
    		return;
    	}
		
		if (requestCode == 1) 	
        { 
        	if (resultCode == RESULT_OK)
            {
        		 Bundle extras = intent.getExtras();
                 
                 int mode = extras.getInt("newsuborder", 0);
                 int subOrder = extras.getInt("resultSubOrder", 0);
                 int tariff = extras.getInt("resultTariff", 0);
                 int nextsuborder = extras.getInt("nextsuborder", 1);

                 if (mode==0)
                 {
                	 _tableSubOrderNumberDest = subOrder;
                	 _tableSubOrderDestTariff = tariff;
                 }
                 else
                 {
                	 _tableSubOrderNumberDest = nextsuborder;
                	 _tableSubOrderDestTariff = AndroidOperations.CurrentTableTariff;
                 }
                 
                 MakeTransfer_Step3();
            }
        }
		if (requestCode == 2)  //Permission Result 	
        { 
        		if (resultCode == RESULT_OK)
            	{
            		Bundle extras = intent.getExtras();
                    
                    int action = extras.getInt("action", 0);
            		
                    if (action==1)
                    	CheckDestHasLinesAndContinueStep2();
            	}
        }
		
		_pressed= false;
    }
}
