package dst.net.droid;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.TextView;

public class AskTableNameAct extends Activity {
	
	private boolean _pressed;
	
	 public void onCreate(Bundle savedInstanceState) {
	        super.onCreate(savedInstanceState);

	        setContentView(R.layout.asktablename);
	        
	        if (Parameters.VerticalMode)
	          	 setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
	        
	        _pressed = false;
	        final Button btnBack =(Button) findViewById(R.id.buttonBackTableName); 
	        final Button btnOK =(Button) findViewById(R.id.buttonAcceptTableName);
	        final TextView texts =(TextView) findViewById(R.id.textTableName);
	        
	        if (AndroidOperations.TableName!= "")
	        {	
	        	texts.setText(AndroidOperations.TableName);
	        	texts.setSelectAllOnFocus(true);
	        }
	        
	        AndroidOperations _andOP = new AndroidOperations(AskTableNameAct.this);
	        _andOP.performClickOnDone(texts, btnOK);
	        
            btnBack.setOnClickListener(new OnClickListener() {
				
				public void onClick(View v) {

					if (_pressed)
						return;
							
					_pressed= true;
					
					AndroidOperations.hideInputMethod(AskTableNameAct.this, v);
					CancelTableName();
				}
			});
            
            btnOK.setOnClickListener(new OnClickListener() {
				
            public void onClick(View v) {
					
					if (_pressed)
						return;
							
					_pressed= true;
					
					AndroidOperations.hideInputMethod(AskTableNameAct.this, v);
					GetTableName();
				}
		
            });
            
            AndroidOperations.showInputMethod(AskTableNameAct.this, texts);
	 }
	 
	    protected void onResume(){ 
	        super.onResume(); 
	        
	        final TextView txtkeyboard = (TextView) findViewById(R.id.textTableName);
	        
	        txtkeyboard.postDelayed(new Runnable() { 
	            public void run() { 
	                InputMethodManager keyboard = (InputMethodManager) 
	                getSystemService(Context.INPUT_METHOD_SERVICE); 
	                keyboard.showSoftInput(txtkeyboard, 0);  
	            } 
	        },200);
	    } 
	 
	 private void CancelTableName()
	 {
		 Bundle bundle = new Bundle();
         
		    bundle.putString("tablename", "");

		    Intent i = new Intent();

		    i.putExtras(bundle);
		    setResult(RESULT_CANCELED, i);
		    finish();
	 }
	 
	 @Override 
	 public void onBackPressed() 
	 { 
		 CancelTableName();
	 }
	 
	 private void GetTableName()
	 {
		 final TextView texts =(TextView) findViewById(R.id.textTableName);
		 
		 try
		 {
			 String  tableName = texts.getText().toString();

			 /*if (tableName.length()==0)
			 {
				 
				 AndroidOperations andOP = new AndroidOperations(this);
	             andOP.ShowMessage(getString(R.string.AskTableNameTitle),getString( R.string.AskTableNameError));
	             
	             AndroidOperations.showInputMethod(AskTableNameAct.this, texts);
	             _pressed = false;
	             return;
			 }*/
			 
			 Bundle bundle = new Bundle();
             
			    bundle.putString("tablename", tableName);

			    Intent i = new Intent();

			    i.putExtras(bundle);
			    setResult(RESULT_OK, i);
			    finish();
		 }
         catch(Exception ex)
         {
             AndroidOperations andOP = new AndroidOperations(this);
             andOP.ShowMessage(getString(R.string.AskTableNameTitle),getString( R.string.AskTableNameError));
         }
		 
		 _pressed = false;
	 }
}
