package dst.net.droid;


import java.io.ByteArrayOutputStream;
import java.util.ArrayList;
import java.util.List;


import android.app.Activity;
import android.content.Context;
import android.content.pm.ActivityInfo;
import android.graphics.*;
import android.graphics.Bitmap.CompressFormat;
import android.os.Bundle;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.LinearLayout;

public class FaxPrinterAct extends Activity {

	private WcfOperations _wcf;
	private CheckBox _chk1, _chk2,_chk3,_chk4,_chk5;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) { 
		super.onCreate(savedInstanceState);        

		setContentView(R.layout.faxprinter);
		
		if (Parameters.VerticalMode)
       	 setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
		
		final LinearLayout ly = (LinearLayout) findViewById(R.id.FaxPaintLayout);
		final Button btAll = (Button) findViewById(R.id.btFaxAll);
		final Button btNone = (Button) findViewById(R.id.btFaxNothing);
		final Button btClear = (Button) findViewById(R.id.btFaxClear);
		final Button btCancel = (Button) findViewById(R.id.btFaxCancel);
		final Button btAccept = (Button) findViewById(R.id.btFaxAccept);
		
		btAccept.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				SendFax();
			}
		});
		
		btCancel.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				setResult(RESULT_CANCELED);
				finish();
			}
		});
		
		btClear.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				MyView mv = (MyView) ly.getChildAt(0);
				mv.ClearDraw();
				
				mv.requestLayout();
				mv.invalidate();
			}
		});
		
		btAll.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				SetAll();
			}
		});
		
		btNone.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				SetNothing();
			}
		});
		
		ly.addView(new MyView(this));
		
		
		
		
		mPaint = new Paint();
        mPaint.setAntiAlias(true);
        mPaint.setDither(true);
        mPaint.setColor(0xFF000000);
        mPaint.setStyle(Paint.Style.STROKE);
        mPaint.setStrokeJoin(Paint.Join.ROUND);
        mPaint.setStrokeCap(Paint.Cap.ROUND);
        mPaint.setStrokeWidth(3);

        _wcf = new WcfOperations();
        
        SetChecks();
        
        FillPrinters();
	}

        private Paint mPaint;

        public void colorChanged(int color) {
        	mPaint.setColor(color);
        }

        public class MyView extends View
        {
	        private Bitmap mBitmap;
	        private Canvas mCanvas;
	        private Path mPath;
	        private Paint mBitmapPaint;
	
	        public MyView(Context c) {
	        super(c);
	
		        mPath = new Path();
		        mBitmapPaint = new Paint(Paint.DITHER_FLAG);
		        
		        
		        
	        }

	        @Override
	        protected void onSizeChanged(int w, int h, int oldw, int oldh)
	        {
		        super.onSizeChanged(w, h, oldw, oldh);
		        mBitmap = Bitmap.createBitmap(w, h, Bitmap.Config.RGB_565);
		        
		        Paint paint = new Paint();
		        Canvas canvas = new Canvas(mBitmap); 
		        
				paint.setStyle(Paint.Style.FILL);
				
				RectF rect = new RectF(0,0,w, h);   
				paint.setAntiAlias(true);
				paint.setColor(Color.WHITE);
				canvas.drawRect(rect, paint); 
		        
		        
		        //mBitmap = Bitmap.createBitmap(200, 200, Bitmap.Config.ARGB_8888);
		        mCanvas = new Canvas(mBitmap);
	        }

	        @Override
	        protected void onDraw(Canvas canvas)
	        {
		        canvas.drawColor(0xFFFFFFFF);
		
		        canvas.drawBitmap(mBitmap, 0, 0, mBitmapPaint);
		
		        canvas.drawPath(mPath, mPaint);
	        }

	        private float mX, mY;
	        private static final float TOUCH_TOLERANCE = 4;
	
	        private void touch_start(float x, float y) {
		        mPath.reset();
		        mPath.moveTo(x, y);
		        mX = x;
		        mY = y;
	        }
	        
	        private void touch_move(float x, float y) 
	        {
		        float dx = Math.abs(x - mX);
		        float dy = Math.abs(y - mY);
		        if (dx >= TOUCH_TOLERANCE || dy >= TOUCH_TOLERANCE) {
		        mPath.quadTo(mX, mY, (x + mX)/2, (y + mY)/2);
		        mX = x;
		        mY = y;
	        }
        }
	        
	        private void touch_up() {
		        mPath.lineTo(mX, mY);
		        // commit the path to our offscreen
		        mCanvas.drawPath(mPath, mPaint);
		        // kill this so we don't double draw
		        mPath.reset();
	        }

	        @Override
        	public boolean onTouchEvent(MotionEvent event) {
		        float x = event.getX();
		        float y = event.getY();
		
		        switch (event.getAction()) {
			        case MotionEvent.ACTION_DOWN:
			        touch_start(x, y);
			        invalidate();
			        break;
			        case MotionEvent.ACTION_MOVE:
			        touch_move(x, y);
			        invalidate();
			        break;
			        case MotionEvent.ACTION_UP:
			        touch_up();
			        invalidate();
			        break;
		        }
		       return true;
	        }
        
	        public void ClearDraw()
	        {
	        	int width = mBitmap.getWidth();
	        	int height = mBitmap.getHeight();

	        	mBitmap = Bitmap.createBitmap(width, height, Bitmap.Config.RGB_565); 
	        	
	        	 Paint paint = new Paint();
			        Canvas canvas = new Canvas(mBitmap); 
			        
					paint.setStyle(Paint.Style.FILL);
					
					RectF rect = new RectF(0,0,width, height);   
					paint.setAntiAlias(true);
					paint.setColor(Color.WHITE);
					canvas.drawRect(rect, paint); 
	        	
	        	
	        	mCanvas = new Canvas(mBitmap);
	        	
	        }
	        
	        public Bitmap ReturnBitmap()
	        {
	        	return mBitmap;
	        }
        
        }

        private void FillPrinters()
    	{
    		try
    		{
    			List<String> lst =  _wcf.GetFaxPrinters();
    			
    			for (int i=0; i< lst.size(); i++)
    			{
    				String printer = lst.get(i);
    				
    				CheckBox chk = GetCheckBox(i+1);
    				
    				chk.setChecked(false);
    				
    				if (printer.length()>0)
    				{
    					chk.setText(printer);
    					chk.setTag(i+1);
    				}
    				else
    				{
    					chk.setVisibility(View.INVISIBLE);
    				}
    			}
    		}
    		catch (Exception e) 
    		{
    			setResult(RESULT_FIRST_USER);
    			finish();
    		}
    	}

    	private CheckBox GetCheckBox(int valueBox)
    	{
    		switch (valueBox)
    		{
    			case 1: return _chk1;
    			case 2: return _chk2;
    			case 3: return _chk3;
    			case 4: return _chk4;
    			case 5: return _chk5;
    			
    			default: return _chk1;
    		}
    	}
    	
    	private void SetAll()
    	{
    		if (_chk1.isShown())
    			_chk1.setChecked(true);
    		
    		if (_chk2.isShown())
    			_chk2.setChecked(true);
    		
    		if (_chk3.isShown())
    			_chk3.setChecked(true);
    		
    		if (_chk4.isShown())
    			_chk4.setChecked(true);
    		
    		if (_chk5.isShown())
    			_chk5.setChecked(true);
    	}
    	
    	private void SetNothing()
    	{
    		_chk1.setChecked(false);
    		_chk2.setChecked(false);
    		_chk3.setChecked(false);
    		_chk4.setChecked(false);
    		_chk5.setChecked(false);
    	}
    	
    	private void SetChecks()
    	{
    		_chk1 = (CheckBox) findViewById(R.id.chkKm1);
    		_chk2 = (CheckBox) findViewById(R.id.chkKm2);
    		_chk3 = (CheckBox) findViewById(R.id.chkKm3);
    		_chk4 = (CheckBox) findViewById(R.id.chkKm4);
    		_chk5 = (CheckBox) findViewById(R.id.chkKm5);
    	}
    	
    	private void SendFax()
    	{
    		ArrayList<String> lstPrinetrs = new ArrayList<String>();
			
			for (int i=1; i<6; i++)
			{
				CheckBox z = GetCheckBox(i);
				
				if (z==null)
					continue;
				
				
				if (z.isChecked())
					lstPrinetrs.add(String.valueOf( z.getText()));
			}

			if (lstPrinetrs.size()==0)
			{
				AndroidOperations andOp = new AndroidOperations(FaxPrinterAct.this);
				
				andOp.ShowMessage(getString(R.string.FaxPrinterTitle),getString(R.string.SelectPrinter));
				
				return;
			}
				try
				{
					final LinearLayout ly = (LinearLayout) findViewById(R.id.FaxPaintLayout);
					
					MyView v =(MyView) ly.getChildAt(0);
					
					Bitmap bm = v.ReturnBitmap();
					
					bm = Bitmap.createScaledBitmap(bm,  200, 270, true); 
					
					ByteArrayOutputStream bos = new ByteArrayOutputStream();   
					bm.compress(CompressFormat.PNG,40,bos);   

					_wcf.PrintFaxMessage(lstPrinetrs, dst.net.wcf.Base64.encodeBytes(bos.toByteArray()));
					setResult(RESULT_OK);
					finish();
				}
				catch (Exception e) 
				{
					AndroidOperations.AppendLog("FaxPrinter_send:" + e.getMessage());
					
					setResult(RESULT_FIRST_USER);
					finish();
				}
    	}
}
