package dst.net.droid;

import java.util.ArrayList;

import dst.net.jsonObj.GenericResult;
import android.content.Context;
import android.graphics.Color;
import android.util.TypedValue;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

public class FloorListAdapter extends ArrayAdapter<GenericResult> {
	 
    private ArrayList<GenericResult> items;
    private Context _context;
    private int _selectedPos = -1;
    
    public FloorListAdapter(Context context,  ArrayList<GenericResult> items) {
             super(context, 0, items);
             this.items = items;
             _context = context;
     }

    
    public int getPosition()
    {
    	return _selectedPos;
    }
    
    public int gettSelectedID(){
    	
    	if (_selectedPos>-1)
    	{
    		return items.get(_selectedPos).Result;
    		
    	}
    	else
    		return -1;
	}
    
    
    public void setSelectedPosition(int pos){
    	_selectedPos = pos;
		// inform the view of this change
		notifyDataSetChanged();
	}

    @Override
     public View getView(final int position, View convertView, ViewGroup parent) {
             
    		TextView v;
             
             if (convertView == null) {
            	 v = new TextView(_context);
            	 v.setTextSize(TypedValue.COMPLEX_UNIT_SP, 18);
            	 v.setPadding(0, 5, 0, 5);
             }
             else
            	 v = (TextView) convertView;
             
             GenericResult o = items.get(position);
             
             if (o != null) 
             {
            	 TextView tt = (TextView) v;
                     
            	 if (tt != null) 
            	 {
            		 tt.setText(o.Description);
            		 tt.setTextColor(Color.WHITE);
            	 }
            	 
            	 if(_selectedPos == position)
            		 tt.setBackgroundColor(((SelectTableNumberAct) _context).getResources().getColor(R.color.blueColor));
            	 else
            		 tt.setBackgroundColor(Color.BLACK);
             }
             
             v.setOnClickListener(new OnClickListener() {
				
				public void onClick(View v) {
					// TODO Auto-generated method stub
					// TODO Auto-generated method stub
					setSelectedPosition(position);
					
					((SelectTableNumberAct) _context).LoadTables(true);
				}
			});
             
             return v;
     }
}