package dst.net.droid;

import java.util.ArrayList;
import java.util.List;

import dst.net.jsonObj.FreezeSalesOrderLine;

import android.app.Activity;
import android.content.res.Resources;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;

public class GoCoursesAct extends Activity {

	private List<Integer> _currentDiners;
	private WcfOperations _wcf;
	private Button course1,course2,course3,course4,course5,course6,course7,course8;
	private CheckBox _chkCancel;
	private boolean _pressed;
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
	
        setContentView(R.layout.gocourses);
        
       
        _pressed = false;
        
        _wcf = new WcfOperations();
        
        try
        {
        	_currentDiners = new ArrayList<Integer>();
//        	_currentDiners = _wcf.GetCurrentDiners();
        	
        	for (int i=0; i< AndroidOperations.OrderData.SaleLines.size(); i++)
        	{
        		FreezeSalesOrderLine f = AndroidOperations.OrderData.SaleLines.get(i);
        		
        		if (!_currentDiners.contains(f.CourseNumber))
        			_currentDiners.add(f.CourseNumber);
        	}
        	
        }
        catch (Exception e) {
			setResult(RESULT_FIRST_USER);
			finish();
        }
        
        course1 = (Button) findViewById(R.id.btngcDin1);
    	course2 = (Button) findViewById(R.id.btngcDin2);
    	course3 = (Button) findViewById(R.id.btngcDin3);
    	course4 = (Button) findViewById(R.id.btngcDin4);
    	course5 = (Button) findViewById(R.id.btngcDin5);
    	course6 = (Button) findViewById(R.id.btngcDin6);
    	course7 = (Button) findViewById(R.id.btngcDin7);
    	course8 = (Button) findViewById(R.id.btngcDin8);
    	_chkCancel = (CheckBox) findViewById(R.id.gcChkCancelCourse);
    	
        setCourseNames();
        
        final Button back = (Button) findViewById(R.id.btngcCancel);
        
        back.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				setResult(RESULT_CANCELED);
				finish();
			}
		});
	}
	
    private void setCourseNames()
    {
    	course1.setText(Parameters.ECDinnerPassNames[0]);
    	course2.setText(Parameters.ECDinnerPassNames[1]);
    	course3.setText(Parameters.ECDinnerPassNames[2]);
    	course4.setText(Parameters.ECDinnerPassNames[3]);
    	course5.setText(Parameters.ECDinnerPassNames[4]);
    	course6.setText(Parameters.ECDinnerPassNames[5]);
    	course7.setText(Parameters.ECDinnerPassNames[6]);
    	course8.setText(Parameters.ECDinnerPassNames[7]);
    	
    	if (Parameters.ECDinnerPassNames[0].trim().length()==0)
    		course1.setVisibility(View.INVISIBLE);
    	if (Parameters.ECDinnerPassNames[1].trim().length()==0)
    		course2.setVisibility(View.INVISIBLE);
    	if (Parameters.ECDinnerPassNames[2].trim().length()==0)
    		course3.setVisibility(View.INVISIBLE);
    	if (Parameters.ECDinnerPassNames[3].trim().length()==0)
    		course4.setVisibility(View.INVISIBLE);
    	if (Parameters.ECDinnerPassNames[4].trim().length()==0)
    		course5.setVisibility(View.INVISIBLE);
    	if (Parameters.ECDinnerPassNames[5].trim().length()==0)
    		course6.setVisibility(View.INVISIBLE);
    	if (Parameters.ECDinnerPassNames[6].trim().length()==0)
    		course7.setVisibility(View.INVISIBLE);
    	if (Parameters.ECDinnerPassNames[7].trim().length()==0)
    		course8.setVisibility(View.INVISIBLE);
    	
    	Resources r = getResources();
    	
    	for (int i = 1; i < 9; i++)
        {
    		Button b = GetButton(i);
    		
    		if (b==null)
    			continue;
    		
    		if (!_currentDiners.contains(i))
    		{
    			b.setVisibility(View.INVISIBLE);
    			continue;
    		}

    		if (AndroidOperations.CurrentTableDiner >= i)
    			b.setCompoundDrawablesWithIntrinsicBounds(r.getDrawable(R.drawable.gocourseok), null, null, null);
    		else
    			b.setCompoundDrawablesWithIntrinsicBounds(null, null, null, null);
        }
    	
    	course1.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				// TODO Auto-generated method stub
				SetCourse(1);
			}
		});
    	
		course2.setOnClickListener(new OnClickListener() {
					
					public void onClick(View v) {
						// TODO Auto-generated method stub
						SetCourse(2);
					}
				});
		
		course3.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				// TODO Auto-generated method stub
				SetCourse(3);
			}
		});
		
		course4.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				// TODO Auto-generated method stub
				SetCourse(4);
			}
		});
		
		course5.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				// TODO Auto-generated method stub
				SetCourse(5);
			}
		});
		
		course6.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				// TODO Auto-generated method stub
				SetCourse(6);
			}
		});
		
		course7.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				// TODO Auto-generated method stub
				SetCourse(7);
			}
		});
		
		course8.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				// TODO Auto-generated method stub
				SetCourse(8);
			}
		});
    
    }
    
    private Button GetButton(int button)
    {
    	switch(button)
    	{
    		case 1: return course1;
    		case 2: return course2;
    		case 3: return course3;
    		case 4: return course4;
    		case 5: return course5;
    		case 6: return course6;
    		case 7: return course7;
    		case 8: return course8;
    		
    		default: return null;
    	}
    }
    
	private void SetCourse(int number)
	{
		AndroidOperations.CurrentTableDiner = number;
		
		if (_pressed)
			return;
		
		_pressed = true;
		
		boolean cancelMode = _chkCancel.isChecked();
		
		if (cancelMode)
			AndroidOperations.CurrentTableDiner = GetPreviousDiner(number);
		
		try
		{
		_wcf.SetCurrentDiner(number,cancelMode);
		}
		catch (Exception e) {
				setResult(RESULT_FIRST_USER);
				finish();
		}
		
		setResult(RESULT_OK);
		finish();
	}
	
	private int GetPreviousDiner(int diner )
    {
        int index = _currentDiners.indexOf(diner);

        if (index > 0)
            return _currentDiners.get(index - 1);
        else
            return _currentDiners.get(0);
    }

}
