package dst.net.droid;

import java.util.ArrayList;
import java.util.List;

import dst.net.jsonObj.GenericResult;
import dst.net.jsonObj.GenericResultInt;
import android.app.Activity;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.FrameLayout;
import android.widget.ListView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.TextView;

public class KitchenMessageAct extends Activity {
	
	private Button _btnFree, _btnPred, _btnAll, _btnNothing ;
	private CheckBox _chk1, _chk2,_chk3,_chk4,_chk5,_chk6,_chk7,_chk8;
	private FrameLayout _frmFree, _frmPredet;
	private WcfOperations _wcf;
	private ListView _lstPredefined;
	private PredefinedListAdapter _lstAdapter;
	private TextView _txtText;
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
	
        setContentView(R.layout.kitchenmessage);
        
        if (Parameters.VerticalMode)
       	 setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        
        _wcf = new WcfOperations();
        
        final Button accept= (Button) findViewById(R.id.btKmAccept);
        final Button cancel= (Button) findViewById(R.id.btKmCancel);
        
        _btnFree = (Button) findViewById(R.id.btKmFree);
        _btnPred = (Button) findViewById(R.id.btkmPred);
        _frmFree = (FrameLayout) findViewById(R.id.kmFrmFree);
        _frmPredet = (FrameLayout) findViewById(R.id.kmFrmPredet);
        _lstPredefined = (ListView) findViewById(R.id.lstKmPred);
        _txtText = (TextView) findViewById(R.id.txtKmMessage);
        
        accept.setOnClickListener(new OnClickListener() 
        {
			public void onClick(View v) {
				// TODO Auto-generated method stub
			String message = String.valueOf(_txtText.getText());
				
			ArrayList<String> lstPrinetrs = new ArrayList<String>();
			
			for (int i=1; i<9; i++)
			{
				CheckBox z = GetCheckBox(i);
				
				if (z==null)
					continue;
				
				
				if (z.isChecked())
					lstPrinetrs.add(String.valueOf( z.getText()));
			}
			
			if (lstPrinetrs.size()==0)
			{
				AndroidOperations andOp = new AndroidOperations(KitchenMessageAct.this);
				
				andOp.ShowMessage(getString(R.string.KitchemMessageTitle),getString(R.string.SelectPrinter));
				
				return;
			}
				try
				{
					AndroidOperations.hideInputMethod(KitchenMessageAct.this, _txtText);
					
					GenericResult resp = _wcf.PrintKitchenMessage(lstPrinetrs, message);
					
					if (resp==null)
					{
						AndroidOperations.AppendLog("Restarting from KitchenMessage_accept");
						
						setResult(RESULT_FIRST_USER);
						finish();
					}
					else
					{
						setResult(RESULT_OK);
						finish();
					}
				}
				catch (Exception e) 
				{
					AndroidOperations.AppendLog("KitchenMessage_accept:" + e.getMessage());
					
					setResult(RESULT_FIRST_USER);
					finish();
				}

			}
		});
        
        final ArrayList<String> lstString = GetPredefined();
        
        _lstAdapter = new PredefinedListAdapter(KitchenMessageAct.this, lstString);
        _lstPredefined.setAdapter(_lstAdapter);
        
        _lstPredefined.setOnItemClickListener(new OnItemClickListener() {

			public void onItemClick(AdapterView<?> arg0, View view, int position,
					long id) {
				// TODO Auto-generated method stub
				_lstAdapter.setSelectedPosition(position);
				
				_txtText.setText(_lstAdapter.gettSelectedString());
			}
		});
        
        SetChecks();
        
        _btnAll = (Button) findViewById(R.id.btKmAll);
        _btnNothing = (Button) findViewById(R.id.btKmNothing);
        
        cancel.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				setResult(RESULT_CANCELED);
				finish();
				
			}
		});
        
        _btnFree.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				SetFreeText();
			}
		});
        
        _btnPred.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				SetPredetText();
				
			}
		});
        
        _btnAll.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				SetAll();
			}
		});
        
        _btnNothing.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				SetNothing();
				
			}
		});
        
        FillPrinters();
        
        SetFreeText();
        
        PrepareForm();
	}

	private ArrayList<String> GetPredefined()
	{
		try
		{
			ArrayList<String> alst = new ArrayList<String>();
			
			List<String> lst = _wcf.GetPredefinedList();
		
			for (int i=0; i< lst.size(); i++)
			{
				alst.add(lst.get(i));
			}
			
			return alst;
		}
		catch (Exception e) {
			
			AndroidOperations.AppendLog("KM_GetPredefined:" + e.getMessage());
			
			setResult(RESULT_FIRST_USER);
			finish();
			
			return new ArrayList<String>();
		}
	}
	

	private void FillPrinters()
	{
		try
		{
			List<GenericResultInt> lst =  _wcf.GetPrinters();
			
			for (int i=0; i< lst.size(); i++)
			{
				GenericResultInt printer = lst.get(i);
				
				CheckBox chk = GetCheckBox(printer.Value);
				
				chk.setChecked(false);
				
				if (printer.Description.length()>0)
				{
					chk.setText(printer.Description);
					chk.setTag(printer.Value);
				}
				else
				{
					chk.setVisibility(View.INVISIBLE);
				}
			}
		}
		catch (Exception e) 
		{

		}
	}
	
	private CheckBox GetCheckBox(int valueBox)
	{
		switch (valueBox)
		{
			case 1: return _chk1;
			case 2: return _chk2;
			case 3: return _chk3;
			case 4: return _chk4;
			case 5: return _chk5;
			case 6: return _chk6;
			case 7: return _chk7;
			case 8: return _chk8;
			
			default: return _chk1;
		}
	}
	
	private void SetAll()
	{
		if (_chk1.isShown())
			_chk1.setChecked(true);
		
		if (_chk2.isShown())
			_chk2.setChecked(true);
		
		if (_chk3.isShown())
			_chk3.setChecked(true);
		
		if (_chk4.isShown())
			_chk4.setChecked(true);
		
		if (_chk5.isShown())
			_chk5.setChecked(true);
		
		if (_chk6.isShown())
			_chk6.setChecked(true);
		
		if (_chk7.isShown())
			_chk7.setChecked(true);
		
		if (_chk8.isShown())
			_chk8.setChecked(true);
	}
	
	private void SetNothing()
	{
		_chk1.setChecked(false);
		_chk2.setChecked(false);
		_chk3.setChecked(false);
		_chk4.setChecked(false);
		_chk5.setChecked(false);
		_chk6.setChecked(false);
		_chk7.setChecked(false);
		_chk8.setChecked(false);
	}
	
	private void SetChecks()
	{
		_chk1 = (CheckBox) findViewById(R.id.chkKm1);
		_chk2 = (CheckBox) findViewById(R.id.chkKm2);
		_chk3 = (CheckBox) findViewById(R.id.chkKm3);
		_chk4 = (CheckBox) findViewById(R.id.chkKm4);
		_chk5 = (CheckBox) findViewById(R.id.chkKm5);
		_chk6 = (CheckBox) findViewById(R.id.chkKm6);
		_chk7 = (CheckBox) findViewById(R.id.chkKm7);
		_chk8 = (CheckBox) findViewById(R.id.chkKm8);
	}
	
	private void SetFreeText()
	{
		if (_btnFree.isEnabled())
		{
			AndroidOperations.showInputMethod(KitchenMessageAct.this, _txtText);
			
			_btnFree.setEnabled(false);
			_btnPred.setEnabled(true);
			
			_frmPredet.setVisibility( View.INVISIBLE);
			_frmFree.setVisibility (View.VISIBLE);
		}
	}
	
	private void SetPredetText()
	{
		
		
		if (_btnPred.isEnabled())
		{
			AndroidOperations.hideInputMethod(KitchenMessageAct.this, _txtText);
			
			_btnFree.setEnabled(true);
			_btnPred.setEnabled(false);
			
			_frmFree.setVisibility( View.INVISIBLE);
			_frmPredet.setVisibility (View.VISIBLE);
		}
	}
	
	private void PrepareForm()
	{
		
	}
}
