package dst.net.droid;


import java.io.File;
import java.lang.reflect.Type;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import dst.net.jsonObj.ConfigurationData;
import dst.net.jsonObj.ItemDataNode;
import dst.net.rest.RestClient;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.content.pm.PackageManager.NameNotFoundException;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.Shader;
import android.graphics.drawable.BitmapDrawable;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.os.Handler;
import android.os.Message;
import android.preference.PreferenceManager;
import android.view.Display;
import android.view.Gravity;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;
import android.provider.Settings.Secure;

public class MainActivity extends Activity {
	
	private static int TIMEOUT_INIT = 5000;
	private static int TRY_RECONNECT = 0;
	
	
	private boolean _backPressed;
	private ProgressDialog progressDialog;
	private boolean _loadOK;
	public ProgressDialog PDialog;
	private static Handler _handle;
	private Button _btnStart;
	private Button _btnConfig;
	private TextView _txtState, _txtRecon,_txtVersion;
	private CountDownTimer cdTimer,cdTimerShort;
	private boolean _serialOK, _wrongPassword;
	private int updateWarning;
	private boolean _restartFromFail;
	public int versionCode;
	
	
	class LoadViewTask extends AsyncTask<Void, Integer, Void>
    {
    	//Before running code in separate thread
		@Override
		protected void onPreExecute()
		{
			//Create a new progress dialog
			progressDialog = new ProgressDialog(MainActivity.this);
			//Set the progress dialog to display a horizontal progress bar
			progressDialog.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL);
			//Set the dialog title to 'Loading...'
			progressDialog.setTitle(getString(R.string.LoadingTitle));
			//Set the dialog message to 'Loading application View, please wait...'
			progressDialog.setMessage(getString(R.string.LoadingStep1));
			//This dialog can't be canceled by pressing the back key
			progressDialog.setCancelable(false);
			progressDialog.setIcon(R.drawable.ic_dialog_icon);

			//This dialog isn't indeterminate
			progressDialog.setIndeterminate(false);
			//The maximum number of items is 100
			progressDialog.setMax(100);
			//Set the current progress to zero
			progressDialog.setProgress(0);
			//Display the progress dialog
			progressDialog.show();
			
			AndroidOperations.DeviceID = Secure.getString(getContentResolver(), Secure.ANDROID_ID);;
	        
			Parameters.FileImagePath = getFilesDir().getParent() + "/images/";
		    Parameters.FileImagePathRender = getFilesDir().getParent() + "/imagesrender/";
   		
			
	        _backPressed = false;
	        _loadOK = false;
	        _wrongPassword = false;
	        _txtVersion = (TextView) findViewById(R.id.textViewMainVersion);
	        
   			PackageManager manager = MainActivity.this.getPackageManager();
 	        PackageInfo info;
 	        
 	         versionCode=0;
 			try {
 				info = manager.getPackageInfo(MainActivity.this.getPackageName(), 0);
 				
 				versionCode = info.versionCode;
 				
 				_txtVersion.setTextColor(Color.GREEN);
 				_txtVersion.setText("V." + String.valueOf(versionCode));
 			} catch (NameNotFoundException e) {
 				
 				AndroidOperations.AppendLog("GetVersion:" + e.getMessage());
 				
 				e.printStackTrace();
 			}
		}

		//The code to be executed in a background thread.
		@Override
		protected Void doInBackground(Void... params)
		{
			System.gc();
			//Get the current thread's token
			synchronized (this)
			{
				//Initialize an integer (that will act as a counter) to zero
				int counter = 0;
				//While the counter is smaller than four

				counter=1;
			    publishProgress(counter);
			    
			    if (InitalizeData())
			    {
			    	counter++;
			    	publishProgress(counter);
			    	try
			    	{
			   			 RestClient clientRest = new RestClient(Parameters.WcfUrl,TIMEOUT_INIT );
			   			 Map<String, String> params1 = new HashMap<String, String>();
			   				
			   			 params1.put("deviceid", AndroidOperations.DeviceID);
			   			 params1.put("versionapk", String.valueOf(versionCode));  
			   			 
			   			 String response = clientRest.webGet("StartApplication/", params1); 
			   			 int resp = new Gson().fromJson(response, Integer.class);
			   			
			   			 if (resp==0 )
			   			 {
			   				_serialOK = false;
			   				_loadOK= false;
			   			 }
			   			 else
			   			 {
			   				updateWarning = 0;
			   				
			   				 if (resp==-1) 
			   				 {
			   					updateWarning=-1;
			   					_serialOK = true;
			   					_loadOK= false;
			   					 //Cantscontinue Version old
			   					 
			   				 }
			   				 else //can execute version
			   				 {
				   				 if (resp==2)
				   				 {
				   					updateWarning=1;
				   				 }
			   				 
					   			_handle.sendEmptyMessage(R.string.LoadingStep2);
					   			
					   			WcfOperations wcf =  new WcfOperations(); 
					   			if (!wcf.CheckPassword(TIMEOUT_INIT))
					   			{
					   				_loadOK = false;
					   				_wrongPassword = true;
					   			}
					   			else
					   			{
						   			counter=5;
								    publishProgress(counter);
						   			 
						   			ReadConfFromPos(this,counter);
						   			
						   			_handle.sendEmptyMessage(R.string.LoadingStep3);
						   			counter=20;
								    publishProgress(counter);
			
								    createImagesDir(Parameters.FileImagePath);
								    createImagesDir(Parameters.FileImagePathRender);
						   			 
						   			 //Here count = 20
								    
								    boolean reloadArticles = false;
								    if (AndroidOperations.CacheCleared  || wcf.CheckToLoadImages(TIMEOUT_INIT))
								    {		
								    	reloadArticles = true;
								    		wcf.ReadArticlesImages(this,counter, true,TIMEOUT_INIT);
								    	
								    	_handle.sendEmptyMessage(R.string.LoadingStep4);
							   			counter=65;
									    publishProgress(counter);
								    }
								    
						   			if (Employee.EmployeeImageMap==null || Employee.EmployeeImageMap.size()==0)
						   				wcf.GetEmployeeImages(TIMEOUT_INIT);
						   			

						   			wcf.GetShortCuts(TIMEOUT_INIT);
						   			 
						   			_handle.sendEmptyMessage(R.string.LoadingStep5);
						   			counter+=2;
								    publishProgress(counter);
			
								    if (reloadArticles || Item.GetTotalItems()==0)
								    	LoadArticles(-1, this,counter);
						   			
						   			_handle.sendEmptyMessage(R.string.LoadingStep6);
						   			counter=100;
								    publishProgress(counter);
						   			 
						   			_loadOK =  true;
					   			}
				   			 }
			   			 }
			   		}
			    	catch(Exception ex)
			    	{
			    		_loadOK= false;
			    		updateWarning= 0;
			    	}
			    }
			    else
			    {
			    	_loadOK= false;
			    }
			}
			
			return null;
		}

		//Update the progress
		@Override
		protected void onProgressUpdate(Integer... values)
		{
			//set the current progress of the progress dialog
			progressDialog.setProgress(values[0]);
		}

		//after executing the code in the thread
		@Override
		protected void onPostExecute(Void result)
		{
			//close the progress dialog
			progressDialog.dismiss();
			//initialize the View

			
	        if (_btnStart!= null)
	        	_btnStart.setVisibility(View.VISIBLE);
	        
	        if (_btnConfig!= null)
	        	_btnConfig.setVisibility(View.VISIBLE);
	        
	        
	        if(!_loadOK )
	        {
	        	TRY_RECONNECT++;
	        	
	        	if (_txtState!= null)
	        	{
		        	_txtState.setText(R.string.MainActivityNoConnect);
		        	_txtState.setTextColor(Color.RED);
		        	_txtState.setVisibility(View.VISIBLE);
	        	}
	        	
	        	if (_btnStart!= null)
	        		_btnStart.setEnabled(false);
	        	
	        	if (_wrongPassword)
	        	{
	        		cdTimer.cancel();
	        		cdTimerShort.cancel();
	        		
	        		AndroidOperations andOP = new AndroidOperations(MainActivity.this);
        			andOP.ShowMessage(getString(R.string.Warning),getString(R.string.WrongMasterPWD));
        			_txtRecon.setText("");
	        	}
	        	else if (_serialOK)
	        	{
	        		_txtRecon.setVisibility(View.VISIBLE);

	        		if (updateWarning==-1)
	        		{
	        			cdTimer.cancel();
	        			cdTimerShort.cancel();
	        			
	        			AndroidOperations andOP = new AndroidOperations(MainActivity.this);
	        			andOP.ShowMessage(getString(R.string.Warning),getString(R.string.UpdateRequired));
	        			_txtRecon.setText("");
	        		}
	        		else
	        		{	
	        			if (TRY_RECONNECT<11)
	        				cdTimerShort.start();
	        			else
	        				cdTimer.start();
	        		
	        		
	        		}
	        	}
	        	else
	        	{
	        		cdTimer.cancel();
	        		cdTimerShort.cancel();
	        		_txtRecon.setText("");

	        		AndroidOperations andOP = new AndroidOperations(MainActivity.this);
	        		andOP.ShowMessage(getString(R.string.Warning),getString(R.string.LicenseMax));
	        	}
	        }
	        else
	        {
	        	Parameters.SerialOk = true;
	        	
	        	if (_txtState!= null)
	        	{
		        	_txtState.setText(R.string.MainActivityConnect);
		        	_txtState.setTextColor(Color.GREEN);
		        	_txtState.setVisibility(View.VISIBLE);
	        	}
	        	
	        	if (_btnStart!= null)
	        		_btnStart.setEnabled(true);
	        	
	        	if (_txtRecon!=null)
	        		_txtRecon.setVisibility(View.INVISIBLE);
	        	
	        	if (updateWarning==1)
        		{
        			AndroidOperations andOP = new AndroidOperations(MainActivity.this);
	        		andOP.ShowMessage(getString(R.string.Warning),getString(R.string.UpdateAvailable));
        		}
	        	
	        	TRY_RECONNECT = 0;
	        	
	        	if (_restartFromFail)
		        {
		        	_restartFromFail = false;
		        	
		        	StartEmployee(true);
		        	
		        }
	        }
		}
    
	    public void Update(int counter)
	    {
	    	publishProgress(counter);
	    }
    }
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        
        AndroidOperations.AppendLog("Starting APP");
        
        //GET device ID
        _serialOK = true;
        _restartFromFail = false;
        
        if (_handle==null)
        {
	        _handle = new Handler(){ 
				   @Override
	
				   public void handleMessage(Message msg) {
					   
						   progressDialog.setMessage(getString(msg.what));
					}
				};
        
        }
				
				cdTimer = new CountDownTimer(6000,1000) {
				
				@Override
				public void onTick(long millisUntilFinished) {
					
					_txtRecon.setVisibility(View.VISIBLE);
					_txtRecon.setTextColor(Color.YELLOW);
					_txtRecon.setText(getString(R.string.Reconnect) + " " + String.valueOf(millisUntilFinished/1000));
				}
				
				@Override
				public void onFinish() {
					
					new LoadViewTask().execute();
					
				}
			};
			
			cdTimerShort = new CountDownTimer(1500,1000) {
				
				@Override
				public void onTick(long millisUntilFinished) {
					
					_txtRecon.setVisibility(View.VISIBLE);
					_txtRecon.setTextColor(Color.YELLOW);
					_txtRecon.setText(getString(R.string.Reconnect) + " " + String.valueOf(millisUntilFinished/1000));
				}
				
				@Override
				public void onFinish() {
					
					new LoadViewTask().execute();
					
				}
			};
			
			setContentView(R.layout.main);
	        
			_btnStart = (Button) findViewById(R.id.btnStart);
	        _btnConfig = (Button) findViewById(R.id.btnConfig);
	        _txtState = (TextView) findViewById(R.id.textViewMainState);
	        
	        
	        
			_txtRecon = (TextView) findViewById(R.id.textReconn);
			
	        BitmapDrawable bitmapDrawable = null;
		    Bitmap bmp = BitmapFactory.decodeResource(getResources(), R.drawable.background);
		    
		    try
		    {
		    	Display display = getWindowManager().getDefaultDisplay(); 
			    int width = display.getWidth();
			    int height = display.getHeight();
		    	
		        bitmapDrawable = new BitmapDrawable(Bitmap.createBitmap(bmp, (bmp.getWidth() / 2) - (width / 2),0, width, height));
		    }
		    catch (Exception ex)
		    {
		        bitmapDrawable = new BitmapDrawable(bmp);
		    }  
		    
		    bitmapDrawable.setTileModeXY(Shader.TileMode.REPEAT, Shader.TileMode.REPEAT);
	        LinearLayout layout = (LinearLayout)findViewById(R.id.widgetMain1);
	        layout.setBackgroundDrawable(bitmapDrawable);
	        layout.setGravity(Gravity.CENTER_HORIZONTAL);
	                
	        if (_txtState!=null)
	        	_txtState.setVisibility(View.INVISIBLE);
	        
	        
	        if (_btnStart != null)
	        {
	        	_btnStart.setVisibility(View.INVISIBLE);
	        	_btnStart.setOnClickListener(new OnClickListener() {

				public void onClick(View v) {
					
					_backPressed = false;
					
					
					StartEmployee(false);
					

				}
			});
	        }


	        if (_btnConfig!= null)
	        {
	        	_btnConfig.setVisibility(View.INVISIBLE);
	        	_btnConfig.setOnClickListener(new  OnClickListener() 
	        	{
					public void onClick(View v) {
						
					cdTimer.cancel();
					cdTimerShort.cancel();
					
				    _backPressed = false;
				    
				    Intent i = new Intent(MainActivity.this,  RequestAccessPasswordAct.class);
			        
			        i.putExtra("password", "masterkey");
			        i.putExtra("action", 999);
			        
			        startActivityForResult(i,2);
					}  
				});
	        }			

	        try
	        {
	        	new LoadViewTask().execute();
	        }
	        catch (Exception e) 
	        {
	        	AndroidOperations.AppendLog("LoadViewTask:" + e.getMessage());
	        	
	        	AndroidOperations andOP = new AndroidOperations(MainActivity.this);
	        	
	        	andOP.ShowMessage(getString(R.string.MainActivityInit), getString(R.string.MainActivityErrorInit));
			}
    }
    
    private void StartEmployee(boolean autoLogin)
    {
		WcfOperations wcf = new WcfOperations();
		
		try
		{
			if (wcf.GetCurrentSession()<1)
			{
				AndroidOperations andOP = new AndroidOperations(MainActivity.this);
				
				andOP.ShowMessage(getString(R.string.MainActivityInit), getString(R.string.MainActivitySession));
			}
			else
			{
				Intent i ;
				if (Parameters.TCAccessMode)
				{
					i = new Intent(MainActivity.this, SelectEmployeeAct.class);
				}
				else
				{
					i = new Intent(MainActivity.this, SelectEmployeeListAct.class);
				}
				
				i.putExtra("autologin", autoLogin);
				
				startActivityForResult(i,0);
			}
		}
		catch (Exception e) {
			_loadOK= false;
			new LoadViewTask().execute();    
		}
    }
    
    private void createImagesDir(String aPath)
    {    	
    	File lDir = new File(aPath);    	
    	if(!lDir.exists())
    	{
    		lDir.mkdir();    	
    	}    
    }
    
    private void LoadArticles(int folderNode, LoadViewTask task, int counter)
    {
    	ItemData root = Item.GetFolder(folderNode);
    	
    	for (int i=0; i< root.Nodes.size(); i++)
    	{
    		ItemDataNode article = root.Nodes.get(i);
    		
    		if (task!=null)
    		{
    			counter+=2;
    			task.Update(counter);
    		}
    		
    		if (article.IsFolder)
    		{
    			LoadArticles(article.Number , null, counter);
    		}
    		
    		if (counter==90)
    			counter = 65;
    	}
    }
    
	private boolean  InitalizeData()
	{
		try
		{
			SharedPreferences share = PreferenceManager.getDefaultSharedPreferences(this);
			Parameters.WCFIp = share.getString("ip", "127.0.0.1");
			Parameters.WCFPort = share.getString("port", "8081");
			Parameters.UsePaymentMethods= share.getBoolean("usepaymethods", true);
			Parameters.DontAllowPays= share.getBoolean("dontallowpay", false);
			Parameters.SizeFont = share.getInt("sizefont", 14);
			Parameters.ArticleColumns = share.getInt("columns",4);
			Parameters.Password= share.getString("password","");
			AndroidOperations.CurrentExpanMode = share.getBoolean("expandmode", true);
			Parameters.ShowLineToolBar= share.getBoolean("showlinetoolbar", false);
			Parameters.WcfTimeOut =  share.getInt("timeout", 5000);
			Parameters.VerticalMode = share.getBoolean("vmode", false);
			
			
			Parameters.WcfUrl =  "http://" + Parameters.WCFIp + ":" + Parameters.WCFPort +"/dstwcf/";  //Emulator
			
			return true;
		}
		catch(Exception ex)
		{
			return false;
		}
	}

	@Override 
	public void onBackPressed() { 
	    
		if (progressDialog!= null && progressDialog.isShowing())
			progressDialog.dismiss();
		
		// do something on back. 
	    if (_backPressed)
	    {
	    	 WcfOperations wcf = new WcfOperations();
	    	 
	    	 try
	    	 {
	    		 cdTimer.cancel();
	    		 cdTimerShort.cancel();
	    		 
	    		 wcf.ExitApplication();	
	    		 
	    		 System.exit(0);
	    	 }
	    	 catch (Exception e) 
	    	 {
			
	    	 }
	    	 
	    	super.onBackPressed();
	    }
	    else
	    {
	    	_backPressed = true;
	        Toast.makeText(MainActivity.this,R.string.MainActivityExit, Toast.LENGTH_SHORT).show();
	    }
	} 
	
	private void ReadConfFromPos(LoadViewTask task, int counter)
	{
	    RestClient clientRest = new RestClient(Parameters.WcfUrl,TIMEOUT_INIT);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);  
	
		/********** READ CONFIGRATION PARAMETERS ***************************/
		 String response = clientRest.webGet("ReadConfiguration/", params); 
		 
		if (task!=null)
		{
			counter+=5;
			task.Update(counter);
		}

		 ConfigurationData resp = new Gson().fromJson(response, ConfigurationData.class);
			 
		 Parameters.ECDinnerPassActive = resp.DinnerPassActive;
		 Parameters.TCRequestTableMember = resp.RequestTableMember;
		 Parameters.CurrentCurrencySymbol = resp.CurrencySymbol;
		 Parameters.CurrentCurrencyDecimals = resp.CurrencyDecimals;
		 Parameters.CurrentCashMethod = resp.CurrentCashMethod;
		 Parameters.TCAccessMode = resp.AccesMode;
		 Parameters.TCMenuCourseControl = resp.MenuCourseControl;
		 Parameters.TCMenuConfig = resp.MenuConfig;
		 Parameters.ECDinnerMode = resp.DinnerMode;
		 Parameters.TCRequestTableName = resp.RequestTableName;  //V10
		 
		 /********** READ DINNER PASS NAMES ***************************/
		 RestClient clientRest1 = new RestClient(Parameters.WcfUrl,TIMEOUT_INIT);
		 Map<String, String> params1 = new HashMap<String, String>();
		 
		 params1.put("deviceid", AndroidOperations.DeviceID);  
		 
		 String response1 = clientRest1.webGet("ReadDinnerPassNames/", params1); 

		 Type collectionType = new TypeToken<List<String>>(){}.getType();
		 List<String> resp1 = new Gson().fromJson(response1, collectionType);
			
		 if (task!=null)
			{
				counter+=5;
						task.Update(counter);
			}
		 
		 Iterator<String> i = resp1.iterator();

		 int j=0;
		 while(i.hasNext() && j<8)
		 {
			 String l = (String) i.next();
			 Parameters.ECDinnerPassNames[j] = l;
			 j++;
		 }

		 /** Read Dinerpass is last in menus */
		 response1 = clientRest1.webGet("ReadDinnerPassLastPlaces/", params1); 

		 collectionType = new TypeToken<List<Boolean>>(){}.getType();
		 List<Boolean> resp2 = new Gson().fromJson(response1, collectionType);
			
		 if (task!=null)
			{
				counter+=5;
						task.Update(counter);
			}
		 
		 Iterator<Boolean> k = resp2.iterator();

		 int m=0;
		 while(k.hasNext() && m<8)
		 {
			 boolean l = (boolean) k.next();
			 Parameters.ECDinnerLastPlace[m] = l;
			 m++;
		 }
		 
		 
		 /********** FINISH READ DINNER PASS NAMES ***************************/

		 Parameters.MoneyFormat = new DecimalFormat(Parameters.CurrentCurrencySymbol +  " 0."+ GetZeros(Parameters.CurrentCurrencyDecimals));
		 Parameters.MoneyFormatNoSymbol = new DecimalFormat("0."+ GetZeros(Parameters.CurrentCurrencyDecimals));
		 Parameters.QuantityFormat = new DecimalFormat("0."+ GetZeros(2));
	}

	private String GetZeros(int number)
	{
		String zeros = "";
		
		for (int i=0; i<number; i++)
			zeros+= "0";
		
		return zeros;
	}
	
	public void onActivityResult(int requestCode, int resultCode, Intent intent) { 
		 
		if (resultCode== RESULT_FIRST_USER)
		{
			if (_txtState!= null)
        	{
	        	_txtState.setText(R.string.MainActivityNoConnect);
	        	_txtState.setTextColor(Color.RED);
	        	_txtState.setVisibility(View.VISIBLE);
	        	_restartFromFail = true;
	        	
	        	AndroidOperations.AppendLog("Restarting APP");
	        	
	        	new LoadViewTask().execute();
        	}
		}
		else
		{
			if (requestCode==1)
			{
				if (resultCode== RESULT_OK)
				{
					new LoadViewTask().execute();    
				}
			}
			else if (requestCode==2)
			{
				if (resultCode== RESULT_OK)
				{
					Intent i = new Intent(MainActivity.this, Configuration.class);
					startActivityForResult(i, 1);  
				}
				else
				{
					if (!_loadOK)
					{
						if (TRY_RECONNECT<5)
	        				cdTimerShort.start();
	        			else
	        				cdTimer.start();
					}
				}
			}
				
		}
	}

}
