package dst.net.droid;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Iterator;

import dst.net.jsonObj.FreezeSalesOrderLineOption;
import dst.net.jsonObj.ItemDataNode;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Button;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

public class MultiOptionalAct  extends Activity {
	
	private int _article;
	private double _price;
	private double _totalPrice;
	private int _idLine;
	private String _articleDescription;
	private int _multiOptionals;
	private ArrayList<ItemDataNode> _lines;
	private  ListView listOptions;
	private OptionsSelectedAdapter _adapter;
	private int _piece;
	private boolean _inMenu;
	private int _numFreeOptions;
	
	
	public boolean AcceptArticleClicks;
	private Runnable _runnableDisableGrid;
	private final int WAIT_MILISECONDS_TO_ENABLE = 400;
	private Handler _handler;
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.multioptionals);
        
        Bundle extras = getIntent().getExtras();
        _article= extras.getInt("article",0);
        _price= extras.getDouble("price");
        
        _idLine = extras.getInt("idLine",-1);
        _articleDescription = extras.getString("articleDescription");
        _multiOptionals = extras.getInt("multioptional",1);
        _piece = extras.getInt("piece",-1);
        listOptions = (ListView) findViewById(R.id.multiOptList);
        
        _inMenu= extras.getBoolean("inmenu",false);
        _numFreeOptions = extras.getInt("numfreeoptions",0);
        
        _totalPrice = _price;
        AcceptArticleClicks = true;
       
        _handler = new Handler();
        
        _lines = new ArrayList<ItemDataNode>();
        
       
        if (_idLine== -1)
        	Parameters.OptionsArticle = new ArrayList<FreezeSalesOrderLineOption>();
        else
        {
        	for (int i=0; i< Parameters.OptionsArticle.size(); i++)
        	{
        		ItemDataNode it = new ItemDataNode();
        		
        		it.Number = Parameters.OptionsArticle.get(i).Article;
        		it.TicketText = Parameters.OptionsArticle.get(i).Description;
        		it.SetPrice(AndroidOperations.CurrentTableTariff, Parameters.OptionsArticle.get(i).Price);
        		
        		_lines.add(it);
        	}
        }
        
        final Button cancelButton = (Button) findViewById(R.id.multiOptBtnCancel);
        
        cancelButton.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {

				Parameters.OptionsArticle.clear();
				
				Bundle bundle = new Bundle();
	            bundle.putInt("idLine", _idLine);
	            Intent i = new Intent();
	            i.putExtras(bundle);
				
				setResult(RESULT_CANCELED, i);
				finish();
			}
		});
        
        final TextView txtArticle = (TextView) findViewById(R.id.multiOptTxtArticle);
        txtArticle.setText(_articleDescription);
        
        final GridView gridViewOptions = (GridView) findViewById(R.id.multiOptGridView);
        
        try {

			gridViewOptions.setAdapter(new OptionsAdapter( _article,_idLine, this, _multiOptionals , _piece,_inMenu));
			
		} catch (UnsupportedEncodingException e) {

			AndroidOperations.AppendLog("MultiOptionals_Create:" + e.getMessage());
			
			e.printStackTrace();
		} 
        
        LoadSelectedOptions();
        
        final Button btnDelete = (Button) findViewById(R.id.multiOptBtnDelete);
        btnDelete.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				// TODO Auto-generated method stub
				RemoveLine();
			}
		});
	
        final Button btnAccept = (Button) findViewById(R.id.multiOptBtnOk);
        btnAccept.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {

				Bundle bundle = new Bundle();
		        
	            bundle.putInt("idLine", _idLine);
	            bundle.putString("newdescription", _articleDescription);
	            bundle.putDouble("newPrice", _price);
	            Intent i = new Intent();
	            
	            i.putExtras(bundle);
	            setResult(RESULT_OK, i);
	            finish();
			}
		});

        _runnableDisableGrid = new Runnable()
   	{ 
   		public void run() 
   		{  
    			AcceptArticleClicks = true;
   		}
   	};
        
	}
	
	private void RemoveLine()
	{
		int position = _adapter.getPosition();
		
		if (position>-1)
		{
			boolean preFreeOptions = PendingFreeOptions();
			
			_lines.remove(position);
			
	        Parameters.OptionsArticle.remove(position);
	         
			LoadSelectedOptions();
			
			_adapter.setSelectedPosition(_adapter.getCount()-1);
			_adapter.notifyDataSetChanged();
			listOptions.setSelection(listOptions.getCount()-1); 
			
			WcfOperations wcf = new WcfOperations();
			
			if (preFreeOptions != PendingFreeOptions())
			{
				final GridView gridViewOptions = (GridView) findViewById(R.id.multiOptGridView);
				
				gridViewOptions.requestLayout();
				gridViewOptions.invalidateViews();
				
			}
			
			try
			{
				if (_idLine >-1)
				{
					wcf.OptionAction(position , 2, -1);
					
				}
			}
			catch (Exception e) {
				
				AndroidOperations.AppendLog("MO_RemoveLine:" + e.getMessage());
				
				setResult(RESULT_FIRST_USER);
				finish();
			}
		}
		else
		{
			if (_lines.size()>0)
			{
				AndroidOperations andOP = new AndroidOperations(MultiOptionalAct.this);
				andOP.ShowMessage(getString(R.string.MultiOptional), getString(R.string.MultiOptionalRemoveInvalid));
			}
		}
	}
	
	private void LoadSelectedOptions()
	{
		
		_adapter = new OptionsSelectedAdapter(MultiOptionalAct.this, _article, _lines);
		
		listOptions.setAdapter(_adapter);
		
		listOptions.setOnItemClickListener(new OnItemClickListener() {

			public void onItemClick(AdapterView<?> arg0, View view, int position,
					long id) {
				// TODO Auto-generated method stub
				_adapter.setSelectedPosition(position);
				
			}
		});
		
		UpdatePrice();
	}
	
	private void UpdatePrice()
	{
		_totalPrice = _price;
		final TextView total = (TextView) findViewById(R.id.multiOptTxtTotalPrice);
		
		if (!_inMenu)
		{
			Iterator<ItemDataNode> i = _lines.iterator();
	
			while(i.hasNext())
	    	{
				ItemDataNode l = (ItemDataNode) i.next();
	    		
				_totalPrice+= l.GetCurrentPrice();
	    	}
		}
		
		total.setText(Parameters.MoneyFormatNoSymbol.format(_totalPrice));
	}	

	public void EventDataClick(ItemDataNode idItem, ImageView image)
	{
		if (!AcceptArticleClicks)
    		return;
		
		AcceptArticleClicks = false;

		boolean preFreeOptions = PendingFreeOptions();
		
		AddOptions(idItem);
		
		
		if (preFreeOptions != PendingFreeOptions())
		{
			final GridView gridViewOptions = (GridView) findViewById(R.id.multiOptGridView);
			
			gridViewOptions.requestLayout();
			gridViewOptions.invalidateViews();
			
		}
		ActivateGridDelayed();
		
	}
	
	private void AddOptions (ItemDataNode idItem)
	{
		FreezeSalesOrderLineOption opt = new FreezeSalesOrderLineOption();
		ItemDataNode it = new ItemDataNode();
		
		it.Number = idItem.Number;
		it.TicketText = idItem.TicketText;
		it.SetPrice(AndroidOperations.CurrentTableTariff, idItem.GetCurrentPrice());
		
		opt.Article = idItem.Number;
		opt.Description = idItem.TicketText;
		
		opt.Price = idItem.GetCurrentPrice();
		
		//if (_inMenu)
		//	opt.Price = 0; // Removed by Rafa
		
		
		
		if (_numFreeOptions > Parameters.OptionsArticle.size())
		{
			opt.Price =0;
			
			it.SetPrice(AndroidOperations.CurrentTableTariff,0);
		}
		
		_lines.add(it);
		Parameters.OptionsArticle.add(opt);
		
		
		WcfOperations wcf = new WcfOperations();
		
		try
		{
			_idLine=0;
			if (_idLine >-1)
			{
				int action = 1;
				
				if (_inMenu)
					action = 3;
				
				wcf.OptionAction(_idLine , action, idItem.Number);
			}
		}
		catch (Exception e) {
			
			AndroidOperations.AppendLog("MO_AddOption:" + e.getMessage());
			
			setResult(RESULT_FIRST_USER);
			finish();
		}
		
		LoadSelectedOptions();
		
		_adapter.setSelectedPosition(_adapter.getCount()-1);
		_adapter.notifyDataSetChanged();
		
		listOptions.setSelection(listOptions.getCount()-1); 
	}
	
	public boolean PendingFreeOptions()
	{
		if (_numFreeOptions > Parameters.OptionsArticle.size())
			return true;
		else 
			return false;
	}
	
	public void ActivateGridDelayed()
    {
    	_handler.postDelayed(_runnableDisableGrid, WAIT_MILISECONDS_TO_ENABLE);
    }
}
