package dst.net.droid;

import java.util.ArrayList;

import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.util.TypedValue;
import android.view.Display;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

public class PredefinedListAdapter extends ArrayAdapter<String> {
	 
    private ArrayList<String> items;
    private Context _context;
    private int _selectedPos = -1;
    int _totalWidth;
    
    public PredefinedListAdapter(Context context,  ArrayList<String> items) {
             super(context, 0, items);
             this.items = items;
             _context = context;
             
             Display display = ((Activity) _context).getWindowManager().getDefaultDisplay();  
     		 _totalWidth = display.getWidth();
     }

    
    public int getPosition()
    {
    	return _selectedPos;
    }
    
    public String gettSelectedString(){
    	
    	if (_selectedPos>-1)
    	{
    		return items.get(_selectedPos);
    		
    	}
    	else
    		return "";
	}
    
    
    public void setSelectedPosition(int pos){
    	_selectedPos = pos;
		// inform the view of this change
		notifyDataSetChanged();
	}

    @Override
     public View getView(int position, View convertView, ViewGroup parent) {
             
    		TextView v;

             if (convertView == null) {
            	 v = new TextView(_context);
            	 v.setTextSize(TypedValue.COMPLEX_UNIT_SP, 24);
            	 v.setTextColor(Color.WHITE);
            	 v.setPadding(0, 5, 0, 5);
            	 v.setWidth(_totalWidth);
             }
             else
            	 v = (TextView) convertView;
             
             String o = items.get(position);
             
             if (o != null) 
             {
            	 TextView tt = (TextView) v;
                     
            	 if (tt != null) 
            		 tt.setText(o);                            
            	 
            	 if(_selectedPos == position)
            		 tt.setBackgroundColor(((KitchenMessageAct) _context).getResources().getColor(R.color.blueColor));
            	 else
            		 tt.setBackgroundColor(Color.BLACK);
             }
             
             return v;
     }
}