package dst.net.droid;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;

import dst.net.jsonObj.FreezeSalesOrderLineOption;
import dst.net.jsonObj.ItemDataNode;
import dst.net.jsonObj.Promotion;
import android.app.Activity;
import android.app.ProgressDialog;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

public class PromotionSelectAct extends Activity {
	 
		public ProgressDialog PDialog;
		private Button btnPromo1,btnPromo2,btnPromo3,btnPromo4,btnPromo5,btnPromo6,btnPromo7,btnPromo8;
		private LinearLayout promoLayout;
		int _article;
		private String _articleName;
		WcfOperations _wcf ;
		int _menuID, _piece;
		private int _currentPromo;
		private ImagePromoAdapter _promoAdapter;
		private boolean _fromMenu;
		
		@Override
	    public void onCreate(Bundle savedInstanceState) {
	        super.onCreate(savedInstanceState);
	        
	        setContentView(R.layout.askpromotion);
	        
	        Bundle extras = getIntent().getExtras();
	        
	        _wcf =new WcfOperations();
	        _article= extras.getInt("article",0);
	        _articleName = extras.getString("articlename");
	        _piece= extras.getInt("piece",-1);
	        
	        _fromMenu = extras.getBoolean("fromMenu", false); 
	        _currentPromo = -1;
	        
	        final TextView txtArticle = (TextView)findViewById(R.id.regtxtAdSaleArticle);
	        final Button btnCancel = (Button)findViewById(R.id.regbtnAdSaleCancel);
        
	        btnCancel.setOnClickListener(new OnClickListener() {
				
				public void onClick(View v) {
					setResult(RESULT_CANCELED);
					finish();
				}
			});
	        
	        promoLayout= (LinearLayout) findViewById(R.id.adSaleLinearPromo);
	        btnPromo1 = (Button) promoLayout.getChildAt(0);
	        btnPromo2 = (Button) promoLayout.getChildAt(1);
	        btnPromo3 = (Button) promoLayout.getChildAt(2);
	        btnPromo4 = (Button) promoLayout.getChildAt(3);
	        btnPromo5 = (Button) promoLayout.getChildAt(4);
	        btnPromo6 = (Button) promoLayout.getChildAt(5);
	        btnPromo7 = (Button) promoLayout.getChildAt(6);
	        btnPromo8 = (Button) promoLayout.getChildAt(7);
	        
	       
	        txtArticle.setText(_articleName);
	        
	        try {
	        	 _promoAdapter = new ImagePromoAdapter(_article ,PromotionSelectAct.this);
				 AndroidOperations.CurrentArticlePromos = _promoAdapter.GetAvailablePromos();
				
			} catch (UnsupportedEncodingException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	       
	        SetButtonNames();
	        
	        SetButtonPromoEvents();
	        
	        ActivatePromo(0);
		}
		
		private void SetButtonNames()
		{
			for (int i=0; i<8;i++)
			{
				Button b = (Button) promoLayout.getChildAt(i);
				
				if (AndroidOperations.CurrentArticlePromos.size() > i)
				{
					Promotion p = AndroidOperations.CurrentArticlePromos.get(i);
					
					if (p!=null)
					{
						b.setText(p.Price + "");
					}
					else
					{
						b.setVisibility(View.GONE);
					}
				}
				else
				{
					b.setVisibility(View.GONE);
				}
					
			}
		}
		
		private void SetButtonPromoEvents()
		{
			btnPromo1.setOnClickListener(new OnClickListener() {
				
				public void onClick(View v) {
					
					ActivatePromo(0);
				}
			});
			
			btnPromo2.setOnClickListener(new OnClickListener() {
				
				public void onClick(View v) {
					
					ActivatePromo(1);
				}
			});
			
			btnPromo3.setOnClickListener(new OnClickListener() {
				
				public void onClick(View v) {
					
					ActivatePromo(2);
				}
			});

			btnPromo4.setOnClickListener(new OnClickListener() {

					public void onClick(View v) {
							
							ActivatePromo(3);
						}
					});
			btnPromo5.setOnClickListener(new OnClickListener() {
				
				public void onClick(View v) {
					
					ActivatePromo(4);
				}
			});
			btnPromo6.setOnClickListener(new OnClickListener() {
				
				public void onClick(View v) {

					ActivatePromo(5);

				}
			});
			btnPromo7.setOnClickListener(new OnClickListener() {
				
				public void onClick(View v) {
					
					
					ActivatePromo(6);
					
				}
			});
			btnPromo8.setOnClickListener(new OnClickListener() {
				
				public void onClick(View v) {
					
					ActivatePromo(7);
				}
			});
			
		}

		private void ActivatePromo(int promo)
		{
			if (_currentPromo==promo)
				return;
					
			_currentPromo = promo;
			
			for (int i=0; i< promoLayout.getChildCount();i++)
			{
				Button b = (Button) promoLayout.getChildAt(i);
				
				if (i== _currentPromo)
				{
					b.setEnabled(false);
				}
				else
				{
					b.setEnabled(true);
				}
			}

			GridView gridMenuArt = (GridView)findViewById(R.id.gridviewAdPromoArticles);
	        
			_promoAdapter.ApplyPromofilter(AndroidOperations.CurrentArticlePromos.get(_currentPromo).Number);
			
	        gridMenuArt.setAdapter(_promoAdapter);
		}
		
	    public void EventDataClick(ItemDataNode idItem, ImageView image, int amount, boolean focuseLine) 
	    {
	    	try
	    	{
	    		_wcf.AddFreezeLine(idItem.Number, 1, idItem.GetCurrentPrice(),new ArrayList<Integer>(),new ArrayList<FreezeSalesOrderLineOption>(),-1,-1, "", true, _fromMenu, 0);
	        	
//	    		MakeAddMenuLine(res.Result,idItem,amount,  new ArrayList<Integer>(),new ArrayList<String>(), Parameters.OptionsArticle,focuseLine);
	    		setResult(RESULT_OK);
	       		finish();
	    	}
	    	
	    	catch (Exception e) {
	       		AndroidOperations.AppendLog("EventDataClick:" + e.getMessage());
	       		setResult(RESULT_FIRST_USER);
	       		finish();
				
			}
	    	
	    	
	    }
}
