package dst.net.droid;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import dst.net.jsonObj.PreOrderInfo;
import dst.net.rest.RestClient;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ListView;
import android.widget.AdapterView.OnItemClickListener;

public class RecoverSaleAct extends Activity {

	private RecoverOrderListAdapter _lstAdapter;
	private ListView _lstPredefined;
	private WcfOperations _wcf;
	private int _selectedOrder = -1;
	private int _selectedOrderType = 0;
	private boolean _pressed = false;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) { 
		super.onCreate(savedInstanceState);        

		setContentView(R.layout.recoverorder);
		
		 _wcf = new WcfOperations();
		 
		final Button btCancel = (Button) findViewById(R.id.btroCancel);
		final Button btAccept = (Button) findViewById(R.id.btroAccept);
		
		btAccept.setOnClickListener(new OnClickListener() {
			
		public void onClick(View v) {
				
				if (_pressed)
					return;
				
				_pressed = true;
				
				if ( _lstAdapter.gettSelectedString()!=null)
				{
					PreOrderInfo value = _lstAdapter.gettSelectedString();
					
					Intent i = new Intent(RecoverSaleAct.this, RecoverSalePreviewAct.class);
	
					_selectedOrderType = value.OrderType;
					_selectedOrder = value.TableId2;
					
			        i.putExtra("ordernumber", _selectedOrder);
			        i.putExtra("orderType", _selectedOrderType);
			        
			        startActivityForResult(i, 0);
				}
			}
		});
		
		btCancel.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				if (_pressed)
					return;
				
				_pressed = true;
				setResult(RESULT_CANCELED);
				finish();
			}
		});

		final ArrayList<PreOrderInfo> lstString = GetPreOrders();
		
		_lstPredefined = (ListView) findViewById(R.id.lstroList);
		
		 _lstAdapter = new RecoverOrderListAdapter(RecoverSaleAct.this, lstString);
	        _lstPredefined.setAdapter(_lstAdapter);
	        
	        _lstPredefined.setOnItemClickListener(new OnItemClickListener() {

				public void onItemClick(AdapterView<?> arg0, View view, int position,
						long id) {
					// TODO Auto-generated method stub
					_lstAdapter.setSelectedPosition(position);
					
					//_txtText.setText(_lstAdapter.gettSelectedString());
				}
			});
	}
	
	private ArrayList<PreOrderInfo> GetPreOrders()
	{
		try
		{
			ArrayList<PreOrderInfo> alst = new ArrayList<PreOrderInfo>();
			
			List<PreOrderInfo> lst = _wcf.GetPreorderList();
		
			for (int i=0; i< lst.size(); i++)
			{
				alst.add(lst.get(i));
			}
			
			return alst;
		}
		catch (Exception e) {
			
			AndroidOperations.AppendLog("KM_GetPreorder:" + e.getMessage());
			
			setResult(RESULT_FIRST_USER);
			finish();
			
			return new ArrayList<PreOrderInfo>();
		}
	}
	
	public void onActivityResult(int requestCode, int resultCode, Intent intent) 
	{

		if (resultCode== RESULT_FIRST_USER)
    	{
			AndroidOperations.AppendLog("BackToMain FROM:" + this.toString());
			
    		setResult(RESULT_FIRST_USER);
    		finish();
    		return;
    	}
		
        if (requestCode == 0) 	
        { 
                 if (resultCode == RESULT_OK)
                 {
                	 AddPreOrderToLines(_selectedOrder, _selectedOrderType);
                 }
        }
        
        _pressed = false;
	}
	
	private void AddPreOrderToLines(int tableNumber, int orderType)
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();

		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("tableNumber",String.valueOf(tableNumber));
		params.put("orderType",String.valueOf(orderType));
		
		try     
		{   
			clientRest.webGet("AddPreOrderToLines/", params);
			
			setResult(RESULT_OK);
			finish();
			
		}
		catch (Exception e) 
		{
			AndroidOperations.AppendLog("AddPreOrderToLines:" + e.getMessage());
			
			setResult(RESULT_FIRST_USER);
			finish();
		}	
	}
}
