package dst.net.droid;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import dst.net.jsonObj.FreezeSalesOrderLine;
import dst.net.rest.RestClient;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ListView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.TextView;

public class RecoverSalePreviewAct extends Activity {

	private RecoverSalePreviewAdapter _lstAdapter;
	private ListView _lstOrderPreview;
	private int _ordernumber;
	private int _orderType;
	private boolean _pressed= false;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) { 
		super.onCreate(savedInstanceState);        

		setContentView(R.layout.recoverorderpreview);
		
		Bundle extras = getIntent().getExtras();
		_ordernumber= extras.getInt("ordernumber",1);
		_orderType = extras.getInt("orderType",0);
		
		final Button btCancel = (Button) findViewById(R.id.btroPrvCancel);
		final Button btAccept = (Button) findViewById(R.id.btroPrvAccept);
		final TextView lblTot = (TextView) findViewById(R.id.roTxtTotalAmount);
		
		btAccept.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {

				if (_pressed)
					return;
				
				_pressed = true;
				
				setResult(RESULT_OK);
				finish();
				//andOP.ShowMessage("",value[0].trim());
			}
		});
		
		btCancel.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				if (_pressed)
					return;
				
				_pressed = true;
				
				setResult(RESULT_CANCELED);
				finish();
			}
		});

		
		final ArrayList<FreezeSalesOrderLine> lstLines =  (ArrayList<FreezeSalesOrderLine>) GetPreFreezeOrder(_ordernumber,_orderType);
		
		
		double total = 0;
		
		for (int i=0; i< lstLines.size(); i++)
			total+= lstLines.get(i).GetTotalLine();
		
		
		lblTot.setText(Parameters.MoneyFormat.format(total));
		
		_lstOrderPreview = (ListView) findViewById(R.id.lstroPrvList);
		
		 _lstAdapter = new RecoverSalePreviewAdapter(RecoverSalePreviewAct.this,0,lstLines);
		 _lstOrderPreview.setAdapter(_lstAdapter);
	        
		 _lstOrderPreview.setOnItemClickListener(new OnItemClickListener() {

				public void onItemClick(AdapterView<?> arg0, View view, int position,
						long id) {
					// TODO Auto-generated method stub
					_lstAdapter.setSelectedPosition(position);
					
					//_txtText.setText(_lstAdapter.gettSelectedString());
				}
			});
	}
	
	private List<FreezeSalesOrderLine> GetPreFreezeOrder(int tableNumber, int orderType)
	{
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();

		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("tableNumber",String.valueOf(tableNumber));
		params.put("orderType",String.valueOf(orderType));
		try     
		{   
			String response = clientRest.webGet("GetPreFreezeOrder/", params);
			
			Type collectionType = new TypeToken<List<FreezeSalesOrderLine>>(){}.getType();
			List<FreezeSalesOrderLine> resp = new Gson().fromJson(response, collectionType);
			
			return resp;
			
		}
		catch (Exception e) 
		{
			AndroidOperations.AppendLog("PrepareSalesOrder:" + e.getMessage());
			
			setResult(RESULT_FIRST_USER);
			finish();
			return null;
		}	
	
	}
	
}
