package dst.net.droid;

import dst.net.jsonObj.GenericResult;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.text.InputType;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.TextView;

public class SelectEmployeeAct extends Activity {
	
	private AndroidOperations _andOP;
	private boolean _pressed;
	private  ProgressDialog PDialog;
	private TextView _employeeText;
	private static int CURRENT_EMPLOYEE_PWD;
	
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        setContentView(R.layout.selectemployee);
        
        final Button backButton = (Button)findViewById(R.id.buttonBackEmployee);
        final Button employeeButton = (Button) findViewById(R.id.buttonAcceptEmployee);

        _employeeText = (TextView) findViewById(R.id.textEmployee);
        _andOP= new AndroidOperations(SelectEmployeeAct.this);
        _andOP.performClickOnDone(_employeeText, employeeButton);
        _pressed = false;
        PDialog = new ProgressDialog(SelectEmployeeAct.this);
        PDialog.setMessage(getText(R.string.Processing)); 
		PDialog.setIndeterminate(true);
		PDialog.setCancelable(false);
		PDialog.setIcon(R.drawable.ic_dialog_icon);
		
		
        
        if (backButton != null)
        {
        	backButton.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				onBackPressed();
			}
		});
        }
        
        if (employeeButton != null)
        {
        	employeeButton.setOnClickListener(new OnClickListener() {
			
        		public void onClick(View v) {
				
        			if (_pressed)
        				return;
        			_pressed = true;
        			
        			PDialog.show(); 
        			
        			final TextView employeeText = (TextView) findViewById(R.id.textEmployee);

        			final String employee = employeeText.getText().toString();
        			
        			PDialog.dismiss();
        			if (employee.length()>0)
        			{
        				CURRENT_EMPLOYEE_PWD = Integer.valueOf(employee);
        				 
                			if (CheckValidEmployee(CURRENT_EMPLOYEE_PWD))
        	                {
        	                    //Show Table Form
        	                    Intent i = new Intent(SelectEmployeeAct.this, SelectTableNumberAct.class);
        	                    startActivityForResult(i,0); // Modified by Rafa from startActivity
        	                }
        			}
        			else
        			{
        				_andOP.ShowMessage(getString(R.string.SelectEmployee), getString(R.string.SelectEmployeeInvalid));
        			}

        			
 				   _pressed= false;

        			employeeText.setText("");
			}	
				
        	});
        }
        

        _employeeText.setInputType(InputType.TYPE_CLASS_PHONE); 
        _employeeText.requestFocus();
      
        Bundle extras = getIntent().getExtras();
		boolean _autoLogin = extras.getBoolean("autologin",false);
		
        if (_autoLogin)
        {
        	_autoLogin = false;
        	
        	if (CheckValidEmployee(CURRENT_EMPLOYEE_PWD))
            {
                //Show Table Form
                Intent i = new Intent(SelectEmployeeAct.this, SelectTableNumberAct.class);
                startActivityForResult(i,0); // Modified by Rafa from startActivity
            }
        }
    }
    
    @Override 
    protected void onResume(){ 
        super.onResume(); 
        
        final TextView employeeText = (TextView) findViewById(R.id.textEmployee);
        _pressed = false;
        
        employeeText.postDelayed(new Runnable() { 
            public void run() { 
                InputMethodManager keyboard = (InputMethodManager) 
                getSystemService(Context.INPUT_METHOD_SERVICE); 
                keyboard.showSoftInput(employeeText, 0);
                
                
            } 
        },200);
    } 

	private boolean CheckValidEmployee(int employeePWD) {
		
			WcfOperations wcf = new WcfOperations();
			
			try
			{
				GenericResult resp = wcf.SelectEmployee(employeePWD);
				
				
				PDialog.dismiss();
				
				if (!resp.SerialIdOk)
				{
					setResult(RESULT_FIRST_USER);
					finish();
				}

				if(resp.Result >0)
				{
					AndroidOperations.CurrentEmployee = resp.Result;
					AndroidOperations.CurrentEmployeeName = resp.Description;
					
					return true;
				}
				else
				{
					 _andOP.ShowMessage(getString(R.string.SelectEmployee), resp.Description);
					 return false;
				}
			}
			catch(Exception ex)
			{
				PDialog.dismiss();
				
				AndroidOperations.AppendLog("SE_CheckValidEmployee:" + ex.getMessage());
				
				setResult(RESULT_FIRST_USER);
				finish();
				
				return false;
			}
	}
	
	public void onActivityResult(int requestCode, int resultCode, Intent intent) 
	{ 
		PDialog.dismiss();
		
		if (resultCode== RESULT_FIRST_USER)
    	{
			AndroidOperations.AppendLog("BackToMain FROM:" + this.toString());
    		setResult(RESULT_FIRST_USER);
    		finish();
    		
    	}
		
		_employeeText.postDelayed(new Runnable() { 
            public void run() { 
                InputMethodManager keyboard = (InputMethodManager) 
                getSystemService(Context.INPUT_METHOD_SERVICE); 
                keyboard.showSoftInput(_employeeText, 0);  
            } 
        },200);
        
		_pressed= false;
    }
}
