package dst.net.droid;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Timer;
import java.util.TimerTask;

import com.google.gson.Gson;

import dst.net.jsonObj.GenericResult;
import dst.net.jsonObj.GenericResultInt;
import dst.net.jsonObj.Table;
import dst.net.rest.RestClient;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Resources;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.GridView;
import android.widget.TabHost;
import android.widget.TabHost.OnTabChangeListener;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;


public class SelectTableNumberAct extends Activity {

	private AndroidOperations _andOP;
	private TextView _tableText;
	private boolean _pressed;
	private  ProgressDialog PDialog;
	
	private FloorListAdapter _floorAdapter;
	private TableListAdapter _tableAdapter;
	private List<GenericResult> _lstFloors;
	private List<GenericResultInt> _lstTables;
	private  GridView lstFloors;
	private GridView grdTables;
	private TabHost tabs; 
	private Handler updateTimer;
	private Timer mTimer;
	private boolean firstTime;
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        
       setContentView(R.layout.selecttablenumberhost);
  
       firstTime= true;
        
       tabs = (TabHost)findViewById(R.id.hosttablenumber); 
        
       tabs.setup();
       
       tabs.setOnTabChangedListener(new OnTabChangeListener() {
		
    	   public void onTabChanged(String tabId) {
		
			if (firstTime)
			{
				firstTime= false;
			}
			else
			{
				if (tabs.getCurrentTab()== 0)
				{
					Parameters.TableMode = 0;
					
					launchTask(0,false);
				}
				else if (tabs.getCurrentTab()== 1)
				{
					if (_tableText!=null)
		    			 AndroidOperations.hideInputMethod(SelectTableNumberAct.this, _tableText);
		    		
					Parameters.TableMode = 1;
				}
				
				
				SharedPreferences share = PreferenceManager.getDefaultSharedPreferences(SelectTableNumberAct.this);
				SharedPreferences.Editor editor  = share.edit();
		            
				editor.putInt("tablemode", Parameters.TableMode);
		            
				editor.commit();
		            
				Log.i("***Selected Tab", "Im currently in tab with index::" + tabs.getCurrentTab());

				PrepareData(tabs.getCurrentTab());
			}
				
			
		}
	});
       
        _andOP = new AndroidOperations(SelectTableNumberAct.this);
       
        TabHost.TabSpec spec1 = tabs.newTabSpec("tag1"); 
        Resources res = getResources(); 
        
        spec1.setContent(R.id.tabTableNumberContent); 
        spec1.setIndicator(getString(R.string.TabTableNumber), res.getDrawable(R.drawable.ic_tab_numbers)); 

        tabs.addTab(spec1); 
 
        TabHost.TabSpec spec2 = tabs.newTabSpec("tag2"); 
        spec2.setContent(R.id.tabTableButtonContent); 
        spec2.setIndicator(getString(R.string.TabTableFloor),res.getDrawable(R.drawable.ic_tab_tables)); 
 
        tabs.addTab(spec2); 

        SharedPreferences share = PreferenceManager.getDefaultSharedPreferences(this);
		Parameters.TableMode = share.getInt("tablemode", 0);
		Parameters.Floor = share.getInt("floor", 0);
		
		tabs.setCurrentTab(Parameters.TableMode);

		if (Parameters.TableMode==0)
			PrepareData(0); //Force prepare data for table number
		
        _pressed = false;

        PDialog = new ProgressDialog(SelectTableNumberAct.this);
        PDialog.setMessage(getText(R.string.Processing)); 
        PDialog.setCancelable(false);
        PDialog.setIndeterminate(true); 

    }
    
    @Override 
	public void onBackPressed() { 
	    // do something on back. 
    	launchTask(0,false);
    	
    	if (_tableText!=null)
			AndroidOperations.hideInputMethod(SelectTableNumberAct.this, _tableText);
			 
		
			
		setResult(RESULT_CANCELED);
		finish();
    }
    
    private void PrepareData(int option)
    {
    	if (option==0)  //table Number
    	{
    		final Button backButton = (Button)findViewById(R.id.buttonBackTable);
            final Button tableButton = (Button) findViewById(R.id.buttonAcceptTable);
            
            _tableText = (TextView) findViewById(R.id.textTableNumber);
            
            if (backButton != null)
            {
            	backButton.setOnClickListener(new OnClickListener() {
    			
    			public void onClick(View v) {
    				
    				launchTask(0,false);
    				
    				if (_tableText!=null)
    					AndroidOperations.hideInputMethod(SelectTableNumberAct.this, _tableText);

    				setResult(RESULT_CANCELED);
    				finish();
    			}
            	});
            }
            
            if (tableButton!= null)
            {
            	tableButton.setOnClickListener(new OnClickListener(){
            		
        			public void onClick(View v) {
            			
        				launchTask(0,false);
        				
        				GoToTable(v);
        		}	
           	});
            }
            
            _tableText.postDelayed(new Runnable() { 
                public void run() { 
                    InputMethodManager keyboard = (InputMethodManager) 
                    getSystemService(Context.INPUT_METHOD_SERVICE); 
                    keyboard.showSoftInput(_tableText, 0);  
                } 
            },200);
            
            _andOP.performClickOnDone(_tableText, tableButton);
    	}
    	else if (option==1)
    	{
    		final Button back1Button = (Button) findViewById(R.id.floorTableListCancel);
    		grdTables = (GridView) findViewById(R.id.gridViewTables);
    		
    		 if (back1Button!= null)
    	        {
    	        	back1Button.setOnClickListener(new OnClickListener() {
    	    			
    	    			public void onClick(View v) {
    	    				
    	    				if (_tableText!=null)
    	    					AndroidOperations.hideInputMethod(SelectTableNumberAct.this, _tableText);

    	    				launchTask(0,false);
    	    				setResult(RESULT_CANCELED);
    	    				finish();
    	    			}
    	        	});
    	        }
    		 
    		 lstFloors = (GridView) findViewById(R.id.listViewFloors);
    	        
    		 lstFloors.setOnItemClickListener(new OnItemClickListener() {

    				public void onItemClick(AdapterView<?> arg0, View view, int position,
    						long id) {
    					// TODO Auto-generated method stub
    					_floorAdapter.setSelectedPosition(position);
    					
    					LoadTables(true);
    				}
    			});
    	        
    		 LoadFloors();
    		 
    		 

    		 updateTimer = new Handler() {
    	        	@Override
    	        	public void handleMessage(Message msg) {
    	        		
    	        		if (tabs.getCurrentTab()== 1 && _floorAdapter!=null)
    	        			 LoadTables(false);
    	        			  	
    	        	}
    		 };

    		 if (_floorAdapter.getCount()>0)
    		 {
    			 _floorAdapter.setSelectedPosition(0);
    			 Parameters.Floor = _floorAdapter.gettSelectedID();
    			 
    			 launchTask(0,true);
    		 }
    	}
    	
    }
    
    private void launchTask(int mDelay, boolean start)
    {
        int delay = mDelay; // delay for 1 seconds
        int period = 5000; // repeat every 2minutes

        if (start)
        {
  	      
  	    	  mTimer = new Timer();
  	    	  mTimer.scheduleAtFixedRate(new TimerTask() {
  	    		  
  	    		  public void run() {
  	        	updateTimer.sendEmptyMessage(0);
  	        }
  	      }, delay, period);
        }
        else
        {
        	 try
 	    	  {
        		 if (mTimer!=null)
             		  mTimer.cancel();
 	    	  }
 	    	  catch (Exception e) {
				
 	    	  }
 	    	 
      	 
        }
    }

	private void GoToTable(View v)
	{
		if (_pressed)
			return;
		
		_pressed = true;
		
		if (v!=null)
			AndroidOperations.hideInputMethod(SelectTableNumberAct.this, v);
		
		if (PDialog!=null)
			PDialog.show();
		
		
		GoToTableNumber(_tableText.getText().toString());	
		    	
		_pressed= false;
		    	
		_tableText.setText("");
	}
	
	public void GoToTableFloor(int tableNumber)
	{
		if (_pressed)
			return;
		
		_pressed = true;
				
		launchTask(0,false);
		
		PDialog.show();
		
		GoToTableNumber(String.valueOf(tableNumber));
		
		   
		if (_tableText!=null)
			_tableText.setText("");
	}
    
	private void LoadFloors()
    {
		WcfOperations wcf= new WcfOperations();
    	
		try
		{
			_lstFloors = wcf.GetFloorList();
    	
    	    	
	    	ArrayList<GenericResult> flo = new ArrayList<GenericResult>();
	    	
	    	for (int i=0; i< _lstFloors.size(); i++)
	    	{
	    		flo.add(_lstFloors.get(i));
	    	}
	    	
	    	_floorAdapter = new FloorListAdapter(SelectTableNumberAct.this,flo);
	    	
	    	lstFloors.setAdapter(_floorAdapter);
	    	
	    	_floorAdapter.setSelectedPosition(Parameters.Floor);
	    	
	    	lstFloors.setSelection(Parameters.Floor);
	    	
	    	lstFloors.buildDrawingCache();
    	}
    	catch (Exception e) 
    	{
    		Log.e("LOADFLOORS:", e.getMessage());
    		
    		AndroidOperations.AppendLog("SelectTableN_LoadFloors:" + e.getMessage());
    		
    		launchTask(0, false);
    		
			setResult(RESULT_FIRST_USER);
			finish();
    	}
		
    }
    
    public void LoadTables(boolean restartOnError)
    {
    		WcfOperations wcf= new WcfOperations();
    	
	    	Parameters.Floor = _floorAdapter.getPosition();
	    		
	    	SharedPreferences share = PreferenceManager.getDefaultSharedPreferences(SelectTableNumberAct.this);
			SharedPreferences.Editor editor  = share.edit();
	            
			editor.putInt("floor", Parameters.Floor);
			editor.commit();
	    	
			
			try
			{
				_lstTables = wcf.GetTableList(_floorAdapter.gettSelectedID());
	    	
				
				if (_lstTables==null)
				{
					AndroidOperations.AppendLog("Restarting from SelectTableN_LoadTables:");
		    		
		    		launchTask(0, false);
		    		
		    		if (restartOnError)
		    		{
		    			setResult(RESULT_FIRST_USER);
		    			finish();
		    		}
				}
				else
				{
			    	ArrayList<GenericResultInt> flo = new ArrayList<GenericResultInt>();
			    	
			    	for (int i=0; i< _lstTables.size(); i++)
			    	{
			    		flo.add(_lstTables.get(i));
			    	}
			    	
			    	_tableAdapter = new TableListAdapter(SelectTableNumberAct.this,flo);
			    	
			    	grdTables.setAdapter(_tableAdapter);
			    	grdTables.buildDrawingCache();
				}
	    	}
	    	catch(Exception ex)
	    	{
	    		    		
	    		AndroidOperations.AppendLog("SelectTableN_LoadTables:" + ex.getMessage());
	    		
	    		launchTask(0, false);
	    		
	    		if (restartOnError)
	    		{
	    			setResult(RESULT_FIRST_USER);
	    			finish();
	    		}
	    	}
    }

    private void GoToTableNumber(String tableNumber)
    {
    	try
    	{
    		@SuppressWarnings("unused")
			int	iTableNumber = Integer.valueOf(tableNumber);
    		
    	}
    	catch (Exception e) {
    		
			 PDialog.dismiss();
	    	 _andOP.ShowMessage(  getString(R.string.SelectTableNumber),  getString(R.string.SelectTableNumberInvalid));
	    	 if (Parameters.TableMode==0 && _tableText!= null)
					AndroidOperations.showInputMethod(SelectTableNumberAct.this, _tableText);
	    	 _pressed = false;
				return;
		}    	
    	
    	
		if (tableNumber.length()>0)
		{
			RestClient clientRest = new RestClient(Parameters.WcfUrl);
			Map<String, String> params = new HashMap<String, String>();
			
			params.put("deviceid", AndroidOperations.DeviceID);
			params.put("number",tableNumber);
			
			try     
    		 {   
				 String response = clientRest.webGet("SelectTableToSale/", params);
				 
				 PDialog.dismiss();
				 
				 Table resp = new Gson().fromJson(response, Table.class);
				 
				 if (response ==null || response== "")
				 {
					 AndroidOperations.AppendLog("Restaring from SelectTableN_GotoTableN");
					 
			    	 _pressed = false;

			    	 setResult(RESULT_FIRST_USER);
					 finish(); 
				 
				 }
				 
				 if (!resp.SerialIdOk)
				 {
					 Parameters.SerialOk= false;
					 setResult(RESULT_FIRST_USER);
					 finish();
					 return;	 
				 }
				 
				 if (resp.Number >0)
				 {
					 AndroidOperations.CurrentTable = resp.Number;
					 
					 launchTask(0,false);
					 
					 if (resp.HasSubOrder)
					 {
                         //Show Sub Order Forms
                         Intent i = new Intent(SelectTableNumberAct.this,RequestSubOrderAct.class);
                         
                         i.putExtra("transfermode", false);
                         
                         startActivityForResult(i, 2);
					 }
					 else //Goto To Table Selected
					 {
						 AndroidOperations.CurrentTableTariff = resp.Tariff;
						 AndroidOperations.CurrentTableSubOrder= resp.SubOrder;
						 AndroidOperations.CurrentTableDiner = resp.CurrentTableDiner;
						 
						 Intent i = new Intent(SelectTableNumberAct.this, ShowRegisterAct.class);
							
						 i.putExtra("newsale", resp.NewSale);
						 
						 startActivityForResult(i, 1);
					 }
				 }
			     else
			     {
			    	 PDialog.dismiss();
			    	 _andOP.ShowMessage(  getString(R.string.SelectTableNumber), resp.Description);
			    	 if (Parameters.TableMode==0 && _tableText!= null)
							AndroidOperations.showInputMethod(SelectTableNumberAct.this, _tableText);
			    	 
			    	 _pressed = false;
			     }
    		 }
			 catch (Exception ex)
			 {
				 AndroidOperations.AppendLog("SelectTableN_GotoTableN:" + ex.getMessage());
				 
				 PDialog.dismiss();
		    	 _pressed = false;

		    	 setResult(RESULT_FIRST_USER);
				 finish();
			 }
		}
		else
		{
			PDialog.dismiss();
			_andOP.ShowMessage(getString(R.string.SelectTableNumber), getString(R.string.SelectTableNumberInvalid));
			
			if (Parameters.TableMode==0 && _tableText!= null)
				AndroidOperations.showInputMethod(SelectTableNumberAct.this, _tableText);
			_pressed = false;
		}	
    
    }

    public void onActivityResult(int requestCode, int resultCode, Intent intent) 
    { 
    	if (resultCode== RESULT_FIRST_USER)
    	{
    		launchTask(0,false);
    		
    		AndroidOperations.AppendLog("BackToMain FROM:" + this.toString());
    		
    		setResult(RESULT_FIRST_USER);
    		finish();
    		return;
    	}
    	
    	if (requestCode == 1) 	//Back from Register Form
        { 
            if (resultCode == RESULT_OK)
    		{
            	if (AndroidOperations.CreateNewSubOrderNumber>0)
	            {
	            	 AndroidOperations.CurrentTableSubOrder = AndroidOperations.CreateNewSubOrderNumber;
	            	 AndroidOperations.CreateNewSubOrderNumber = -1;
	            	 Intent i = new Intent(SelectTableNumberAct.this, ShowRegisterAct.class);
	                 
	                 i.putExtra("newsale", true );
	                 
	                 startActivityForResult(i, 1);
	            }
           		 
    		}
            else if (resultCode == RESULT_CANCELED)
            {
            	launchTask(0,false);
            	
            	WcfOperations wcf = new WcfOperations();
            	
            	try
            	{
            		if (!wcf.FreeTableLock())
            		{
            			AndroidOperations.AppendLog("Restarting from SelectTableN_OAR_1_can:");
                		
                		setResult(RESULT_FIRST_USER);
        				finish();
            		}
            			
            	}
            	catch (Exception e) {

            		AndroidOperations.AppendLog("SelectTableN_OAR_1_can:" + e.getMessage());
            		
            		setResult(RESULT_FIRST_USER);
    				finish();
				}	
            	
            }
            else if (resultCode==RESULT_FIRST_USER )
            {
            	launchTask(0,false);
            	
            	setResult(RESULT_FIRST_USER);
            	finish();
            }
			
            
            if (tabs.getCurrentTab()== 1 && resultCode != RESULT_FIRST_USER)
            {
               	launchTask(0,  true);
            }
            else if (_tableText!=null)
            	AndroidOperations.showInputMethod(SelectTableNumberAct.this, _tableText);
            
            
            PDialog.dismiss();
        }
    	
    	else if (requestCode == 2) 	//SubOrder Select Form
        { 
    		AndroidOperations.hideInputMethod(SelectTableNumberAct.this, _tableText);
    		
    		 if (resultCode == RESULT_OK)
             {
                 try
                 {
                     Bundle extras = intent.getExtras();
                     
                     final int mode = extras.getInt("newsuborder", 0);
                     int subOrder = extras.getInt("resultSubOrder", 0);
                     int tariff = extras.getInt("resultTariff", 0);
                     int nextsuborder = extras.getInt("nextsuborder", 1);
                     
                     if (mode == 0) //Exist SubOrder
                     {
                    	 AndroidOperations.CurrentTableSubOrder = subOrder;
                     }
                     else //New SubORder
                     {
                    	 AndroidOperations.CurrentTableSubOrder = nextsuborder;
                     }
                     
                     AndroidOperations.CurrentTableTariff =  (short) tariff; 
     				
                    if (CanSaleTableAndSubOrder(AndroidOperations.CurrentTable, AndroidOperations.CurrentTableSubOrder))
                    {
                    	launchTask(0,false);
                    	
                    	Intent i = new Intent(SelectTableNumberAct.this, ShowRegisterAct.class);
     		                     
                    	i.putExtra("newsale", mode==1 );
     		                     
                    	startActivityForResult(i, 1);
                    }
                    else
                    	PDialog.dismiss();
                 }
                 catch (Exception ex)
                 {
                	 AndroidOperations.AppendLog("SelectTableN_OAR_2_can:" + ex.getMessage());
                	 
                	 setResult(RESULT_FIRST_USER);
                	 finish();
                 }
            }else
            {
            	PDialog.dismiss();
            	
            }
            
        }
    	else
    	{
    		PDialog.dismiss();
    		
    		if (_tableText!=null)
    			AndroidOperations.showInputMethod(SelectTableNumberAct.this, _tableText);
    	}
        
    	_pressed = false;
    	
    	if (_tableText!=null)
    		_tableText.setText("");
        
    } 
    
    private boolean CanSaleTableAndSubOrder( int table, int suborder)
    {
    	RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();
		
		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("number",String.valueOf(table));
		params.put("suborder",String.valueOf(suborder));
		
		 try     
		 {   
			 String response = clientRest.webGet("SelectTableAndSubToSale/", params); 
			 
			 Table resp = new Gson().fromJson(response, Table.class);
			 
			 if (!resp.SerialIdOk)
			 {
				 setResult(RESULT_FIRST_USER);
					finish();
				 return false;	 
			 }
			 
			 if (resp.Number >0)
			 {
				return true;
			 }
		     else
		     {
		    	 _andOP.ShowMessage(getString(R.string.SelectTableNumber), resp.Description);
		    	 
		    	 return false;
		     }
		 }
		 catch (Exception ex)
         {
			 AndroidOperations.AppendLog("SelectTableN_CanSaleTableAnsSubOrder:" + ex.getMessage());
			 
			 setResult(RESULT_FIRST_USER);
			 finish();
	
			 return false;
         }
    }
}