package dst.net.droid;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import dst.net.jsonObj.PayLine;
import dst.net.jsonObj.PaymentMethodLine;
import android.app.Activity;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.util.TypedValue;
import android.view.Gravity;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;

public class ShowPayment extends Activity {
	
	 private AndroidOperations _andOP;
     private Button _btnRemove, _btnCancel, _btnAccept;
     private EditText _txtAmount;
     private TextView _lblOrderTotal, _lblTotalPayed, _lblChange;
     private TableLayout _tablePays;
     private String _currentSelMethod;
     private double _orderTotal, _changeAmount;
     private  ArrayList<PayLine> _tableDataPays;
     private PayMethodsAdapter _adapter;
     private boolean _pressed; 
 	 private CountDownTimer _timerPressed;
 	 
     private ListView _listView;
     
 	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        
        Bundle extras = getIntent().getExtras();  

        _orderTotal= extras.getDouble("orderTotal",0);
        _changeAmount = _orderTotal;
        
        _pressed = false;
        
		_timerPressed = new CountDownTimer(2000, 500) {
			
			@Override
			public void onTick(long millisUntilFinished) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void onFinish() {
				_pressed= false;
				
			}
		};
        
        setContentView(R.layout.showpayment);

        if (getResources().getConfiguration().orientation ==  2)
        	SetLandsCapeMode();
        else
        	SetPortraitMode();
    }
    
    private void SetLandsCapeMode()
    {
    	 final TextView _lblOrderTotal = (TextView)findViewById(R.id.paytxtTotal);
         
         _lblOrderTotal.setText(Parameters.MoneyFormat.format(_orderTotal));
    }
    
    private void SetPortraitMode()
    {
        _lblOrderTotal = (TextView)findViewById(R.id.paytxtTotal);
        _tablePays = (TableLayout)findViewById(R.id.payTablePays);
        _txtAmount = (EditText)findViewById(R.id.payaskTxtPay);
        _lblChange = (TextView) findViewById(R.id.paytxtCHANGE1);
        _lblTotalPayed= (TextView)findViewById(R.id.paytxtPAYS1);
        _btnAccept =(Button) findViewById(R.id.payBtnAccept);
        _btnCancel = (Button)findViewById(R.id.payBtnCancel);
        _btnRemove = (Button)findViewById(R.id.payBtnRemove);
        _listView = (ListView) findViewById(R.id.payMethodlistView);
        
        _tableDataPays = new ArrayList<PayLine>();
        _tableDataPays.clear();
        
        AndroidOperations.hideInputMethod(ShowPayment.this, _txtAmount);
        
        try
        {
        	Wcf_ClearPays();
        }
        catch (Exception e) {
        	
        	AndroidOperations.AppendLog("ShowPayment_SetPortrait:" + e.getMessage());
        	
        	setResult(RESULT_FIRST_USER);
        	finish();
        	return;
		}
        
             
        if (_btnCancel!= null)
        _btnCancel.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				
				if (_pressed)
					return;
				
				_pressed = true;
				
				_timerPressed.start();
				
				setResult(RESULT_CANCELED);

				finish();
			}
		});

        if (_btnRemove!= null)
        _btnRemove.setOnClickListener(new OnClickListener() {
			
			public void onClick(View arg0) {
				
				_tableDataPays.clear();
				
	            _tablePays.removeAllViews();
	            _tablePays.removeAllViewsInLayout();
	            UpdateAmounts();
	            
	            Wcf_ClearPays();
			}
		});
        
       if (_btnAccept!= null)
    	   _btnAccept.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				// TODO Auto-generated method stub
				AcceptPay();
			}
		});
       
        PrepareDataForm();
    }
    
    @Override 
    protected void onResume() 
    { 
        super.onResume(); 
     
        
        if (_txtAmount!= null)
        {
        	AndroidOperations.hideInputMethod(ShowPayment.this, _txtAmount);
        }

    } 

    
    private void Wcf_ClearPays()
    {
    	WcfOperations wcf = new WcfOperations();
    	
    	try
    	{
    		wcf.ClearPays();
    	}
    	catch (Exception e) {
    		
    		AndroidOperations.AppendLog("ShowPayment_ClearPays:" + e.getMessage());
    		
    		setResult(RESULT_FIRST_USER);
			finish();
		}
    }
    
    private void AcceptPay()
    {
    	if (_pressed)
			return;
		
		_pressed = true;
		
		_timerPressed.start();
    	
        double payAmount = 0;
        
        if (_tableDataPays.size()>0)
        {
        	Iterator<PayLine> i = _tableDataPays.iterator();

	    	while(i.hasNext())
	    	{
	    		double amountLine  = (Double) i.next().PayAmount;
	
	    		if (amountLine > 0)
	                payAmount += amountLine;
	    	}
	        
	        if (payAmount < _orderTotal)
	        {
	        	_andOP = new AndroidOperations(ShowPayment.this);
	            _andOP.ShowMessage(getString(R.string.ShowPayment), getString(R.string.ShowPaymentNoEnought));
	        }
	        else
	        {
	        	Intent in = new Intent(ShowPayment.this, ShowSelectTicketAct.class);
				
	        	in.putExtra("directPayment",false);
	        	in.putExtra("orderTotal",_orderTotal);
	        	in.putExtra("change",_changeAmount);
				
	        	startActivityForResult(in, 5);
	        }
        }
        else
        {
        	_andOP = new AndroidOperations(ShowPayment.this);
            _andOP.ShowMessage(getString(R.string.ShowPayment), getString(R.string.ShowPaymentNoEnought));
        }
    }
    
    private void PrepareDataForm()
    {
        _lblOrderTotal.setText(Parameters.MoneyFormat.format(_orderTotal));
    	
    	WcfOperations wcf = new  WcfOperations();
    	 
    	try
    	{
    		List<PaymentMethodLine> payLines = wcf.GetPaymentMethods();
    	
	    	if (payLines.size()>0)
	        {
	        	Iterator<PaymentMethodLine> i = payLines.iterator();
	
	        	ArrayList<String> methodList = new ArrayList<String>();
	        	
	        	while(i.hasNext())
	        	{
	        		PaymentMethodLine l = (PaymentMethodLine) i.next();
	        		
	        		methodList.add(l.Code);
	        	}
	        	
	        	_adapter = new PayMethodsAdapter(ShowPayment.this, -1, methodList);
	        	
	        	_listView.setAdapter(_adapter);
	        	
	        	_listView.setOnItemClickListener(new OnItemClickListener() {
	
	    			public void onItemClick(AdapterView<?> arg0, View view, int position,
	    					long id) {
	    				// TODO Auto-generated method stub
	    				_adapter.setSelectedPosition(position);
	    				_currentSelMethod = _adapter.getItem(position);
	    				
	    				AddPay();
	    			}
	    		});
	        }
    	}
    	catch (Exception e) 
    	{
    		AndroidOperations.AppendLog("ShowPayment_PrepareDataForm:" + e.getMessage());
    		
    		setResult(RESULT_FIRST_USER);
			finish();
    	}
    	  
      	
        
    }

    private void AddPay()
    {
    		double amount;
            try
            {
                amount = Double.valueOf( _txtAmount.getText().toString());
            }
            catch (Exception ex)
            {
                amount = 0;
            }

            if (amount == 0)
                amount = _changeAmount;
            
            if (amount > 0)
            {
            	PayLine line = new PayLine();
            	
            	line.PayAmount = amount;
           		line.PayMethod = _currentSelMethod;
                
           		_tableDataPays.add(line);
                
           		WcfOperations wcf = new WcfOperations();
           		
           		try
           		{
           			wcf.AddOrderPay(line.PayMethod,line.PayAmount);
           		}
           		catch (Exception e) 
				{
           			AndroidOperations.AppendLog("ShowPayment_AddOrderPay:" + e.getMessage());
           			
           			setResult(RESULT_FIRST_USER);
    				finish();
    				return;
           		}
           		
                UpdateAmounts();

                TableRow newPay = new TableRow(this);
                
                newPay.setWeightSum(100);

                TextView lblMethod = new TextView(this);
                lblMethod.setGravity(Gravity.LEFT);
                lblMethod.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 16);
                
                lblMethod.setText( _currentSelMethod);
                
                TextView lblAmount = new TextView(this);
    
                lblAmount.setGravity(Gravity.RIGHT);
                lblAmount.setTextSize(TypedValue.COMPLEX_UNIT_DIP, 16);
                lblAmount.setText(Parameters.MoneyFormatNoSymbol.format(amount));
                
               
                newPay.addView(lblMethod);
                newPay.addView(lblAmount);

                _tablePays.addView(newPay, new TableLayout.LayoutParams(TableLayout.LayoutParams.FILL_PARENT, TableLayout.LayoutParams.WRAP_CONTENT));
            }

            if (_txtAmount.getText().toString()!= "")
                _txtAmount.setText("");

            AndroidOperations.hideInputMethod(ShowPayment.this, _txtAmount);
    }
    
    private void UpdateAmounts()
    {
        double payAmount = 0;
        
        Iterator<PayLine> i = _tableDataPays.iterator();

    	while(i.hasNext())
    	{
    		double amountLine  = (Double) i.next().PayAmount;
    		
    		payAmount+= amountLine;
    	}

        _lblTotalPayed.setText(Parameters.MoneyFormatNoSymbol.format(payAmount));
        		
        double change = _orderTotal - payAmount;
        
        _lblChange.setText(Parameters.MoneyFormatNoSymbol.format(change));
        
        _changeAmount = change;
        
        if (change <= 0)
        {
          _lblChange.setBackgroundColor(Color.GREEN);
          _lblChange.setTextColor(Color.BLACK);
        }
        else
        {
        	_lblChange.setTextColor(Color.WHITE);
            _lblChange.setBackgroundColor(Color.RED);
        }
    }
    
	public void onActivityResult(int requestCode, int resultCode, Intent intent) 
	{ 
		if (resultCode== RESULT_FIRST_USER)
    	{
			AndroidOperations.AppendLog("BackToMain FROM:" + this.toString());
			
    		setResult(RESULT_FIRST_USER);
    		finish();
    		return;
    	}
		
        if (requestCode == 5) 	//Make Payment must be equal request code in ShowRegisterForm
        { 
        	if(resultCode == RESULT_OK)
        	{
        		setResult(RESULT_OK);
        		finish();
        	}
        }
    }
}
