package dst.net.droid;

import java.io.UnsupportedEncodingException;
import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import dst.net.jsonObj.ArticleShortCut;
import dst.net.jsonObj.FreezeSalesOrderLine;
import dst.net.jsonObj.FreezeSalesOrderLineModifier;
import dst.net.jsonObj.FreezeSalesOrderLineOption;
import dst.net.jsonObj.FreezeSalesOrderState;
import dst.net.jsonObj.GenericResult;
import dst.net.jsonObj.GenericResultDouble;
import dst.net.jsonObj.ItemDataNode;
import dst.net.rest.RestClient;
import dst.net.tools.ActionItem;
import dst.net.tools.QuickAction;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.os.Handler;
import android.os.Message;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.animation.Animation;
import android.view.animation.Animation.AnimationListener;
import android.view.animation.AnimationUtils;
import android.view.animation.TranslateAnimation;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.GridView;
import android.widget.HorizontalScrollView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

public class ShowRegisterAct extends Activity {

	private Button _btnArticles, _btnLines, _btnOptions, _btnCancel, _btnSend,
			_btnPay, _btnUp, /* _btnMain, */_btnExpand;
	private FrameLayout _frmLines, _frmArticles;
	private TextView _txtTableName, _txtTotal, _txtCurrentLine,
			_txtTableNameCustom;
	private AndroidOperations _andOP;
	private boolean _orderChanged;
	private boolean _newSale;
	private WcfOperations _wcf;
	private ItemDataNode _selectedItem;
	private Context _context;
	public Date LastArticleAdded;
	private Runnable _runnable, _runnableDisableGrid;
	private int _waitMiliSeconds, _waitMiliSecondsToEnable;
	private boolean _pressed;
	public GridView GridviewArticles;
	private Handler _handler, _handlerProcessing;
	public boolean AcceptArticleClicks;
	public ProgressDialog PDialog;
	private ListView _registerLines;
	private RegisterLinesAdapter m_adapter;
	public int CurrentPosition;
	private int _maxID;
	private boolean _expandedSC;
	private LinearLayout _headOptions;
	private LinearLayout _lySc;
	private RelativeLayout _reLLin;
	private CountDownTimer _timerPressed;
	private int _forceDinerMode;
	private int _layout;

	private int _moveLayout = 0;
	int _currentParent;

	// action id
	private static final int ID_SUBORDER = 1;
	private static final int ID_GUESNUMBER = 2;
	private static final int ID_CHANGESALE = 3;
	private static final int ID_KITCHENMESSAGE = 4;
	private static final int ID_FAX = 5;
	private static final int ID_GOCOURSES = 6;
	private static final int ID_CANCELSALE = 7;
	private static final int ID_RECOVERSALE = 8;
	private static final int ID_CHANGETABLENAME = 9;
	private static final int ID_MODIFIERS = 10;
	private static final int ID_INGREDIENTS = 11;

	/** Called when the activity is first created. */
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		_pressed = false;
		_waitMiliSeconds = 300;
		_waitMiliSecondsToEnable = 400;
		_wcf = new WcfOperations();
		_selectedItem = null;
		LastArticleAdded = new Date();
		_handler = new Handler();
		AcceptArticleClicks = true;
		_context = this;
		_maxID = 0;
		_forceDinerMode = -1;

		_timerPressed = new CountDownTimer(2000, 500) {

			@Override
			public void onTick(long millisUntilFinished) {
				// TODO Auto-generated method stub

			}

			@Override
			public void onFinish() {
				_pressed = false;

			}
		};

		ActionItem nextItem = new ActionItem(ID_GUESNUMBER,
				getString(R.string.MenuDinerNum), getResources().getDrawable(
						R.drawable.menu_guess));
		ActionItem prevItem = new ActionItem(ID_SUBORDER,
				getString(R.string.MenuSubOrder), getResources().getDrawable(
						R.drawable.menu_suborder));
		ActionItem searchItem = new ActionItem(ID_CHANGESALE,
				getString(R.string.MenuChangeSale), getResources().getDrawable(
						R.drawable.menu_changesale));
		ActionItem infoItem = new ActionItem(ID_KITCHENMESSAGE,
				getString(R.string.KitchenMessageMenu), getResources()
						.getDrawable(R.drawable.menu_kitchen));
		ActionItem eraseItem = new ActionItem(ID_FAX,
				getString(R.string.MenuFax), getResources().getDrawable(
						R.drawable.menu_fax));
		ActionItem goCourses = new ActionItem(ID_GOCOURSES,
				getString(R.string.MenuGoCourses), getResources().getDrawable(
						R.drawable.menu_gocourse));
		ActionItem cancelsaleItem = new ActionItem(ID_CANCELSALE,
				getString(R.string.ShowRegisterAskCancelMenu), getResources()
						.getDrawable(R.drawable.menu_cancelsale));
		ActionItem recoversaleItem = new ActionItem(ID_RECOVERSALE,
				getString(R.string.ShowRegisterRecoverSale), getResources()
						.getDrawable(R.drawable.menu_gocourse));
		ActionItem changeTableNameItem = new ActionItem(ID_CHANGETABLENAME,
				getString(R.string.ShowRegisterTableName), getResources()
						.getDrawable(R.drawable.menu_tablename));
		ActionItem modifiers = new ActionItem(ID_MODIFIERS,
				getString(R.string.ShowRegisterModifiers), getResources()
						.getDrawable(R.drawable.menu_modifiers));
		ActionItem ingredients = new ActionItem(ID_INGREDIENTS,
				getString(R.string.ShowRegisterIngredients), getResources()
						.getDrawable(R.drawable.menu_ingredients));

		// use setSticky(true) to disable QuickAction dialog being dismissed
		// after an item is clicked
		/*
		 * prevItem.setSticky(true); nextItem.setSticky(true);
		 */

		final QuickAction quickAction = new QuickAction(this,
				QuickAction.VERTICAL);

		quickAction.addActionItem(nextItem);

		quickAction.addActionItem(prevItem);
		quickAction.addActionItem(searchItem);
		quickAction.addActionItem(infoItem);

		quickAction.addActionItem(ingredients);
		quickAction.addActionItem(modifiers);

		if (Parameters.ECDinnerPassActive)
			quickAction.addActionItem(goCourses);

		quickAction.addActionItem(recoversaleItem);

		// Always cancel is at the end
		quickAction.addActionItem(cancelsaleItem);
		quickAction.addActionItem(eraseItem);
		quickAction.addActionItem(changeTableNameItem);

		// Set listener for action item clicked
		quickAction
				.setOnActionItemClickListener(new QuickAction.OnActionItemClickListener() {

					public void onItemClick(QuickAction source, int pos,
							int actionId) {
						// ActionItem actionItem =
						// quickAction.getActionItem(pos);

						// here we can filter which action item was clicked with
						// pos or actionId parameter
						if (actionId == ID_GUESNUMBER) {
							AskTableMembers(false);
						} else if (actionId == ID_SUBORDER) {
							AskCreateSubOrder();
						} else if (actionId == ID_CHANGESALE) {
							AskDoChangeTableSale();
						} else if (actionId == ID_KITCHENMESSAGE) {
							AskKitchenMessage();
						} else if (actionId == ID_FAX) {
							AskFaxPrinter();
						} else if (actionId == ID_GOCOURSES) {
							AskGoCourses();
						} else if (actionId == ID_CANCELSALE) {
							removeSale_Step1();
							_andOP = new AndroidOperations(ShowRegisterAct.this);
						} else if (actionId == ID_RECOVERSALE) {
							AskSaleNumber();
							// _andOP = new
							// AndroidOperations(ShowRegisterAct.this);
						}

						else if (actionId == ID_CHANGETABLENAME) {
							AskTableName();
							// _andOP = new
							// AndroidOperations(ShowRegisterAct.this);
						} else if (actionId == ID_MODIFIERS) {
							AskModifiers();
							// _andOP = new
							// AndroidOperations(ShowRegisterAct.this);
						} else if (actionId == ID_INGREDIENTS) {
							AskOptions();
							// _andOP = new
							// AndroidOperations(ShowRegisterAct.this);
						}
					}
				});

		// set listnener for on dismiss event, this listener will be called only
		// if QuickAction dialog was dismissed
		// by clicking the area outside the dialog.
		quickAction.setOnDismissListener(new QuickAction.OnDismissListener() {

			public void onDismiss() {
				// Toast.makeText(getApplicationContext(), "Dismissed",
				// Toast.LENGTH_SHORT).show();
			}
		});

		PDialog = new ProgressDialog(_context);

		_runnable = new Runnable() {
			public void run() {
				long seconds = new Date().getTime();
				if (seconds - LastArticleAdded.getTime() > _waitMiliSeconds - 50
						&& AcceptArticleClicks) {
					LastArticleAdded = new Date();
					GetOrderTotal();
				}
			}
		};

		_runnableDisableGrid = new Runnable() {
			public void run() {
				AcceptArticleClicks = true;
			}
		};

		_handlerProcessing = new Handler() {
			@Override
			public void handleMessage(Message msg) {

				if (msg == null) {
					_pressed = false;
				} else {
					if (msg.what == 1) {

						setResult(RESULT_OK);
						finish();
					} else {

						setResult(RESULT_FIRST_USER);
						finish();
					}
				}
			}
		};

		setContentView(R.layout.showregister);

		Bundle extras = getIntent().getExtras();
		_newSale = extras.getBoolean("newsale", false);

		_btnArticles = (Button) findViewById(R.id.regbtnArticles);
		_btnLines = (Button) findViewById(R.id.regbtnLines);
		_btnOptions = (Button) findViewById(R.id.regtxtOptions);
		_frmLines = (FrameLayout) findViewById(R.id.regframeLines);
		_frmArticles = (FrameLayout) findViewById(R.id.regframeArticles);
		_txtTableName = (TextView) findViewById(R.id.regtxtTable);
		_txtTotal = (TextView) findViewById(R.id.regtxtTotal);
		_txtCurrentLine = (TextView) findViewById(R.id.regtxtCurrentLine);
		_btnCancel = (Button) findViewById(R.id.regbtnCancel);
		_btnSend = (Button) findViewById(R.id.regbtnSend);
		_btnPay = (Button) findViewById(R.id.regbtnPay);
		_btnUp = (Button) findViewById(R.id.regbtnPrev);
		// _btnMain= (Button) findViewById(R.id.regbtnMain);
		_btnExpand = (Button) findViewById(R.id.regbtnSC);
		_txtTableNameCustom = (TextView) findViewById(R.id.regtxtTableName);

		final LinearLayout toolBarLine = (LinearLayout) findViewById(R.id.reglinToolBarLine);

		final Button _btnOptMod = (Button) findViewById(R.id.regBtnMod);
		final Button _btnOptOpt = (Button) findViewById(R.id.regBtnOptionals);
		final Button _btnOptDel = (Button) findViewById(R.id.regBtnRemove);

		final HorizontalScrollView horDinnerMode = (HorizontalScrollView) findViewById(R.id.regScrollDinerMode);

		if (!Parameters.ECDinnerMode && horDinnerMode != null) {
			horDinnerMode.setVisibility(View.GONE);
			_forceDinerMode = -1;
		} else {
			horDinnerMode.setVisibility(View.VISIBLE);

			final Button btnForceDiner1 = (Button) findViewById(R.id.regBtnDin1);
			final Button btnForceDiner2 = (Button) findViewById(R.id.regBtnDin2);
			final Button btnForceDiner3 = (Button) findViewById(R.id.regBtnDin3);
			final Button btnForceDiner4 = (Button) findViewById(R.id.regBtnDin4);
			final Button btnForceDiner5 = (Button) findViewById(R.id.regBtnDin5);
			final Button btnForceDiner6 = (Button) findViewById(R.id.regBtnDin6);
			final Button btnForceDiner7 = (Button) findViewById(R.id.regBtnDin7);
			final Button btnForceDiner8 = (Button) findViewById(R.id.regBtnDin8);

			btnForceDiner1.setText(Parameters.ECDinnerPassNames[0]);
			btnForceDiner2.setText(Parameters.ECDinnerPassNames[1]);
			btnForceDiner3.setText(Parameters.ECDinnerPassNames[2]);
			btnForceDiner4.setText(Parameters.ECDinnerPassNames[3]);
			btnForceDiner5.setText(Parameters.ECDinnerPassNames[4]);
			btnForceDiner6.setText(Parameters.ECDinnerPassNames[5]);
			btnForceDiner7.setText(Parameters.ECDinnerPassNames[6]);
			btnForceDiner8.setText(Parameters.ECDinnerPassNames[7]);

			Button firstForce = null;

			if (Parameters.ECDinnerPassNames[0].trim().length() == 0)
				btnForceDiner1.setVisibility(View.GONE);
			else if (firstForce == null)
				firstForce = btnForceDiner1;
			if (Parameters.ECDinnerPassNames[1].trim().length() == 0)
				btnForceDiner2.setVisibility(View.GONE);
			else if (firstForce == null)
				firstForce = btnForceDiner2;
			if (Parameters.ECDinnerPassNames[2].trim().length() == 0)
				btnForceDiner3.setVisibility(View.GONE);
			else if (firstForce == null)
				firstForce = btnForceDiner3;
			if (Parameters.ECDinnerPassNames[3].trim().length() == 0)
				btnForceDiner4.setVisibility(View.GONE);
			else if (firstForce == null)
				firstForce = btnForceDiner4;
			if (Parameters.ECDinnerPassNames[4].trim().length() == 0)
				btnForceDiner5.setVisibility(View.GONE);
			else if (firstForce == null)
				firstForce = btnForceDiner5;
			if (Parameters.ECDinnerPassNames[5].trim().length() == 0)
				btnForceDiner6.setVisibility(View.GONE);
			else if (firstForce == null)
				firstForce = btnForceDiner6;
			if (Parameters.ECDinnerPassNames[6].trim().length() == 0)
				btnForceDiner7.setVisibility(View.GONE);
			else if (firstForce == null)
				firstForce = btnForceDiner7;
			if (Parameters.ECDinnerPassNames[7].trim().length() == 0)
				btnForceDiner8.setVisibility(View.GONE);
			else if (firstForce == null)
				firstForce = btnForceDiner8;

			final Drawable pressed = getResources().getDrawable(
					R.drawable.btn_orange);
			final Drawable notPressed = getResources().getDrawable(
					R.drawable.btn_black);

			btnForceDiner1.setOnClickListener(new OnClickListener() {

				public void onClick(View v) {

					btnForceDiner1.setBackgroundDrawable(pressed);
					btnForceDiner2.setBackgroundDrawable(notPressed);
					btnForceDiner3.setBackgroundDrawable(notPressed);
					btnForceDiner4.setBackgroundDrawable(notPressed);
					btnForceDiner5.setBackgroundDrawable(notPressed);
					btnForceDiner6.setBackgroundDrawable(notPressed);
					btnForceDiner7.setBackgroundDrawable(notPressed);
					btnForceDiner8.setBackgroundDrawable(notPressed);

					_forceDinerMode = 1;
				}
			});

			btnForceDiner2.setOnClickListener(new OnClickListener() {

				public void onClick(View v) {
					_forceDinerMode = 2;

					btnForceDiner1.setBackgroundDrawable(notPressed);
					btnForceDiner2.setBackgroundDrawable(pressed);
					btnForceDiner3.setBackgroundDrawable(notPressed);
					btnForceDiner4.setBackgroundDrawable(notPressed);
					btnForceDiner5.setBackgroundDrawable(notPressed);
					btnForceDiner6.setBackgroundDrawable(notPressed);
					btnForceDiner7.setBackgroundDrawable(notPressed);
					btnForceDiner8.setBackgroundDrawable(notPressed);

				}
			});

			btnForceDiner3.setOnClickListener(new OnClickListener() {

				public void onClick(View v) {
					_forceDinerMode = 3;

					btnForceDiner1.setBackgroundDrawable(notPressed);
					btnForceDiner2.setBackgroundDrawable(notPressed);
					btnForceDiner3.setBackgroundDrawable(pressed);
					btnForceDiner4.setBackgroundDrawable(notPressed);
					btnForceDiner5.setBackgroundDrawable(notPressed);
					btnForceDiner6.setBackgroundDrawable(notPressed);
					btnForceDiner7.setBackgroundDrawable(notPressed);
					btnForceDiner8.setBackgroundDrawable(notPressed);

				}
			});

			btnForceDiner4.setOnClickListener(new OnClickListener() {

				public void onClick(View v) {
					_forceDinerMode = 4;
					btnForceDiner1.setBackgroundDrawable(notPressed);
					btnForceDiner2.setBackgroundDrawable(notPressed);
					btnForceDiner3.setBackgroundDrawable(notPressed);
					btnForceDiner4.setBackgroundDrawable(pressed);
					btnForceDiner5.setBackgroundDrawable(notPressed);
					btnForceDiner6.setBackgroundDrawable(notPressed);
					btnForceDiner7.setBackgroundDrawable(notPressed);
					btnForceDiner8.setBackgroundDrawable(notPressed);

				}
			});

			btnForceDiner5.setOnClickListener(new OnClickListener() {

				public void onClick(View v) {
					_forceDinerMode = 5;

					btnForceDiner1.setBackgroundDrawable(notPressed);
					btnForceDiner2.setBackgroundDrawable(notPressed);
					btnForceDiner3.setBackgroundDrawable(notPressed);
					btnForceDiner4.setBackgroundDrawable(notPressed);
					btnForceDiner5.setBackgroundDrawable(pressed);
					btnForceDiner6.setBackgroundDrawable(notPressed);
					btnForceDiner7.setBackgroundDrawable(notPressed);
					btnForceDiner8.setBackgroundDrawable(notPressed);

				}
			});

			btnForceDiner6.setOnClickListener(new OnClickListener() {

				public void onClick(View v) {
					_forceDinerMode = 6;

					btnForceDiner1.setBackgroundDrawable(notPressed);
					btnForceDiner2.setBackgroundDrawable(notPressed);
					btnForceDiner3.setBackgroundDrawable(notPressed);
					btnForceDiner4.setBackgroundDrawable(notPressed);
					btnForceDiner5.setBackgroundDrawable(notPressed);
					btnForceDiner6.setBackgroundDrawable(pressed);
					btnForceDiner7.setBackgroundDrawable(notPressed);
					btnForceDiner8.setBackgroundDrawable(notPressed);

				}
			});

			btnForceDiner7.setOnClickListener(new OnClickListener() {

				public void onClick(View v) {
					_forceDinerMode = 7;

					btnForceDiner1.setBackgroundDrawable(notPressed);
					btnForceDiner2.setBackgroundDrawable(notPressed);
					btnForceDiner3.setBackgroundDrawable(notPressed);
					btnForceDiner4.setBackgroundDrawable(notPressed);
					btnForceDiner5.setBackgroundDrawable(notPressed);
					btnForceDiner6.setBackgroundDrawable(notPressed);
					btnForceDiner7.setBackgroundDrawable(pressed);
					btnForceDiner8.setBackgroundDrawable(notPressed);

				}
			});

			btnForceDiner8.setOnClickListener(new OnClickListener() {

				public void onClick(View v) {
					_forceDinerMode = 8;

					btnForceDiner1.setBackgroundDrawable(notPressed);
					btnForceDiner2.setBackgroundDrawable(notPressed);
					btnForceDiner3.setBackgroundDrawable(notPressed);
					btnForceDiner4.setBackgroundDrawable(notPressed);
					btnForceDiner5.setBackgroundDrawable(notPressed);
					btnForceDiner6.setBackgroundDrawable(notPressed);
					btnForceDiner7.setBackgroundDrawable(notPressed);
					btnForceDiner8.setBackgroundDrawable(pressed);

				}
			});

			if (firstForce != null)
				firstForce.performClick();
		}

		_btnOptOpt.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {

				if (_pressed)
					return;

				if (_frmLines.getVisibility() == View.VISIBLE) {
					_pressed = true;

					_timerPressed.start();

					AskOptions();
				}
			}
		});

		_btnOptMod.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {

				if (_pressed)
					return;

				if (_frmLines.getVisibility() == View.VISIBLE) {
					_pressed = true;

					_timerPressed.start();

					AskModifiers();
				}
			}
		});

		_btnOptDel.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {

				if (_pressed)
					return;

				if (_frmLines.getVisibility() == View.VISIBLE) {
					_pressed = true;

					_timerPressed.start();

					AskRemoveLine();
				}
			}
		});

		if (!Parameters.ShowLineToolBar)
			toolBarLine.setVisibility(View.GONE);

		_lySc = (LinearLayout) findViewById(R.id.regLinSC);
		_reLLin = (RelativeLayout) findViewById(R.id.relativeLines);

		_headOptions = (LinearLayout) findViewById(R.id.headOptions);

		_andOP = new AndroidOperations(getApplicationContext());

		_btnExpand.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {

				ExpandCollapseSC(350);

			}
		});

		_registerLines = (ListView) findViewById(R.id.regLines);
		GridviewArticles = (GridView) findViewById(R.id.gridviewArticles);

		GridviewArticles.setNumColumns(Parameters.ArticleColumns);
		GridviewArticles.setHorizontalScrollBarEnabled(true);

		_txtTableName.setText(getString(R.string.ShowRegisterTable) + " "
				+ AndroidOperations.CurrentTable);

		if (AndroidOperations.CurrentTableSubOrder > 0)
			_txtTableName.setText(_txtTableName.getText() + "/"
					+ (AndroidOperations.CurrentTableSubOrder + 1));
		_txtTotal.setText("0,00"); // TODO

		PrepareSalesOrder();

		if (!AndroidOperations.TableName
				.equals(getString(R.string.ShowRegisterTable) + " "
						+ AndroidOperations.CurrentTable))
			if (AndroidOperations.TableName.length() > 0)
				_txtTableNameCustom.setText("/ " + AndroidOperations.TableName);
			else
				_txtTableNameCustom.setText("");
		else
			_txtTableNameCustom.setText("");

		_layout = R.layout.registeritem;

		if (Parameters.ECDinnerPassActive)
			_layout = R.layout.registeritemdiner;

		m_adapter = new RegisterLinesAdapter(this, _layout,
				new ArrayList<FreezeSalesOrderLine>());

		LoadOrderGrid(0);

		if (AndroidOperations.OrderData.SaleLines.size() > 0) {
			ShowLines();
			_maxID = AndroidOperations.OrderData.SaleLines.size();
		} else {
			_maxID = 0;
			ShowArticles();
		}

		_orderChanged = false;

		_btnArticles.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {
				ShowArticles();

			}
		});

		_btnLines.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {

				ShowLines();
			}
		});

		_btnCancel.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {

				AskCancelSale();
			}
		});

		_btnOptions.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {

				quickAction.show(v);
				quickAction.setAnimStyle(QuickAction.ANIM_REFLECT);

				// openOptionsMenu();

			}
		});

		_btnPay.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {

				if (_pressed)
					return;

				_pressed = true;

				_timerPressed.start();

				RestClient clientRest = new RestClient(Parameters.WcfUrl);
				Map<String, String> params = new HashMap<String, String>();

				params.put("deviceid", AndroidOperations.DeviceID);
				params.put("permissionid",
						String.valueOf(TypePermissions.PER_MAKE_PAY));

				String response = clientRest.webGet("GetPermission/", params);

				if (response == null || response == "") {
					_timerPressed.cancel();

					AndroidOperations.AppendLog("GP_BtnPay");

					setResult(RESULT_FIRST_USER);
					finish();
				} else {
					try {
						GenericResult resp = new Gson().fromJson(response,
								GenericResult.class);

						int respPerm = CheckPermission(resp, 6);

						switch (respPerm) {
						case 1:
							MakePayment();
							break;
						case -1: {

							_andOP = new AndroidOperations(ShowRegisterAct.this);
							_andOP.ShowMessage(getString(R.string.Permissions),
									getString(R.string.AccessDenied));
							break;
						}
						}
					} catch (Exception ex) {
						_timerPressed.cancel();
						ex.printStackTrace();
						AndroidOperations.AppendLog("BtnPay:" + ex.getMessage());

						setResult(RESULT_FIRST_USER);
						finish();
					}
				}
			}
		});

		_btnSend.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {

				if (_pressed)
					return;

				SharedPreferences share = PreferenceManager
						.getDefaultSharedPreferences(ShowRegisterAct.this);
				SharedPreferences.Editor editor = share.edit();

				editor.putBoolean("expandmode",
						AndroidOperations.CurrentExpanMode);

				editor.commit();

				_pressed = true;

				PDialog.setMessage(getText(R.string.Processing));
				PDialog.setIndeterminate(true);
				PDialog.setCancelable(false);
				PDialog.show();

				Thread thread = new Thread() {

					public void run() {

						WcfOperations wcf = new WcfOperations();

						try {
							if (wcf.wcf_MakeSend(false) == -1) {
								Parameters.SerialOk = false;

								setResult(RESULT_FIRST_USER);
								finish();
								PDialog.dismiss();

							} else {
								setResult(RESULT_OK);
								finish();
								PDialog.dismiss();
							}
						} catch (Exception e) {

							AndroidOperations.AppendLog("BtnSend:"
									+ e.getMessage());

							setResult(RESULT_FIRST_USER);
							finish();
						}
					}
				};

				thread.start();
			}
		});

		_btnUp.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {

				if (_currentParent != -1) {
					GridviewArticles.removeAllViewsInLayout();

					try {

						_currentParent = Item.GetParent(_currentParent);

						GridviewArticles.setAdapter(new ImageAdapter(
								_currentParent, ShowRegisterAct.this));

					} catch (UnsupportedEncodingException e) {

						AndroidOperations.AppendLog("BtnUP1:" + e.getMessage());
						e.printStackTrace();
					}
				}
			}
		});

		/*
		 * _btnMain.setOnClickListener(new OnClickListener() { public void
		 * onClick(View v) { // TODO Auto-generated method stub
		 * 
		 * _lstParents.clear();
		 * 
		 * _lstParents.add(-1); _parentFolder = -1;
		 * 
		 * 
		 * try { GridviewArticles.setAdapter(new ImageAdapter( _parentFolder,
		 * ShowRegisterAct.this)); } catch (UnsupportedEncodingException e) {
		 * Log.i("Error", e.getMessage()); e.printStackTrace(); } catch
		 * (SQLException e) { Log.i("Error", e.getMessage());
		 * e.printStackTrace(); } } });
		 */

		try {
			GridviewArticles.setAdapter(new ImageAdapter(-1, this));

			_currentParent = -1;
		} catch (UnsupportedEncodingException e) {
			AndroidOperations.AppendLog("BtnUP2:" + e.getMessage());

			Log.i("Error", e.getMessage());
			e.printStackTrace();
		}

		LoadBottomShortCuts();

		GetOrderTotal();

		if (AndroidOperations.CurrentExpanMode) {
			_expandedSC = false;
		} else {
			_expandedSC = true;
		}

		if (AndroidOperations.OrderData.SaleLines.size() > 0) {
			ShowLines();
			_maxID = AndroidOperations.OrderData.SaleLines.size();
		} else {
			_maxID = 0;
			ShowArticles();
		}

		_btnExpand.postDelayed(new Runnable() {
			public void run() {

				ExpandCollapseSC(50);
				// _btnExpand.performClick();
			}
		}, 50);
	}

	@Override
	public void onCreateContextMenu(ContextMenu menu, View v,
			ContextMenuInfo menuInfo) {
		super.onCreateContextMenu(menu, v, menuInfo);

		menu.clear();

		menu.setHeaderTitle(getString(R.string.Options));

		menu.add(0, v.getId(), 0, getString(R.string.MenuPrice));
		menu.add(0, v.getId(), 0, getString(R.string.MenuQuantity));
		menu.add(0, v.getId(), 0, getString(R.string.MenuOptions));
		menu.add(0, v.getId(), 0, getString(R.string.MenuModifiers));
		menu.add(0, v.getId(), 0, getString(R.string.ShowRegisterInvite));
		menu.add(0, v.getId(), 0, getString(R.string.MenuMenu));
		menu.add(0, v.getId(), 0, getString(R.string.MenuDelete));
		menu.add(0, v.getId(), 0, getString(R.string.Back));
	}

	@Override
	public boolean onContextItemSelected(MenuItem item) {
		if (item.getTitle() == getString(R.string.MenuPrice)) {
			AskArticlePrice(m_adapter.getPosition());
		} else if (item.getTitle() == getString(R.string.MenuQuantity)) {
			if (_registerLines.getItemAtPosition(m_adapter.getPosition()) != null) {
				EditAmount((FreezeSalesOrderLine) _registerLines
						.getItemAtPosition(m_adapter.getPosition()));
			} else {
				Toast.makeText(ShowRegisterAct.this, R.string.SelectLine,
						Toast.LENGTH_SHORT).show();
			}
		}

		else if (item.getTitle() == getString(R.string.MenuOptions)) {
			AskOptions();
		} else if (item.getTitle() == getString(R.string.MenuModifiers)) {
			AskModifiers();
		} else if (item.getTitle() == getString(R.string.MenuMenu)) {
			AskMenu();
		} else if (item.getTitle() == getString(R.string.MenuDelete)) {
			AskRemoveLine();
		} else if (item.getTitle() == getString(R.string.ShowRegisterInvite)) {
			MakeInvite();
		} else // if(item.getTitle()==getString(R.string.Back))
		{
			return true;
		}
		return true;
	}

	private void ExpandCollapseSC(int duration) {
		_headOptions.setEnabled(false);

		if (_moveLayout <= 0)
			_moveLayout = _lySc.getHeight();

		// TODO Auto-generated method stub
		if (_expandedSC) {
			AndroidOperations.CurrentExpanMode = false;
			_btnExpand.setText(getString(R.string.Expand));

			TranslateAnimation slide = new TranslateAnimation(0, 0, 0,
					_moveLayout * -1);

			slide.setFillEnabled(true);

			slide.setAnimationListener(new AnimationListener() {

				public void onAnimationStart(Animation animation) {

				}

				public void onAnimationRepeat(Animation animation) {

				}

				public void onAnimationEnd(Animation animation) {

					RelativeLayout.LayoutParams params = (RelativeLayout.LayoutParams) _reLLin
							.getLayoutParams();
					params.setMargins(0, 0, 0, 0);
					_reLLin.setLayoutParams(params);
				}
			});

			slide.setDuration(duration);

			_reLLin.startAnimation(slide);

			_expandedSC = false;
		} else {
			AndroidOperations.CurrentExpanMode = true;
			_btnExpand.setText(getString(R.string.Collapse));

			TranslateAnimation slide = new TranslateAnimation(0, 0, 0,
					_moveLayout);
			slide.setDuration(350);
			slide.setFillEnabled(true);

			slide.setAnimationListener(new AnimationListener() {

				public void onAnimationStart(Animation animation) {

				}

				public void onAnimationRepeat(Animation animation) {

				}

				public void onAnimationEnd(Animation animation) {

					RelativeLayout.LayoutParams params = (RelativeLayout.LayoutParams) _reLLin
							.getLayoutParams();
					params.setMargins(0, _moveLayout, 0, 0);
					_reLLin.setLayoutParams(params);
				}
			});

			_reLLin.startAnimation(slide);
			_expandedSC = true;
			_headOptions.setEnabled(true);
		}
	}

	private void AskGoCourses() {
		Intent i = new Intent(ShowRegisterAct.this, GoCoursesAct.class);

		startActivityForResult(i, 11);
	}

	private void LoadBottomShortCuts() {
		List<ArticleShortCut> shortcuts = Parameters.ShortCutsList;

		boolean line1 = false;
		boolean line2 = false;
		boolean line3 = false;
		boolean line4 = false;

		if (shortcuts == null)
			return;

		for (int i = 0; i < 20; i++) {
			Button a = GetButton(i);
			a.setEnabled(false);
		}

		Iterator<ArticleShortCut> i = shortcuts.iterator();

		while (i.hasNext()) {
			final ArticleShortCut l = (ArticleShortCut) i.next();

			final Button b = GetButton(l.Position);

			b.setEnabled(true);

			b.setText(l.Description1 + " " + l.Description2);

			b.setOnClickListener(new OnClickListener() {

				public void onClick(View v) {

					if (!AcceptArticleClicks)
						return;

					if (l.Article.IsFolder && _btnArticles.isEnabled())
						ShowArticles();

					Animation rotate = AnimationUtils.loadAnimation(
							ShowRegisterAct.this, R.anim.scaledown_alpha);

					rotate.setDuration(200);

					b.startAnimation(rotate);

					EventDataClick(l.Article, null, 1, true);
				}
			});

			if (l.Article.IsFolder) {
				b.setTextColor(Color.BLACK);
				b.setBackgroundResource(R.drawable.folder);
			}

			if (l.Position < 5)
				line1 = true;
			else if (l.Position >= 5 && l.Position < 10)
				line2 = true;
			else if (l.Position >= 10 && l.Position < 15)
				line3 = true;
			else if (l.Position >= 15 && l.Position < 20)
				line4 = true;
		}

		// LinearLayout regMain = (LinearLayout) findViewById(R.id.regLinSC);

		if (!line1) {
			LinearLayout l1 = (LinearLayout) findViewById(R.id.shortLine1);
			l1.setVisibility(View.INVISIBLE);

			_lySc.removeView(l1);
		}

		if (!line2) {
			LinearLayout l2 = (LinearLayout) findViewById(R.id.shortLine2);
			l2.setVisibility(View.INVISIBLE);
			_lySc.removeView(l2);
		}

		if (!line3) {
			LinearLayout l3 = (LinearLayout) findViewById(R.id.shortLine3);
			l3.setVisibility(View.INVISIBLE);
			_lySc.removeView(l3);
		}
		if (!line4) {
			LinearLayout l4 = (LinearLayout) findViewById(R.id.shortLine4);
			l4.setVisibility(View.INVISIBLE);
			_lySc.removeView(l4);
		}

		_lySc.requestLayout();
	}

	private Button GetButton(int position) {
		switch (position) {
		case 0:
			return (Button) findViewById(R.id.regbtnBut1);
		case 1:
			return (Button) findViewById(R.id.regbtnBut2);
		case 2:
			return (Button) findViewById(R.id.regbtnBut3);
		case 3:
			return (Button) findViewById(R.id.regbtnBut4);
		case 4:
			return (Button) findViewById(R.id.regbtnBut5);
		case 5:
			return (Button) findViewById(R.id.regbtnBut6);
		case 6:
			return (Button) findViewById(R.id.regbtnBut7);
		case 7:
			return (Button) findViewById(R.id.regbtnBut8);
		case 8:
			return (Button) findViewById(R.id.regbtnBut9);
		case 9:
			return (Button) findViewById(R.id.regbtnBut10);
		case 10:
			return (Button) findViewById(R.id.regbtnBut11);
		case 11:
			return (Button) findViewById(R.id.regbtnBut12);
		case 12:
			return (Button) findViewById(R.id.regbtnBut13);
		case 13:
			return (Button) findViewById(R.id.regbtnBut14);
		case 14:
			return (Button) findViewById(R.id.regbtnBut15);
		case 15:
			return (Button) findViewById(R.id.regbtnBut16);
		case 16:
			return (Button) findViewById(R.id.regbtnBut17);
		case 17:
			return (Button) findViewById(R.id.regbtnBut18);
		case 18:
			return (Button) findViewById(R.id.regbtnBut19);
		case 19:
			return (Button) findViewById(R.id.regbtnBut20);
		default:
			return null;
		}

	}

	private void AskArticleKG() {
		Intent i = new Intent(ShowRegisterAct.this, AskKilogramSelectAct.class);

		if ((FreezeSalesOrderLine) _registerLines.getItemAtPosition(m_adapter
				.getPosition()) == null)
			return;

		FreezeSalesOrderLine line = (FreezeSalesOrderLine) _registerLines
				.getItemAtPosition(m_adapter.getPosition());

		if (line.Menu > 0 && !line.MenuPart) {
			_andOP.ShowMessage(ShowRegisterAct.this,
					getString(R.string.EditModifiers),
					getString(R.string.EditModifiersMenu));
			return;
		}

		PDialog.setMessage(getText(R.string.Processing));
		PDialog.setCancelable(false);
		PDialog.setIndeterminate(true);
		PDialog.show();

		_selectedItem = new ItemDataNode();
		_selectedItem.Number = -1;

		startActivityForResult(i, 14);
	}

	public void EventLongDataClick(ItemDataNode idItem, ImageView image) {
		_andOP.ShowMessage(ShowRegisterAct.this, "LONGCLICK", "FICHA ARTICULO");
	}

	public void EventDataClick(ItemDataNode idItem, ImageView image,
			int amount, boolean focuseLine) {
		if (!AcceptArticleClicks)
			return;

		if (idItem.IsFolder) {

			_currentParent = idItem.Number;

			PDialog.setMessage(_context.getText(R.string.GettingFolder));
			PDialog.setCancelable(false);
			PDialog.setIndeterminate(true);
			PDialog.show();

			new LoadImageAsync(_context, GridviewArticles, idItem.Number)
					.execute((Void) null);
		} else if (idItem.AskPrice) // Must Be first
		{
			AcceptArticleClicks = false;
			ActivateGridDelayed();
			AskArticlePrice(idItem);
		} else if (idItem.HasPieces) {
			AcceptArticleClicks = false;
			ActivateGridDelayed();
			AskArticlePieces(idItem);
		} else if (idItem.PricePerKg) {
			AskArticleKG(idItem);
		}

		else if (idItem.Menu) {
			AcceptArticleClicks = false;

			_selectedItem = idItem;

			ShowMenu(idItem.Number, idItem.Description1 + " "+ idItem.Description2 + " " + idItem.Description3 + " "+ idItem.Description4, -1, 0);
		
		} else if (idItem.HasOptionsAutoShow && idItem.HasChildsOptions) {
			AcceptArticleClicks = false;

			AskArticleOptionals(idItem);
		
		} else if (idItem.HasModifiersAutoShow) {
			AcceptArticleClicks = false;
			ActivateGridDelayed();
			AskArticleModifiers(idItem);
		} else // Normal Article
		{
			MakeAddLine(_maxID, idItem, amount, new ArrayList<Integer>(),
					new ArrayList<String>(), Parameters.OptionsArticle,
					focuseLine, "");

			if (idItem.HasPromotions) {
				AcceptArticleClicks = false;

				AskArticlePromotion(idItem, false);
			}
		}
	}

	public void ActivateGridDelayed() {
		_handler.postDelayed(_runnableDisableGrid, _waitMiliSecondsToEnable);
	}

	private void AskArticleKG(ItemDataNode idItem) {
		PDialog.setMessage(_context.getText(R.string.Processing));
		PDialog.setCancelable(false);
		PDialog.setIndeterminate(true);
		PDialog.show();

		Intent i = new Intent(ShowRegisterAct.this, AskKilogramSelectAct.class);

		_selectedItem = idItem;

		startActivityForResult(i, 14);
	}

	private void ShowMenu(int articleNumber, String description, int piece,
			double price) {
		PDialog.setMessage(_context.getText(R.string.Processing));
		PDialog.setCancelable(false);
		PDialog.setIndeterminate(true);
		PDialog.show();

		try {
			_wcf.StartMenuTransaction(articleNumber, piece);

			if (Parameters.TCMenuConfig == 0) {
				Intent i = new Intent(ShowRegisterAct.this, MenuActionAct.class);

				i.putExtra("idLine", -1); // New Line
				i.putExtra("article", articleNumber);
				i.putExtra("articleName", description);
				i.putExtra("piece", piece);
				i.putExtra("price", price);

				startActivityForResult(i, 9);
			} else {
				Intent i = new Intent(ShowRegisterAct.this,
						MenuActionHelperAct.class);

				i.putExtra("idLine", -1); // New Line
				i.putExtra("article", articleNumber);
				i.putExtra("articleName", description);
				i.putExtra("piece", piece);
				i.putExtra("price", price);

				startActivityForResult(i, 9);
			}
		} catch (Exception e) {
			PDialog.dismiss();

			AndroidOperations.AppendLog("StartMenuTransaction:"
					+ e.getMessage());

			setResult(RESULT_FIRST_USER);
			finish();
		}
	}

	private void AskArticleModifiers(ItemDataNode idItem) {
		PDialog.setMessage(_context.getText(R.string.Processing));
		PDialog.setIndeterminate(true);
		PDialog.show();

		Intent i = new Intent(ShowRegisterAct.this, ModifiersSelectAct.class);

		_selectedItem = idItem;

		i.putExtra("idLine", -1); // New Line
		i.putExtra("article", _selectedItem.Number);
		i.putExtra("articlename", _selectedItem.Description1 + " "
				+ _selectedItem.Description2 + " " + _selectedItem.Description3
				+ " " + _selectedItem.Description4);

		startActivityForResult(i, 7);
	}

	private void AskArticlePromotion(ItemDataNode idItem, boolean fromMenu) {
		PDialog.setMessage(_context.getText(R.string.Processing));
		PDialog.setIndeterminate(true);
		PDialog.show();

		Intent i = new Intent(ShowRegisterAct.this, PromotionSelectAct.class);

		_selectedItem = idItem;

		i.putExtra("idLine", -1); // New Line
		i.putExtra("article", _selectedItem.Number);
		i.putExtra("articlename", _selectedItem.Description1 + " "
				+ _selectedItem.Description2 + " " + _selectedItem.Description3
				+ " " + _selectedItem.Description4);
		i.putExtra("fromMenu", fromMenu);

		startActivityForResult(i, 13);
	}

	private void AskArticleOptionals(ItemDataNode idItem) {
		PDialog.setMessage(_context.getText(R.string.Processing));
		PDialog.setIndeterminate(true);
		PDialog.show();

		Intent i;
		if (idItem.MultiOptionals == 1)
			i = new Intent(ShowRegisterAct.this, MultiOptionalAct.class);
		else
			i = new Intent(ShowRegisterAct.this, SingleOptionalAct.class);

		_selectedItem = idItem;

		i.putExtra("idLine", -1); // New Line
		i.putExtra("article", _selectedItem.Number);
		i.putExtra("price", idItem.GetCurrentPrice());
		i.putExtra("piece", idItem.Piece);
		i.putExtra("articleDescription", _selectedItem.Description1 + " "
				+ _selectedItem.Description2 + " " + _selectedItem.Description3
				+ " " + _selectedItem.Description4);
		i.putExtra("multioptional", _selectedItem.MultiOptionals);
		i.putExtra("numfreeoptions", idItem.NumFreeOptions);

		startActivityForResult(i, 8);
	}

	private void AskArticlePieces(ItemDataNode idItem) {
		PDialog.setMessage(_context.getText(R.string.Processing));
		PDialog.setIndeterminate(true);
		PDialog.show();

		Intent i = new Intent(ShowRegisterAct.this, AskPiecesAct.class);

		_selectedItem = idItem;

		i.putExtra("idLine", -1); // New Line
		i.putExtra("article", _selectedItem.Number);
		if (idItem.AskPrice)
			i.putExtra("price", idItem.GetCurrentPrice());
		else
			i.putExtra("price", -1);

		i.putExtra("articleDescription", _selectedItem.Description1 + " "
				+ _selectedItem.Description2 + " " + _selectedItem.Description3
				+ " " + _selectedItem.Description4);

		startActivityForResult(i, 12);
	}

	private void MakeAddLine(int maxID, ItemDataNode idItem, int amount,ArrayList<Integer> modifiers, ArrayList<String> modifiersStr,ArrayList<FreezeSalesOrderLineOption> options, boolean focuseLine,	String freeText)
	{
		_orderChanged = true;

		LastArticleAdded = new Date();

		boolean addNew = true;
		FreezeSalesOrderLine line = new FreezeSalesOrderLine(maxID, idItem,	amount);

		if (_forceDinerMode > -1)
			line.CourseNumber = _forceDinerMode;

		ArrayList<FreezeSalesOrderLineModifier> lstMod = UpdateModifiers(maxID,modifiers, modifiersStr);

		// GetModifiers
		line.Modifiers = new FreezeSalesOrderLineModifier[lstMod.size()];
		line.MultiOptionals = idItem.MultiOptionals;
		line.Description = idItem.TicketText;
		line.Piece = idItem.Piece;
		line.Weight = idItem.Weight;

		Iterator<FreezeSalesOrderLineModifier> i = lstMod.iterator();

		int j = 0;
		while (i.hasNext()) {
			FreezeSalesOrderLineModifier l = (FreezeSalesOrderLineModifier)	i.next();

			line.Modifiers[j] = l;
			j++;
		}

		/*** OPTIONS ***********/
		if (options != null) {
			line.Options = new FreezeSalesOrderLineOption[options.size()];

			Iterator<FreezeSalesOrderLineOption> k = options.iterator();

			int q = 0;
			while (k.hasNext()) {
				FreezeSalesOrderLineOption l = (FreezeSalesOrderLineOption) k
						.next();

				if (idItem.PriceChanged)
					l.Price = 0;

				if (line.MultiOptionals != 1) {
					line.Price = l.Price;
					l.Price = 0;
				}

				l.IdLine = maxID;
				l.Number = q;
				line.Options[q] = l;
				q++;
			}
		}
		/**********/

		if (AndroidOperations.OrderData.SaleLines.size() > 0) {
			FreezeSalesOrderLine currentLine = AndroidOperations.OrderData.SaleLines
					.get(AndroidOperations.OrderData.SaleLines.size() - 1);

			if (_andOP.CompareLines(line, currentLine) && !idItem.HasPromotions
					&& idItem.Weight == 0) {
				addNew = false;
				currentLine.Quantity += amount;
				line = currentLine;
			}

		}

		if (addNew) {
			// wcf add line

			try {
				
				GenericResult res = _wcf.AddFreezeLine(idItem.Number, amount,idItem.GetCurrentPrice(), modifiers, options,idItem.Piece, _forceDinerMode, freeText, false, false,idItem.Weight);

				if (res == null) {
					AndroidOperations.AppendLog("Restaring from AddLine");

					setResult(RESULT_FIRST_USER);
					finish();
					return; // Added by rafa because res is null and it will
							// continue
				}

				if (!res.SerialIdOk) {
					Parameters.SerialOk = false;
					setResult(RESULT_FIRST_USER);
					finish();
					return; // Added by rafa
				}

				line.IdLine = res.Result;

				_maxID = res.Result + 1;

				AndroidOperations.OrderData.SaleLines.put(line.IdLine, line);

				m_adapter.add(line);

				m_adapter.setSelectedPosition(m_adapter.getSize() - 1);

				_maxID++;
			} catch (Exception e) {
				AndroidOperations.AppendLog("AddLine:" + e.getMessage());

				setResult(RESULT_FIRST_USER);
				finish();
			}

		} else {
			try {
				_wcf.ChangeQuantity(line.IdLine, line.Quantity);
			} catch (Exception e) {

				AndroidOperations.AppendLog("ChangeQuantity:" + e.getMessage());

				setResult(RESULT_FIRST_USER);
				finish();
				return; // Added by Rafa
			}
		}

		m_adapter.notifyDataSetChanged();

		if (focuseLine) {
			m_adapter.setSelectedPosition(m_adapter.getSize() - 1);

			_registerLines.post(new Runnable() {

				public void run() {

					_registerLines.setSelection(_registerLines.getCount() - 1);
				}
			});
		}

		SetCurrentLine(Parameters.QuantityFormat.format(line.Quantity) + " "
				+ line.Description);

		if (Parameters.OptionsArticle != null)
			Parameters.OptionsArticle.clear();

		_handler.postDelayed(_runnable, _waitMiliSeconds);
	}

	private ArrayList<FreezeSalesOrderLineModifier> UpdateModifiers(int maxID,
			ArrayList<Integer> modifiers, ArrayList<String> modifiersStr) {
		ArrayList<FreezeSalesOrderLineModifier> modList = new ArrayList<FreezeSalesOrderLineModifier>();

		for (int i = 0; i < modifiers.size(); i++) {
			FreezeSalesOrderLineModifier modLine = new FreezeSalesOrderLineModifier();

			modLine.IdLine = maxID;
			modLine.Modifier = modifiers.get(i);
			modLine.Description = modifiersStr.get(i);

			modList.add(modLine);
		}

		return modList;
	}

	private ArrayList<FreezeSalesOrderLineOption> UpdateOptions(int maxID) {
		ArrayList<FreezeSalesOrderLineOption> optList = new ArrayList<FreezeSalesOrderLineOption>();

		for (int i = 0; i < Parameters.OptionsArticle.size(); i++) {
			FreezeSalesOrderLineOption optionLine = new FreezeSalesOrderLineOption();

			optionLine.IdLine = maxID;
			optionLine.Number = i;
			optionLine.Article = Parameters.OptionsArticle.get(i).Article;
			optionLine.Description = Parameters.OptionsArticle.get(i).Description;
			optionLine.Price = Parameters.OptionsArticle.get(i).Price;

			optList.add(optionLine);
		}

		return optList;
	}

	private void MakePayment() {
		if (AndroidOperations.OrderData.SaleLines.size() > 0) {

			if (Parameters.UsePaymentMethods) {
				Intent i = new Intent(ShowRegisterAct.this,
						SelectPaymentAct.class);
				startActivityForResult(i, 5);
			} else {
				RestClient clientRest = new RestClient(Parameters.WcfUrl);
				Map<String, String> params = new HashMap<String, String>();

				params.put("deviceid", AndroidOperations.DeviceID);
				params.put("permissionid",
						String.valueOf(TypePermissions.PER_MAKE_PAY));

				try {
					String response = clientRest.webGet("GetPermission/",
							params);

					if (response == null || response == "") {
						AndroidOperations
								.AppendLog("Restarting from MakePayment");

						setResult(RESULT_FIRST_USER);
						finish();
					}

					GenericResult resp = new Gson().fromJson(response,
							GenericResult.class);

					switch (CheckPermission(resp, 4)) {
					case 1: {
						PDialog.setMessage(_context
								.getText(R.string.Processing));
						PDialog.setIndeterminate(true);
						PDialog.show();

						_andOP.MakeActionPaymentStep1(ShowRegisterAct.this,
								_handlerProcessing);
						break;
					}

					case -1: {
						_andOP = new AndroidOperations(ShowRegisterAct.this);
						_andOP.ShowMessage(getString(R.string.Permissions),
								getString(R.string.AccessDenied));
						break;
					}
					}
				} catch (Exception ex) {
					AndroidOperations.AppendLog("MakePayment:"
							+ ex.getMessage());

					setResult(RESULT_FIRST_USER);
					finish();
				}
			}
		}
	}

	private void LoadOrderGrid(int startFrom) {
		ArrayList<FreezeSalesOrderLine> list = new ArrayList<FreezeSalesOrderLine>();

		for (int i = 0; i < AndroidOperations.OrderData.SaleLines.values()
				.size(); i++) {
			FreezeSalesOrderLine l = (FreezeSalesOrderLine) AndroidOperations.OrderData.SaleLines
					.get(i);
			list.add(l);

			m_adapter.add(l);
		}

		_registerLines.setAdapter(m_adapter);

		_registerLines.buildDrawingCache();

		if (m_adapter.getSize() > 0) {
			m_adapter.setSelectedPosition(0);

			_registerLines.setSelection(0);
		}

		_registerLines.setOnItemClickListener(new OnItemClickListener() {

			public void onItemClick(AdapterView<?> arg0, View view,
					int position, long id) {
				// TODO Auto-generated method stub
				m_adapter.setSelectedPosition(position);
			}
		});

		_registerLines.setOnLongClickListener(new OnLongClickListener() {

			public boolean onLongClick(View v) {
				// TODO Auto-generated method stub

				openContextMenu(v);
				return true;
			}
		});
	}

	public void OpenContextMenu(View v) {
		openContextMenu(v);
	}

	private void PrepareSalesOrder() {
		AndroidOperations.OrderData.SaleLines.clear();

		AndroidOperations.HasLends = false;
		AndroidOperations.HasPrepays = false;

		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();

		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("tableNumber",
				String.valueOf(AndroidOperations.CurrentTable));
		params.put("suborderNumber",
				String.valueOf(AndroidOperations.CurrentTableSubOrder));
		params.put("tariff",
				String.valueOf(AndroidOperations.CurrentTableTariff));

		try {
			String response = clientRest.webGet("GetFreezeOrder/", params);

			if (response == null || response == "") {
				AndroidOperations
						.AppendLog("Restarting from PrepareSalesOrder_1");

				setResult(RESULT_FIRST_USER);
				finish();
				return;
			}

			Type collectionType = new TypeToken<List<FreezeSalesOrderLine>>() {
			}.getType();
			List<FreezeSalesOrderLine> resp = new Gson().fromJson(response,
					collectionType);

			Iterator<FreezeSalesOrderLine> i = resp.iterator();

			while (i.hasNext()) {
				FreezeSalesOrderLine l = (FreezeSalesOrderLine) i.next();

				AndroidOperations.OrderData.SaleLines.put(l.IdLine, l);
			}

			Map<String, String> params1 = new HashMap<String, String>();

			params1.put("deviceid", AndroidOperations.DeviceID);

			String response1 = clientRest.webGet("GetFreezeOrderState/",
					params1);

			if (response1 == null || response1 == "") {
				AndroidOperations
						.AppendLog("Restarting from PrepareSalesOrder_2");

				setResult(RESULT_FIRST_USER);
				finish();
				return;
			}

			FreezeSalesOrderState resp1 = new Gson().fromJson(response1,
					FreezeSalesOrderState.class);

			AndroidOperations.HasLends = resp1.HasLends;
			AndroidOperations.HasPrepays = resp1.HasPrepays;
			AndroidOperations.TableName = resp1.TableName;
			AndroidOperations.TableMember = resp1.TableMembers;

		} catch (Exception e) {
			AndroidOperations.AppendLog("PrepareSalesOrder:" + e.getMessage());

			setResult(RESULT_FIRST_USER);
			finish();
			return;
		}

		if (_newSale && Parameters.TCRequestTableMember) {
			AskTableMembers(true);
		} else if (_newSale && Parameters.TCRequestTableName) {
			AskTableName();
		}

	}

	public void AskTableMembers(boolean isNewSale) {
		Intent i = new Intent(ShowRegisterAct.this, AskTableMembersAct.class);

		i.putExtra("newsale", isNewSale);

		startActivityForResult(i, 2);
	}

	public void AskTableName() {
		Intent i = new Intent(ShowRegisterAct.this, AskTableNameAct.class);

		startActivityForResult(i, 16);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		MenuInflater inflater = new MenuInflater(this);

		inflater.inflate(R.menu.menu, menu);

		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		_andOP = new AndroidOperations(this);
		// Handle item selection
		switch (item.getItemId()) {
		case R.id.regOpt1CancelSale:
			removeSale_Step1();
			_andOP = new AndroidOperations(ShowRegisterAct.this);
			return true;
			/*
			 * case R.id.regOpt2quantity: { if
			 * (_registerLines.getSelectedItem()!= null)
			 * EditAmount((FreezeSalesOrderLine
			 * )_registerLines.getSelectedItem()); else
			 * Toast.makeText(ShowRegisterAct.this, R.string.SelectLine,
			 * Toast.LENGTH_SHORT).show();
			 * 
			 * return true; }
			 * 
			 * case R.id.regOpt3Options: AskOptions(); return true;
			 */
		case R.id.regOpt6DinersNums:
			AskTableMembers(false);
			return true;
		case R.id.regOpt5ChangeSale:
			AskDoChangeTableSale();
			return true;

		case R.id.regOpt10KitchenMessage:
			AskKitchenMessage();
			return true;
		case R.id.regOpt8SubOrder:
			AskCreateSubOrder();
			return true;
		case R.id.regOpt11Back:
			return true;
		case R.id.regOpt9Fax:
			AskFaxPrinter();
			return true;
		default:
			return super.onOptionsItemSelected(item);
		}
	}

	private void AskMenu() {

		if ((FreezeSalesOrderLine) _registerLines.getItemAtPosition(m_adapter
				.getPosition()) == null)
			return;

		FreezeSalesOrderLine line = (FreezeSalesOrderLine) _registerLines
				.getItemAtPosition(m_adapter.getPosition());

		if (line.Menu > 0 && !line.MenuPart) {
			ShowMenu(line.Article, line.Description, line.Piece, line.Price);
		} else {
			_andOP.ShowMessage(ShowRegisterAct.this,
					getString(R.string.EditMenuTitle),
					getString(R.string.EditMenuTitleError));
			return;
		}

	}

	private void AskFaxPrinter() {
		Intent i = new Intent(ShowRegisterAct.this, FaxPrinterAct.class);
		startActivityForResult(i, 12);
	}

	private void AskSaleNumber() {
		Intent i = new Intent(ShowRegisterAct.this, RecoverSaleAct.class);
		startActivityForResult(i, 15);

	}

	private void AskKitchenMessage() {
		if (!_wcf.IsLite()) {
			Intent i = new Intent(ShowRegisterAct.this, KitchenMessageAct.class);
			startActivityForResult(i, 11);
		} else {
			_andOP.ShowMessage(ShowRegisterAct.this,
					getString(R.string.LicenseTitle),
					getString(R.string.LicenseDescription));
		}
	}

	private void AskModifiers() {
		Intent i = new Intent(ShowRegisterAct.this, ModifiersSelectAct.class);

		if ((FreezeSalesOrderLine) _registerLines.getItemAtPosition(m_adapter
				.getPosition()) == null)
			return;

		FreezeSalesOrderLine line = (FreezeSalesOrderLine) _registerLines
				.getItemAtPosition(m_adapter.getPosition());

		if (line.Menu > 0 && !line.MenuPart) {
			_andOP.ShowMessage(ShowRegisterAct.this,
					getString(R.string.EditModifiers),
					getString(R.string.EditModifiersMenu));
			return;
		}

		PDialog.setMessage(getText(R.string.Processing));
		PDialog.setIndeterminate(true);
		PDialog.show();

		_selectedItem = new ItemDataNode();
		_selectedItem.Number = line.Article;

		i.putExtra("idLine", line.IdLine);
		i.putExtra("article", _selectedItem.Number);
		i.putExtra("articlename", line.Description);

		startActivityForResult(i, 7);
	}

	private void AskOptions() {
		if (_registerLines.getItemAtPosition(m_adapter.getPosition()) == null)
			return;

		FreezeSalesOrderLine line = (FreezeSalesOrderLine) _registerLines.getItemAtPosition(m_adapter.getPosition());

		if (line.Menu > 0 && !line.MenuPart) {
			_andOP.ShowMessage(ShowRegisterAct.this,getString(R.string.EditOptionals),getString(R.string.EditOptionalsMenu));
			return;
		}

		PDialog.setMessage(_context.getText(R.string.Processing));
		PDialog.setIndeterminate(true);
		PDialog.show();

		ItemDataNode item = _wcf.GetArticleInfo(line.Article);

		if (!item.HasChildsOptions) {
			_andOP.ShowMessage(ShowRegisterAct.this,getString(R.string.Options),getString(R.string.OptionsNoArticle));
			PDialog.dismiss();
			return;
		}

		Intent i;
		if (line.MultiOptionals == 1)
			i = new Intent(ShowRegisterAct.this, MultiOptionalAct.class);
		else
			i = new Intent(ShowRegisterAct.this, SingleOptionalAct.class);

		_selectedItem = new ItemDataNode();
		_selectedItem.Number = line.Article;
		_selectedItem.SetPrice(AndroidOperations.CurrentTableTariff, line.Price);
		_selectedItem.MultiOptionals = line.MultiOptionals;

		i.putExtra("idLine", line.IdLine);
		i.putExtra("article", _selectedItem.Number);
		i.putExtra("price", _selectedItem.GetCurrentPrice());
		i.putExtra("articleDescription", line.Description);
		i.putExtra("multioptional", line.MultiOptionals);
		i.putExtra("inmenu", false);
		i.putExtra("numfreeoptions", item.NumFreeOptions);

		if (Parameters.OptionsArticle == null)
			Parameters.OptionsArticle = new ArrayList<FreezeSalesOrderLineOption>();

		Parameters.OptionsArticle.clear();

		for (int j = 0; j < line.Options.length; j++) {
			Parameters.OptionsArticle.add(line.Options[j]);
		}

		startActivityForResult(i, 8);
	}

	private void removeSale_Step1() {

		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();

		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("permissionid",
				String.valueOf(TypePermissions.PER_CANCEL_SALES));

		try {
			String response = clientRest.webGet("GetPermission/", params);

			if (response == null || response == "") {
				AndroidOperations.AppendLog("GP_RemoveSaleStep1");

				setResult(RESULT_FIRST_USER);
				finish();
			}

			GenericResult resp = new Gson().fromJson(response,
					GenericResult.class);

			switch (CheckPermission(resp, 3)) {
			case 1:
				RemoveSaleActionStep1();
				break;

			case -1: {
				_andOP = new AndroidOperations(ShowRegisterAct.this);
				_andOP.ShowMessage(getString(R.string.Permissions),
						getString(R.string.AccessDenied));
				break;
			}
			}
		} catch (Exception ex) {
			AndroidOperations.AppendLog("RemoveSaleStep1:" + ex.getMessage());

			setResult(RESULT_FIRST_USER);
			finish();
		}
	}

	private void RemoveSaleActionStep1() {
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();

		params.put("deviceid", AndroidOperations.DeviceID);

		try {
			String response = clientRest.webGet("CancelSaleStep1/", params);

			if (response == null || response == "") {
				AndroidOperations.AppendLog("Restarting from RemoveSale Step1");

				setResult(RESULT_FIRST_USER);
				finish();
			}

			GenericResult resp = new Gson().fromJson(response,
					GenericResult.class);

			if (resp.Result == 0)
				RemoveSaleAsk();
			else if (resp.Result == 1) {
				setResult(RESULT_OK);
				finish();
			}

		} catch (Exception ex) {
			AndroidOperations.AppendLog("RemoveSale Step1:" + ex.getMessage());

			setResult(RESULT_FIRST_USER);
			finish();
		}

	}

	private void RemoveSaleActionStep2() {
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();

		params.put("deviceid", AndroidOperations.DeviceID);

		try {
			String response = clientRest.webGet("CancelSaleStep2/", params);

			if (response == null || response == "") {
				AndroidOperations.AppendLog("Restart from RemoveSaleStep2");

				setResult(RESULT_FIRST_USER);
				finish();
			}

			GenericResult resp = new Gson().fromJson(response,
					GenericResult.class);

			if (resp.Result == 1) {
				setResult(RESULT_OK);
				finish();
			} else if (resp.Result == 0) {

				// TODO SALE with prepay or lends, i have to accpet it
			}
		} catch (Exception ex) {
			AndroidOperations.AppendLog("RemoveSaleStep2:" + ex.getMessage());

			setResult(RESULT_FIRST_USER);
			finish();
		}
	}

	private void RemoveSaleAsk() {
		DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() {

			public void onClick(DialogInterface dialog, int which) {
				switch (which) {
				case DialogInterface.BUTTON_POSITIVE:
					RemoveSaleActionStep2();
					break;

				case DialogInterface.BUTTON_NEGATIVE:
					// No button clicked
					break;
				}
			}
		};

		AlertDialog.Builder builder = new AlertDialog.Builder(
				ShowRegisterAct.this);
		builder.setIcon(R.drawable.ic_dialog_icon);
		builder.setMessage(R.string.ShowRegisterAskCancel)
				.setPositiveButton(R.string.Yes, dialogClickListener)
				.setNegativeButton(R.string.No, dialogClickListener)
				.setCancelable(false).show();
	}

	private void AskDoChangeTableSale() {
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();

		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("permissionid",
				String.valueOf(TypePermissions.PER_TABLE_TRANSFER));

		try {
			String response = clientRest.webGet("GetPermission/", params);

			if (response == null || response == "") {
				AndroidOperations
						.AppendLog("Restarting from AskDoChangeTableSale");

				setResult(RESULT_FIRST_USER);
				finish();
			}

			GenericResult resp = new Gson().fromJson(response,
					GenericResult.class);

			switch (CheckPermission(resp, 2)) {
			case 1:
				DoChangeTableSale_Action();
				break;
			case -1: {
				_andOP = new AndroidOperations(ShowRegisterAct.this);
				_andOP.ShowMessage(getString(R.string.Permissions),
						getString(R.string.AccessDenied));
				break;
			}
			}
		} catch (Exception ex) {
			AndroidOperations.AppendLog("AskDoChangeTableSale:"
					+ ex.getMessage());

			setResult(RESULT_FIRST_USER);
			finish();
		}
	}

	private void DoChangeTableSale_Action() {
		if (AndroidOperations.OrderData.SaleLines.size() > 0) {
			Intent i = new Intent(ShowRegisterAct.this, AskTableChangeAct.class);
			startActivityForResult(i, 3);
		} else {
			_andOP.ShowMessage(ShowRegisterAct.this,
					getString(R.string.Warning), getString(R.string.EmptyLines));
		}
	}

	private void AskRemoveLine() {
		if (m_adapter.getPosition() < m_adapter.getCount()
				&& _registerLines.getItemAtPosition(m_adapter.getPosition()) != null) {
			int lines = m_adapter.getCountNoMenuParts();

			if (lines == 1) {
				Toast.makeText(ShowRegisterAct.this,
						R.string.CantRemoveLastLine, Toast.LENGTH_SHORT).show();

			} else {
				FreezeSalesOrderLine line = (FreezeSalesOrderLine) _registerLines
						.getItemAtPosition(m_adapter.getPosition());

				if (!line.PrintedInKitchen) {
					RestClient clientRest = new RestClient(Parameters.WcfUrl);
					Map<String, String> params = new HashMap<String, String>();

					params.put("deviceid", AndroidOperations.DeviceID);
					params.put("permissionid",
							String.valueOf(TypePermissions.PER_DELETE_LINE));

					try {
						String response = clientRest.webGet("GetPermission/",
								params);

						if (response == null || response == "") {
							AndroidOperations
									.AppendLog("Restarting from AskRemoveLine");

							_pressed = false;
							setResult(RESULT_FIRST_USER);
							finish();
						}

						GenericResult resp = new Gson().fromJson(response,
								GenericResult.class);

						switch (CheckPermission(resp, 1)) {
						case 1:
							RemoveLineAction();
							break;
						case -1: {
							_pressed = false;
							_andOP = new AndroidOperations(ShowRegisterAct.this);
							_andOP.ShowMessage(getString(R.string.Permissions),
									getString(R.string.AccessDenied));
							break;
						}
						}
					} catch (Exception ex) {
						AndroidOperations.AppendLog("AskRemoveLine:"
								+ ex.getMessage());

						_pressed = false;
						setResult(RESULT_FIRST_USER);
						finish();
					}

				} else {
					CheckDeleteLinePrinted();
				}
			}

		} else {
			Toast.makeText(ShowRegisterAct.this, R.string.SelectLine,
					Toast.LENGTH_SHORT).show();
		}
	}

	private void CheckDeleteLinePrinted() {
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();

		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("permissionid",
				String.valueOf(TypePermissions.PER_DELETE_LINE_AK));

		try {
			String response = clientRest.webGet("GetPermission/", params);

			if (response == null || response == "") {
				AndroidOperations
						.AppendLog("Restarting from GP_CheckDeleteLinePrinted");

				setResult(RESULT_FIRST_USER);
				finish();
			}

			GenericResult resp = new Gson().fromJson(response,
					GenericResult.class);

			switch (CheckPermission(resp, 1)) {
			case 1:
				RemoveLineAction();
				break;

			case -1: {
				_pressed = false;
				_andOP = new AndroidOperations(ShowRegisterAct.this);
				_andOP.ShowMessage(getString(R.string.Permissions),
						getString(R.string.AccessDenied));
				break;
			}
			}
		} catch (Exception ex) {
			AndroidOperations.AppendLog("CheckDeleteLinePrinted:"
					+ ex.getMessage());

			setResult(RESULT_FIRST_USER);
			finish();
		}
	}

	public int CheckPermission(GenericResult result, int action) {

		if (result.Result == 1 || result.Result == -1)
			return result.Result;

		// Show Table Form
		Intent i = new Intent(ShowRegisterAct.this,
				RequestAccessPasswordAct.class);

		i.putExtra("password", result.Description);
		i.putExtra("action", action);

		startActivityForResult(i, 1);

		return 0;
	}

	private void RemoveLineAction() {
		DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() {

			public void onClick(DialogInterface dialog, int which) {
				switch (which) {
				case DialogInterface.BUTTON_POSITIVE:
					RemoveLineActionStep2();
					break;

				case DialogInterface.BUTTON_NEGATIVE:
					_pressed = false;
					break;
				}
			}
		};

		AlertDialog.Builder builder = new AlertDialog.Builder(
				ShowRegisterAct.this);
		builder.setIcon(R.drawable.ic_dialog_icon);
		builder.setMessage(R.string.ShowRegisterAskRemoveLine)
				.setPositiveButton(R.string.Yes, dialogClickListener)
				.setNegativeButton(R.string.No, dialogClickListener)
				.setCancelable(false).show();
	}

	private void RemoveLineActionStep2() {
		if (_registerLines.getItemAtPosition(m_adapter.getPosition()) != null) {
			// REMOVE ON GRID

			FreezeSalesOrderLine lineToDelete = (FreezeSalesOrderLine) _registerLines
					.getItemAtPosition(m_adapter.getPosition());

			// REMOVE WEB SERVICE
			RestClient clientRest = new RestClient(Parameters.WcfUrl);
			Map<String, String> params = new HashMap<String, String>();

			params.put("deviceid", AndroidOperations.DeviceID);
			params.put("lineNumber", String.valueOf(lineToDelete.IdLine));

			try {
				String response = clientRest.webGet("DeleteLine/", params);

				if (response == null || response == "") {
					AndroidOperations
							.AppendLog("Restarting from RemoveLineActionStep2");

					setResult(RESULT_FIRST_USER);
					finish();
				}

				GenericResult resp = new Gson().fromJson(response,
						GenericResult.class);

				if (!resp.SerialIdOk) {
					setResult(RESULT_FIRST_USER);
					finish();
				}

				if (lineToDelete.Menu > 0) {
					m_adapter.RemoveMenu(lineToDelete.Menu);
				} else
					m_adapter.remove(lineToDelete);

				m_adapter.notifyDataSetChanged();

				AndroidOperations.OrderData.SaleLines
						.remove(lineToDelete.IdLine);

				GetOrderTotal();
			} catch (Exception e) {
				AndroidOperations.AppendLog("RemoveLineActionStep2:"
						+ e.getMessage());

				setResult(RESULT_FIRST_USER);
				finish();
			}
		}

		_pressed = false;
	}

	private void MakeInvite() {
		if (_pressed)
			return;

		_pressed = true;

		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();

		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("permissionid",
				String.valueOf(TypePermissions.PER_INVITE_LINE));

		try {
			FreezeSalesOrderLine line = (FreezeSalesOrderLine) _registerLines
					.getItemAtPosition(m_adapter.getPosition());

			if (line.Invited) {
				MakeInvite_Action(false);
			}

			else {
				String response = clientRest.webGet("GetPermission/", params);

				if (response == null || response == "") {
					AndroidOperations
							.AppendLog("Restarting from GP_MakeInvite");

					setResult(RESULT_FIRST_USER);
					finish();
				}

				GenericResult resp = new Gson().fromJson(response,
						GenericResult.class);

				int respPerm = CheckPermission(resp, 5);

				switch (respPerm) {
				case 1:
					MakeInvite_Action(true);
					break;
				case -1: {
					_andOP = new AndroidOperations(ShowRegisterAct.this);
					_andOP.ShowMessage(getString(R.string.Permissions),
							getString(R.string.AccessDenied));
					break;
				}
				}
			}
		} catch (Exception ex) {
			AndroidOperations.AppendLog("MakeInvite:" + ex.getMessage());

			setResult(RESULT_FIRST_USER);
			finish();
		}

		_pressed = false;
	}

	private void MakeInvite_Action(boolean isInvited) {
		_pressed = true;

		if (_registerLines.getItemAtPosition(m_adapter.getPosition()) != null) {
			FreezeSalesOrderLine line = (FreezeSalesOrderLine) _registerLines
					.getItemAtPosition(m_adapter.getPosition());

			if (line.Menu > 0 && !line.MenuPart) {
				m_adapter.ChangeInvitation(line.Menu, isInvited);
			} else {
				line.Invited = isInvited;
			}

			m_adapter.notifyDataSetChanged();

			// REMOVE WEB SERVICE
			RestClient clientRest = new RestClient(Parameters.WcfUrl);
			Map<String, String> params = new HashMap<String, String>();

			params.put("deviceid", AndroidOperations.DeviceID);
			params.put("lineNumber", String.valueOf(line.IdLine));
			params.put("state", String.valueOf(line.Invited));

			try {
				String response = clientRest.webGet("InviteLine/", params);

				if (response == null || response == "") {
					AndroidOperations
							.AppendLog("Restarting from MakeInvite_Action");

					setResult(RESULT_FIRST_USER);
					finish();

				}
				GenericResult resp = new Gson().fromJson(response,
						GenericResult.class);

				if (!resp.SerialIdOk) {
					setResult(RESULT_FIRST_USER);
					finish();
				}
			} catch (Exception e) {
				AndroidOperations.AppendLog("MakeInvite_Action:"
						+ e.getMessage());

				setResult(RESULT_FIRST_USER);
				finish();
			}
		}

		_pressed = false;

		GetOrderTotal();
	}

	private void AskCreateSubOrder() {
		if (AndroidOperations.OrderData.SaleLines.size() > 0) {
			DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() {

				public void onClick(DialogInterface dialog, int which) {
					switch (which) {
					case DialogInterface.BUTTON_POSITIVE:
						AskCreateSubOrder_Action();
						break;

					case DialogInterface.BUTTON_NEGATIVE:
						// No button clicked
						break;
					}
				}
			};

			AlertDialog.Builder builder = new AlertDialog.Builder(
					ShowRegisterAct.this);
			builder.setIcon(R.drawable.ic_dialog_icon);
			builder.setMessage(R.string.ShowRegisterAskCreateSubOrder)
					.setPositiveButton(R.string.Yes, dialogClickListener)
					.setNegativeButton(R.string.No, dialogClickListener)
					.setCancelable(false).show();
		}
	}

	private void AskCreateSubOrder_Action() {
		PDialog.show();

		Thread thread = new Thread() {
			public void run() {

				try {
					WcfOperations wcf = new WcfOperations();

					AndroidOperations.CreateNewSubOrderNumber = wcf
							.wcf_MakeSend(true);

					setResult(RESULT_OK);
					finish();
					PDialog.dismiss();
				} catch (Exception e) {
					AndroidOperations.AppendLog("AskCreateSubOrder_Action:"
							+ e.getMessage());

					setResult(RESULT_FIRST_USER);
					finish();
				}
			}
		};

		thread.start();
	}

	private double GetOrderTotal() {
		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();

		params.put("deviceid", AndroidOperations.DeviceID);

		try {
			String response = clientRest.webGet("GetOrderTotal/", params);

			if (response == null || response == "") {
				AndroidOperations.AppendLog("Restarting from GetOrderTotal:");

				setResult(RESULT_FIRST_USER);
				finish();
				return 0;
			} else {
				GenericResultDouble resp = new Gson().fromJson(response,
						GenericResultDouble.class);

				_txtTotal.setText(Parameters.CurrentCurrencySymbol + " "
						+ resp.Description);

				return resp.Value;
			}
		} catch (Exception e) {
			e.printStackTrace();

			AndroidOperations.AppendLog("GetOrderTotal:" + e.getMessage());

			setResult(RESULT_FIRST_USER);
			finish();
			return 0;
		}
	}

	public void EditAmount(FreezeSalesOrderLine l) {
		try {
			if (_pressed)
				return;

			_pressed = true;

			_timerPressed.start();

			if (l != null) {
				RestClient clientRest = new RestClient(Parameters.WcfUrl);
				Map<String, String> params = new HashMap<String, String>();

				params.put("deviceid", AndroidOperations.DeviceID);
				params.put("permissionid",
						String.valueOf(TypePermissions.PER_CHANGE_AMOUNT));

				try {
					String response = clientRest.webGet("GetPermission/",
							params);

					if (response == null || response == "") {
						_timerPressed.cancel();
						AndroidOperations
								.AppendLog("Restarting from GP_EditAmount");

						setResult(RESULT_FIRST_USER);
						finish();
					}

					GenericResult resp = new Gson().fromJson(response,
							GenericResult.class);

					int respPerm = CheckPermission(resp, 7);

					switch (respPerm) {
					case 1:
						DoChangeQuantityActivity(l.Quantity);
						break;
					case -1: {

						_andOP = new AndroidOperations(ShowRegisterAct.this);
						_andOP.ShowMessage(getString(R.string.Permissions),
								getString(R.string.AccessDenied));
						break;
					}
					}
				} catch (Exception ex) {
					_timerPressed.cancel();
					AndroidOperations
							.AppendLog("EditAmount:" + ex.getMessage());

					setResult(RESULT_FIRST_USER);
					finish();
				}
			} else {
				_andOP = new AndroidOperations(ShowRegisterAct.this);
				_andOP.ShowMessage(getString(R.string.Error),
						getString(R.string.ShowRegisterChangeQtyError));
			}
		} catch (Exception ex) {
			_andOP = new AndroidOperations(ShowRegisterAct.this);
			_andOP.ShowMessage(getString(R.string.Error),
					getString(R.string.ShowRegisterChangeQtyError));
		}
	}

	public void ChangeCourse() {
		try {
			if (_pressed)
				return;

			_pressed = true;

			_timerPressed.start();

			if (_registerLines.getItemAtPosition(m_adapter.getPosition()) == null) {
				_andOP = new AndroidOperations(ShowRegisterAct.this);
				_andOP.ShowMessage(getString(R.string.Error),
						getString(R.string.ShowRegisterChangeQtyError));

			} else {
				DoChangeCourse();
			}
		} catch (Exception ex) {
			_andOP = new AndroidOperations(ShowRegisterAct.this);
			_andOP.ShowMessage(getString(R.string.Error),
					getString(R.string.ShowRegisterChangeQtyError));
		}
	}

	private void DoChangeQuantityActivity(double quantity) {
		Intent i = new Intent(ShowRegisterAct.this, AskQuantityAct.class);

		i.putExtra("quantity", quantity);

		startActivityForResult(i, 0);
	}

	private void DoChangeCourse() {
		Intent i = new Intent(ShowRegisterAct.this, SelectDinnerPassAct.class);

		startActivityForResult(i, 4);
	}

	public void SetCurrentLine(String text) {
		if (text != null && text.length() > 24)
			text = text.substring(0, 23);

		_txtCurrentLine.setText(text);
	}

	private void AskCancelSale() {
		if (_pressed)
			return;

		_pressed = true;

		if (_orderChanged) {
			DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() {

				public void onClick(DialogInterface dialog, int which) {
					switch (which) {

					case DialogInterface.BUTTON_POSITIVE:
						yesCancelSale();
						break;

					case DialogInterface.BUTTON_NEGATIVE:
						_pressed = false;
						break;
					default:
						_pressed = false;
						break;
					}
				}
			};

			AlertDialog.Builder builder = new AlertDialog.Builder(
					ShowRegisterAct.this);
			builder.setIcon(R.drawable.ic_dialog_icon);
			builder.setMessage(R.string.ShowRegisterAskCancelChanges)
					.setPositiveButton(R.string.Yes, dialogClickListener)
					.setNegativeButton(R.string.No, dialogClickListener)
					.setCancelable(false).show();

		} else
			yesCancelSale();

	}

	private void ShowArticles() {
		_btnArticles.setEnabled(false);
		_btnLines.setEnabled(true);
		_btnExpand.setEnabled(false);

		_frmLines.setVisibility(View.GONE);
		_frmArticles.setVisibility(View.VISIBLE);
		_btnExpand.setEnabled(true);

	}

	private void ShowLines() {
		_btnExpand.setEnabled(false);

		_btnArticles.setEnabled(true);
		_btnLines.setEnabled(false);

		_frmArticles.setVisibility(View.GONE);
		_frmLines.setVisibility(View.VISIBLE);

		_btnExpand.setEnabled(true);

		_registerLines.setSelection(CurrentPosition);

	}

	private void yesCancelSale() {
		setResult(RESULT_CANCELED);
		finish();
	}

	@Override
	public void onBackPressed() {
		// do something on back.
		AskCancelSale();
	}

	private void AskArticlePrice(ItemDataNode idItem) {
		Intent i = new Intent(ShowRegisterAct.this, AskPriceAct.class);

		_selectedItem = idItem;

		startActivityForResult(i, 6);
	}

	public void AskArticlePrice(int position) {
		if (_pressed)
			return;

		_pressed = true;

		_timerPressed.start();

		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();

		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("permissionid",
				String.valueOf(TypePermissions.PER_CHANGE_PRICE));

		try {
			String response = clientRest.webGet("GetPermission/", params);

			if (response == null || response == "") {
				AndroidOperations.AppendLog("Restarting from AskArticlePrice");

				setResult(RESULT_FIRST_USER);
				finish();
			}

			GenericResult resp = new Gson().fromJson(response,
					GenericResult.class);

			int respPerm = CheckPermission(resp, 8);

			switch (respPerm) {
			case 1: {
				ItemDataNode item = new ItemDataNode();
				item.Number = -1;
				AskArticlePrice(item);
				break;
			}
			case -1: {
				_andOP = new AndroidOperations(ShowRegisterAct.this);
				_andOP.ShowMessage(getString(R.string.Permissions),
						getString(R.string.AccessDenied));
				break;
			}
			}

		} catch (Exception ex) {
			AndroidOperations.AppendLog("AskArticlePrice:" + ex.getMessage());

			setResult(RESULT_FIRST_USER);
			finish();
		}
	}

	public void AskArticleWeight(int position) {
		if (_pressed)
			return;

		_pressed = true;

		_timerPressed.start();

		RestClient clientRest = new RestClient(Parameters.WcfUrl);
		Map<String, String> params = new HashMap<String, String>();

		params.put("deviceid", AndroidOperations.DeviceID);
		params.put("permissionid",
				String.valueOf(TypePermissions.PER_CHANGE_AMOUNT));

		try {
			String response = clientRest.webGet("GetPermission/", params);

			if (response == null || response == "") {
				AndroidOperations.AppendLog("Restarting from AskArticlePrice");

				setResult(RESULT_FIRST_USER);
				finish();
			}

			GenericResult resp = new Gson().fromJson(response,
					GenericResult.class);

			int respPerm = CheckPermission(resp, 8);

			switch (respPerm) {
			case 1: {
				ItemDataNode item = new ItemDataNode();
				item.Number = -1;
				AskArticlePrice(item);
				break;
			}
			case -1: {
				_andOP = new AndroidOperations(ShowRegisterAct.this);
				_andOP.ShowMessage(getString(R.string.Permissions),
						getString(R.string.AccessDenied));
				break;
			}
			}

		} catch (Exception ex) {
			AndroidOperations.AppendLog("AskArticlePrice:" + ex.getMessage());

			setResult(RESULT_FIRST_USER);
			finish();
		}
	}

	public void onActivityResult(int requestCode, int resultCode, Intent intent) {
		if (PDialog != null)
			PDialog.dismiss();

		if (resultCode == RESULT_FIRST_USER) {
			AndroidOperations.AppendLog("BackToMain FROM:" + this.toString());

			setResult(RESULT_FIRST_USER);
			finish();
			return;
		}

		if (requestCode == 0) // Change Qty
		{
			if (resultCode == RESULT_OK) {
				_orderChanged = true;
				double newQty = intent.getDoubleExtra("newQty", 1);

				int position = m_adapter.getPosition();

				FreezeSalesOrderLine l = (FreezeSalesOrderLine) _registerLines
						.getItemAtPosition(position);

				if (l.Menu > 0 && Parameters.TCMenuCourseControl) {
					m_adapter.ChangeQuantityMenu(l.Menu, newQty);
				} else if (l.PromoHeader > -1) {
					FreezeSalesOrderLine lhead = (FreezeSalesOrderLine) _registerLines
							.getItemAtPosition(l.PromoHeader);

					if (lhead.Quantity < newQty) {
						_andOP = new AndroidOperations(ShowRegisterAct.this);
						_andOP.ShowMessage("MAL", "MAL");
						return;
					} else
						l.Quantity = newQty;
				} else {
					for (int i = position; i < _registerLines.getCount(); i++) {

						FreezeSalesOrderLine promo = (FreezeSalesOrderLine) _registerLines
								.getItemAtPosition(i);

						if (promo.PromoHeader == l.IdLine
								&& newQty < promo.Quantity)
							promo.Quantity = newQty;

					}

					l.Quantity = newQty;
				}

				try

				{
					_wcf.ChangeQuantity(l.IdLine, newQty);
				} catch (Exception e) {
					AndroidOperations.AppendLog("ChangeQuantity:"
							+ e.getMessage());

					setResult(RESULT_FIRST_USER);
					finish();
				}

				m_adapter.notifyDataSetChanged();

				GetOrderTotal();
			}
		} else if (requestCode == 1) // Return from ask Password
		{
			if (resultCode == RESULT_OK) {
				_pressed = false;

				Bundle extras = intent.getExtras();

				int action = extras.getInt("action", 0);

				if (action == 1)
					RemoveLineAction();
				else if (action == 2)
					DoChangeTableSale_Action();
				else if (action == 3)
					RemoveSaleActionStep1();
				else if (action == 4) {
					PDialog.setMessage(_context.getText(R.string.Processing));
					PDialog.setIndeterminate(true);
					PDialog.show();

					_andOP.MakeActionPaymentStep1(ShowRegisterAct.this,
							_handlerProcessing);
				} else if (action == 5)
					MakeInvite_Action(true);
				else if (action == 6)
					MakePayment();
				else if (action == 7)
					DoChangeQuantityActivity(0);
				else if (action == 8) {
					ItemDataNode item = new ItemDataNode();
					item.Number = -1;
					AskArticlePrice(item);
				}
			}
		} else if (requestCode == 2) // Ask TableMembers
		{
			Bundle extras = intent.getExtras();

			boolean newsale = extras.getBoolean("newsale", false);

			if (resultCode == RESULT_OK) {
				_orderChanged = true;
				int members = extras.getInt("tablemembers", 1);

				if (members < 0)
					members = 0;

				AndroidOperations.OrderData.TableMembers = members;

				// REMOVE WEB SERVICE
				RestClient clientRest = new RestClient(Parameters.WcfUrl);
				Map<String, String> params = new HashMap<String, String>();

				params.put("deviceid", AndroidOperations.DeviceID);
				params.put("tablemembers", String.valueOf(members));
				params.put("newsale", String.valueOf(newsale));

				AcceptArticleClicks = false;
				ActivateGridDelayed();

				try {
					String response = clientRest.webGet("SetTableMembers/",
							params);

					if (response == null || response == "") {
						AndroidOperations
								.AppendLog("Restarting from OnactRes. ActTableM:");

						setResult(RESULT_FIRST_USER);
						finish();
					}

					Type collectionType = new TypeToken<List<ItemDataNode>>() {
					}.getType();

					List<ItemDataNode> resp = new Gson().fromJson(response,
							collectionType);

					if (resp != null && members > 0) {
						AcceptArticleClicks = true;

						if (newsale) {
							for (int i = 0; i < resp.size(); i++) {
								EventDataClick(resp.get(i), null, members, true);
							}

							if (Parameters.TCRequestTableName) {
								AskTableName();
							}
						} else {
							for (int i = 0; i < AndroidOperations.OrderData.SaleLines
									.size(); i++) {
								FreezeSalesOrderLine line = AndroidOperations.OrderData.SaleLines
										.get(i);

								if (_wcf.IsDefaultArticle(line.Article)) {
									line.Quantity = members;

									_wcf.ChangeQuantity(line.IdLine, members);
								}
							}

							m_adapter.notifyDataSetChanged();
						}

						AndroidOperations.TableMember = members;
					}
				} catch (Exception e) {
					AndroidOperations.AppendLog("OnactRes. ActTableM:"
							+ e.getMessage());

					setResult(RESULT_FIRST_USER);
					finish();
				}
			} else if (resultCode == RESULT_CANCELED && newsale) {
				setResult(RESULT_CANCELED);
				finish();
			}
		} else if (requestCode == 3) // Return from TABLE TRANSFER
		{
			if (resultCode == RESULT_OK) {
				setResult(RESULT_OK);
				finish();
			}

		}
		if (requestCode == 4) // Change Course
		{
			if (resultCode == RESULT_OK) {
				_orderChanged = true;
				int newCourse = intent.getIntExtra("newCourse", 1);

				FreezeSalesOrderLine l = (FreezeSalesOrderLine) _registerLines
						.getItemAtPosition(m_adapter.getPosition());

				l.CourseNumber = newCourse;

				try {
					_wcf.wcf_DoChangeCourse(l.IdLine, newCourse);
				} catch (Exception e) {
					setResult(RESULT_FIRST_USER);
					finish();
				}

				m_adapter.notifyDataSetChanged();

				AcceptArticleClicks = false;
				ActivateGridDelayed();
			}
		} else if (requestCode == 5) // Return from payment;
		{
			if (resultCode == RESULT_OK) {
				setResult(RESULT_OK);
				finish();
			}

		} else if (requestCode == 6) // Return Ask Price Article
		{
			if (resultCode == RESULT_OK) {
				if (_selectedItem != null) {
					_orderChanged = true;

					double newPrice = intent.getDoubleExtra("newPrice", 0);

					if (_selectedItem.Number > -1) {
						_selectedItem.SetPrice(
								AndroidOperations.CurrentTableTariff, newPrice);

						if (_selectedItem.HasPieces)
							AskArticlePieces(_selectedItem);
						else

						if (_selectedItem.HasOptionsAutoShow
								&& _selectedItem.HasChildsOptions)
							AskArticleOptionals(_selectedItem);

						else if (_selectedItem.HasModifiersAutoShow)
							AskArticleModifiers(_selectedItem);
						else {
							MakeAddLine(_maxID, _selectedItem, 1,
									new ArrayList<Integer>(),
									new ArrayList<String>(),
									Parameters.OptionsArticle, true, "");

							if (_selectedItem.HasPromotions) {
								AcceptArticleClicks = false;

								AskArticlePromotion(_selectedItem, false);
							}

							_selectedItem = null;
						}
					} else {
						FreezeSalesOrderLine l = (FreezeSalesOrderLine) _registerLines
								.getItemAtPosition(m_adapter.getPosition());

						l.Price = newPrice;

						l.SetZeroPriceOptions();

						m_adapter.notifyDataSetChanged();

						try {
							_wcf.changePrice(l.IdLine, newPrice);
						} catch (Exception e) {

							AndroidOperations.AppendLog("AskArticlePrice:"
									+ e.getMessage());

							setResult(RESULT_FIRST_USER);
							finish();
						}

						GetOrderTotal();
					}

					AcceptArticleClicks = false;
					ActivateGridDelayed();
				}
			} else
				AcceptArticleClicks = true;
		} else if (requestCode == 7) // Return Ask Modifiers
		{
			if (resultCode == RESULT_OK) {

				if (_selectedItem != null) {
					_orderChanged = true;

					ArrayList<Integer> modifiersSelected = intent
							.getIntegerArrayListExtra("modifiers");
					ArrayList<String> modifiersStrSelected = intent
							.getStringArrayListExtra("modifiersString");
					String freeText = intent.getStringExtra("freeText");

					int lineID = intent.getIntExtra("idLine", -1); // if -1 i
																	// have to
																	// add line,
																	// esle its
																	// a update

					if (lineID == -1) // AddLine
					{
						MakeAddLine(_maxID, _selectedItem, 1,
								modifiersSelected, modifiersStrSelected,
								Parameters.OptionsArticle, true, freeText);

						if (Parameters.OptionsArticle != null)
							Parameters.OptionsArticle.clear();

						if (_selectedItem.HasPromotions) {
							AcceptArticleClicks = false;

							AskArticlePromotion(_selectedItem, false);
						}
					} else {
						int index = modifiersSelected.indexOf(-1);

						Log.i("getView()", "UpdateModifiers_Start");
						String freeModText = "";

						if (index > -1)
							freeModText = modifiersStrSelected.get(index);

						try {
							_wcf.UpdateModifiers(lineID, modifiersSelected,
									freeModText);
						} catch (Exception e) {

							AndroidOperations.AppendLog("UpdateModifiers:"
									+ e.getMessage());

							setResult(RESULT_FIRST_USER);
							finish();
						}

						Log.i("getView()", "UpdateModifiers_End");

						FreezeSalesOrderLine line = AndroidOperations.OrderData.SaleLines
								.get(lineID);

						ArrayList<FreezeSalesOrderLineModifier> lstMod = UpdateModifiers(
								lineID, modifiersSelected, modifiersStrSelected);

						line.Modifiers = new FreezeSalesOrderLineModifier[lstMod
								.size()];

						Iterator<FreezeSalesOrderLineModifier> i = lstMod
								.iterator();

						int j = 0;
						while (i.hasNext()) {
							FreezeSalesOrderLineModifier l = (FreezeSalesOrderLineModifier) i
									.next();

							line.Modifiers[j] = l;
							j++;
						}
					}

					m_adapter.notifyDataSetChanged();

					_selectedItem = null;

					GetOrderTotal();

					AcceptArticleClicks = false;
					ActivateGridDelayed();
				}
			}
		} else if (requestCode == 8) // Return Ask Optionals
		{
			if (resultCode == RESULT_OK) {
				if (_selectedItem != null) {
					_orderChanged = true;

					int lineID = intent.getIntExtra("idLine", -1); // if -1 i
																	// have to
																	// add line,
																	// esle its
																	// a update
					String newDescription = intent
							.getStringExtra("newdescription");
					double newPrice = intent.getDoubleExtra("newPrice", 0);

					if (lineID == -1) // AddLine
					{
						_selectedItem.TicketText = newDescription;

						if (_selectedItem.HasModifiersAutoShow) {
							AskArticleModifiers(_selectedItem);
						} else {
							MakeAddLine(_maxID, _selectedItem, 1,new ArrayList<Integer>(),new ArrayList<String>(),Parameters.OptionsArticle, true, "");

							Parameters.OptionsArticle.clear();

							if (_selectedItem.HasPromotions) {
								AcceptArticleClicks = false;

								AskArticlePromotion(_selectedItem, false);
							}

							_selectedItem = null;

							GetOrderTotal();

							Parameters.OptionsArticle.clear();
							AcceptArticleClicks = false;
							ActivateGridDelayed();
						}
					} else {
						try {
							_wcf.UpdateOptionals(lineID,
									Parameters.OptionsArticle);
						} catch (Exception e) {

							AndroidOperations.AppendLog("UpdateOptionals:"
									+ e.getMessage());

							setResult(RESULT_FIRST_USER);
							finish();
						}
						FreezeSalesOrderLine line = AndroidOperations.OrderData.SaleLines
								.get(lineID);

						ArrayList<FreezeSalesOrderLineOption> lstOpt = UpdateOptions(lineID);

						line.Description = newDescription;
						line.Options = new FreezeSalesOrderLineOption[lstOpt
								.size()];
						line.Price = newPrice;

						Iterator<FreezeSalesOrderLineOption> i = lstOpt.iterator();

						int j = 0;

						while (i.hasNext()) {
							FreezeSalesOrderLineOption l = (FreezeSalesOrderLineOption) i.next();

							line.Options[j] = l;
							j++;
						}

						if (line.MultiOptionals != 1 && line.Options.length > 0) {
							line.SetZeroPriceOptions();
						}

						m_adapter.notifyDataSetChanged();

						_selectedItem = null;

						GetOrderTotal();

						Parameters.OptionsArticle.clear();
						AcceptArticleClicks = false;
						ActivateGridDelayed();
					}

				}
			} else {
				AcceptArticleClicks = true;
			}
		} else if (requestCode == 9) // Back from menu article
		{
			if (resultCode == RESULT_OK) {
				if (AndroidOperations.OrderData.CurrentFreezeLines != null
						&& AndroidOperations.OrderData.CurrentFreezeLines
								.size() > 0) {
					List<FreezeSalesOrderLine> resp = _wcf.GetLinesInMemory();

					m_adapter.clear();
					AndroidOperations.OrderData.SaleLines.clear();

					Iterator<FreezeSalesOrderLine> i = resp.iterator();

					AndroidOperations.OrderData.SaleLines.clear();

					while (i.hasNext()) {
						FreezeSalesOrderLine l = (FreezeSalesOrderLine) i
								.next();

						m_adapter.add(l);

						AndroidOperations.OrderData.SaleLines.put(l.IdLine, l);
					}
				}

				m_adapter.notifyDataSetChanged();

				if (_selectedItem.HasPromotions) {
					AcceptArticleClicks = false;

					AskArticlePromotion(_selectedItem, true);
				}

				AcceptArticleClicks = false;
				ActivateGridDelayed();

				_selectedItem = null;

				GetOrderTotal();
			} else {
				AcceptArticleClicks = false;
				ActivateGridDelayed();

				_selectedItem = null;
			}
		} else if (requestCode == 10) // Return from select pay or preticket;
		{
			if (resultCode == RESULT_OK) {
				setResult(RESULT_OK);
				finish();
			}
		} else if (requestCode == 11) {
			if (resultCode == RESULT_OK) {
				_wcf.wcf_MakeSend(false);

				setResult(RESULT_OK);
				finish();
			}
		} else if (requestCode == 12) // return from ask pieces
		{
			if (resultCode == RESULT_OK) {
				if (_selectedItem != null) {
					_orderChanged = true;

					double newPrice = intent.getDoubleExtra("newPrice", 0);
					int piece = intent.getIntExtra("piece", -1);
					boolean dontShowOptionals = intent.getBooleanExtra(
							"dontshowoptionals", false);
					String newDescription = intent
							.getStringExtra("newdescription");

					if (_selectedItem.Number > -1) {
						_selectedItem.SetPrice(
								AndroidOperations.CurrentTableTariff, newPrice);
						_selectedItem.Piece = piece;
						_selectedItem.TicketText = newDescription;

						if (_selectedItem.Menu)
							ShowMenu(_selectedItem.Number,
									_selectedItem.Description1 + " "
											+ _selectedItem.Description2 + " "
											+ _selectedItem.Description3 + " "
											+ _selectedItem.Description4,
									piece, newPrice);
						else if (_selectedItem.HasOptionsAutoShow
								&& _selectedItem.HasChildsOptions
								&& !dontShowOptionals) {
							AskArticleOptionals(_selectedItem);
						} else if (_selectedItem.HasModifiersAutoShow)
							AskArticleModifiers(_selectedItem);
						else {
							MakeAddLine(_maxID, _selectedItem, 1,
									new ArrayList<Integer>(),
									new ArrayList<String>(),
									Parameters.OptionsArticle, true, "");

							if (_selectedItem.HasPromotions) {
								AcceptArticleClicks = false;

								AskArticlePromotion(_selectedItem, false);
							}

							_selectedItem = null;
						}
					} else {
						FreezeSalesOrderLine l = (FreezeSalesOrderLine) _registerLines
								.getItemAtPosition(m_adapter.getPosition());

						l.Price = newPrice;
						l.Piece = piece;
						l.Description = newDescription;

						l.SetZeroPriceOptions();

						m_adapter.notifyDataSetChanged();

						try {
							_wcf.changeSetPiece(l.IdLine, newPrice, piece);
						} catch (Exception e) {

							AndroidOperations.AppendLog("SetPiece:"
									+ e.getMessage());

							setResult(RESULT_FIRST_USER);
							finish();
						}

					}

					GetOrderTotal();

					AcceptArticleClicks = false;
					ActivateGridDelayed();
				}
			}
		} else if (requestCode == 13) // Return Ask Promotions
		{
			AcceptArticleClicks = false;
			ActivateGridDelayed();

			if (resultCode == RESULT_OK) {
				List<FreezeSalesOrderLine> resp = _wcf.GetLinesInMemory();

				m_adapter.clear();
				AndroidOperations.OrderData.SaleLines.clear();

				Iterator<FreezeSalesOrderLine> i = resp.iterator();

				AndroidOperations.OrderData.SaleLines.clear();

				while (i.hasNext()) {
					FreezeSalesOrderLine l = (FreezeSalesOrderLine) i.next();

					m_adapter.add(l);

					AndroidOperations.OrderData.SaleLines.put(l.IdLine, l);
				}

				_selectedItem = null;

				GetOrderTotal();
			}
		} else if (requestCode == 14) // Return Ask KG
		{
			if (resultCode == RESULT_OK) {
				if (_selectedItem != null) {
					_orderChanged = true;

					int newKG = intent.getIntExtra("newKG", 0);

					if (_selectedItem.Number > -1) {
						_selectedItem.SetKG(newKG);

						if (_selectedItem.HasPieces)
							AskArticlePieces(_selectedItem);
						else if (_selectedItem.HasOptionsAutoShow
								&& _selectedItem.HasChildsOptions)
							AskArticleOptionals(_selectedItem);
						else if (_selectedItem.HasModifiersAutoShow)
							AskArticleModifiers(_selectedItem);
						else {
							MakeAddLine(_maxID, _selectedItem, 1,
									new ArrayList<Integer>(),
									new ArrayList<String>(),
									Parameters.OptionsArticle, true, "");

							if (_selectedItem.HasPromotions) {
								AcceptArticleClicks = false;

								AskArticlePromotion(_selectedItem, false);
							}

							_selectedItem = null;
						}
					} else {
						FreezeSalesOrderLine l = (FreezeSalesOrderLine) _registerLines
								.getItemAtPosition(m_adapter.getPosition());

						try {
							_wcf.ChangeWeight(l.IdLine, newKG);
						} catch (Exception e) {
							AndroidOperations.AppendLog("AskArticleWeight:"
									+ e.getMessage());

							setResult(RESULT_FIRST_USER);
							finish();
						}
					}

					/***********************/

					List<FreezeSalesOrderLine> resp = _wcf.GetLinesInMemory();

					m_adapter.clear();
					AndroidOperations.OrderData.SaleLines.clear();

					Iterator<FreezeSalesOrderLine> i = resp.iterator();

					AndroidOperations.OrderData.SaleLines.clear();

					while (i.hasNext()) {
						FreezeSalesOrderLine l = (FreezeSalesOrderLine) i
								.next();

						m_adapter.add(l);

						AndroidOperations.OrderData.SaleLines.put(l.IdLine, l);
					}

					_selectedItem = null;

					GetOrderTotal();

					/*********************/

					AcceptArticleClicks = false;
					ActivateGridDelayed();
				}
			} else
				AcceptArticleClicks = true;
		} else if (requestCode == 15) // Return From Add Preorder
		{
			if (resultCode == RESULT_OK) {
				List<FreezeSalesOrderLine> resp = _wcf.GetLinesInMemory();

				m_adapter.clear();
				AndroidOperations.OrderData.SaleLines.clear();

				Iterator<FreezeSalesOrderLine> i = resp.iterator();

				AndroidOperations.OrderData.SaleLines.clear();

				while (i.hasNext()) {
					FreezeSalesOrderLine l = (FreezeSalesOrderLine) i.next();

					m_adapter.add(l);

					AndroidOperations.OrderData.SaleLines.put(l.IdLine, l);
				}

				GetOrderTotal();
			}
		} else if (requestCode == 16) // Return From AskTableName
		{
			if (resultCode == RESULT_OK) {
				Bundle extras = intent.getExtras();

				_orderChanged = true;
				String name = extras.getString("tablename");

				AcceptArticleClicks = false;
				ActivateGridDelayed();

				if (name.length() > 0) {
					RestClient clientRest = new RestClient(Parameters.WcfUrl);
					Map<String, String> params = new HashMap<String, String>();

					params.put("deviceid", AndroidOperations.DeviceID);
					params.put("tablename",
							AndroidOperations.AsUpperCaseFirstChar(name));

					try {
						String response = clientRest.webGet("SetTableName/",
								params);

						if (response == null || response == "") {
							AndroidOperations
									.AppendLog("Restarting from OnactRes. ActTableM");

							setResult(RESULT_FIRST_USER);
							finish();
						}
						Type collectionType = new TypeToken<GenericResult>() {
						}.getType();

						GenericResult resp = new Gson().fromJson(response,
								collectionType);

						if (resp != null) {
							AcceptArticleClicks = true;
							AndroidOperations.TableName = name;

							if (!AndroidOperations.TableName
									.equals(getString(R.string.ShowRegisterTable)
											+ " "
											+ AndroidOperations.CurrentTable))
								if (AndroidOperations.TableName.length() > 0) {
									String finalText = "/ "
											+ AndroidOperations
													.AsUpperCaseFirstChar(AndroidOperations.TableName);
									_txtTableNameCustom.setText(finalText);
								}

								else
									_txtTableNameCustom.setText("");
							else
								_txtTableNameCustom.setText("");
						} else {
							AndroidOperations
									.AppendLog("OnactRes. ActTableM:Error Null");

							setResult(RESULT_FIRST_USER);
							finish();

						}
					} catch (Exception e) {
						AndroidOperations.AppendLog("OnactRes. ActTableM:"
								+ e.getMessage());

						setResult(RESULT_FIRST_USER);
						finish();
					}
				} else {
					AcceptArticleClicks = true;
				}
			} else if (resultCode == RESULT_CANCELED) {
				setResult(RESULT_CANCELED);
				finish();
			}

		}

		_pressed = false;
	}
}
