package dst.net.droid;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;

import dst.net.jsonObj.FreezeSalesOrderLineOption;
import dst.net.jsonObj.ItemDataNode;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.TextView;

public class SingleOptionalAct extends Activity {
	
	private int _article;
	private int _idLine;
	private int _multiOptionals;
	private ItemDataNode _itemParent;
	private WcfOperations _wcf;
	private boolean _pressed;
	private Runnable _runnableDisableGrid;
	private Handler _handler;
	private int _piece;
	private boolean _inMenu;
	
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.singleptionals);
        
        Bundle extras = getIntent().getExtras();
        _article= extras.getInt("article",0);
        _idLine = extras.getInt("idLine",-1);
        _multiOptionals = extras.getInt("multioptional",1);
        _piece = extras.getInt("piece",-1);
        _inMenu= extras.getBoolean("inmenu",false);
        _pressed= true;
        _handler = new Handler();
        
        _runnableDisableGrid = new Runnable()
       	{ 
       		public void run() 
       		{  
       			_pressed = false;
       		}
       	};
        
        _wcf = new WcfOperations();
      
        try
        {
        	_itemParent = _wcf.GetArticleInfo(_article);
        }
        catch (Exception e) {
        	
        	AndroidOperations.AppendLog("SinGleOptional_GetArticleInfo:" + e.getMessage());
        	
        	setResult(RESULT_FIRST_USER);
        	finish();
		}
        
        Parameters.OptionsArticle = new ArrayList<FreezeSalesOrderLineOption>();
        
        final Button cancelButton = (Button) findViewById(R.id.singleOptBtnCancel);
        cancelButton.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {

				if (_pressed)
					return;
				
				_pressed = true;
				
				Parameters.OptionsArticle.clear();
				
				Bundle bundle = new Bundle();
	            bundle.putInt("idLine", _idLine);
	            Intent i = new Intent();
	            i.putExtras(bundle);
				
				setResult(RESULT_CANCELED, i);
				finish();
			}
		});
	
        final TextView txtArticle = (TextView) findViewById(R.id.singleOptTxtArticle);
        txtArticle.setText(_itemParent.TicketText);
	
        final GridView gridViewOptions = (GridView) findViewById(R.id.singleOptGridView);
	
        try {

        	gridViewOptions.setNumColumns(Parameters.ArticleColumns);
			gridViewOptions.setAdapter(new OptionsAdapter( _article,_idLine, this, _multiOptionals, _piece,_inMenu));
			
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
        
        _handler.postDelayed(_runnableDisableGrid, 500);
	}

	public void EventDataClick(ItemDataNode idItem, ImageView image)
	{
		if (_pressed)
			return;
		
		_pressed = true;
		
		
		AddOptions(idItem);
		String newDescription ="";
		double newPrice = 0;
		
		switch (_itemParent.OptionalDescType)
        {
            case 0:
            	newDescription = _itemParent.TicketText;
                break;
            case 1:
            	newDescription = _itemParent.TicketText + " / " + idItem.TicketText;
                break;
            case 2:
            	newDescription = idItem.TicketText;
                break;
        }
		
		if (idItem.Number == 0) //SOLO
		{
			newDescription = _itemParent.TicketText;
			newPrice = _itemParent.GetCurrentPrice();
		}
		else
			newPrice = idItem.GetCurrentPrice();
		
		if (_inMenu)
			newPrice= 0;
		
		Bundle bundle = new Bundle();
        
        bundle.putInt("idLine", _idLine);
        bundle.putString("newdescription", newDescription);
        bundle.putDouble("newPrice",newPrice );
        Intent i = new Intent();
        
        i.putExtras(bundle);
        setResult(RESULT_OK, i);
        finish();
	}
	
	private void AddOptions (ItemDataNode idItem)
	{
		Parameters.OptionsArticle.clear();
		
		if (idItem.Number!=0)
		{
			FreezeSalesOrderLineOption opt = new FreezeSalesOrderLineOption();
			
			opt.Article = idItem.Number;
			opt.Description = idItem.Description1;
			opt.Price = idItem.GetCurrentPrice();
			
			Parameters.OptionsArticle.add(opt);
		}
		if (_idLine >-1)
		{
			try
			{
				if (!_inMenu)
					_wcf.OptionAction(_idLine , 1, idItem.Number);
				else 
					_wcf.OptionAction(_idLine , 3, idItem.Number);
			}
			catch (Exception e) {
				
				AndroidOperations.AppendLog("SingleOptional_OptionAction:" + e.getMessage());
				
				setResult(RESULT_FIRST_USER);
				finish();
			}
		}
	}
}